//
// Copyright (c) 2013, Red Hat Inc.
// Copyright (c) 2003, 2012, Oracle and/or its affiliates.
// All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_aarch64.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "memory/allocation.inline.hpp"
#include "asm/assembler.hpp"
#include "code/compiledIC.hpp"
#include "code/vmreg.hpp"
#include "gc_interface/collectedHeap.inline.hpp"
#include "oops/compiledICHolderOop.hpp"
#include "oops/markOop.hpp"
#include "oops/methodOop.hpp"
#include "oops/oop.inline.hpp"
#include "oops/oop.inline2.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "assembler_aarch64.inline.hpp"
#include "nativeInst_aarch64.hpp"
#include "vmreg_aarch64.inline.hpp"

//SourceForm

#line 741 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"


#define __ _masm.

// advance declaratuons for helper functions to convert register
// indices to register objects

// the ad file has to provide implementations of certain methods
// expected by the generic code
//
// REQUIRED FUNCTIONALITY

//=============================================================================

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

int MachCallStaticJavaNode::ret_addr_offset()
{
  // call should be a simple bl
  // unless this is a method handle invoke in which case it is
  // mov(rfp, sp), bl, mov(sp, rfp)
  int off = 4;
  if (_method_handle_invoke) {
    off += 4;
  }
  return off;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  return 16; // movz, movk, movk, bl
}

int MachCallRuntimeNode::ret_addr_offset() {
  // for generated stubs the call will be
  //   bl(addr)
  // for real runtime callouts it iwll be
  //   mov(rscratch1, RuntimeAddress(addr)
  //   blrt rscratch1
  CodeBlob *cb = CodeCache::find_blob(_entry_point);
  if (cb) {
    return 4;
  } else {
    // A 48-bit address.  See movptr().
    return 16;
  }
}

// Indicate if the safepoint node needs the polling page as an input

// the shared code plants the oop data at the start of the generated
// code for the safepoint node and that needs ot be at the load
// instruction itself. so we cannot plant a mov of the safepoint poll
// address followed by a load. setting this to true means the mov is
// scheduled as a prior instruction. that's better for scheduling
// anyway.

bool SafePointNode::needs_polling_address_input()
{
  return true;
}

//=============================================================================

#ifndef PRODUCT
void MachBreakpointNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  st->print("BREAKPOINT");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);
  __ brk(0);
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    MacroAssembler _masm(&cbuf);
    for (int i = 0; i < _count; i++) { 
      __ nop();
    }
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count * NativeInstruction::instruction_size;
  }

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int Compile::ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_late_expand() const { return false; }
void MachConstantBaseNode::lateExpand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("-- \t// MachConstantBaseNode (empty encoding)");
}
#endif

#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;

  int framesize = C->frame_slots() << LogBytesPerInt;

  if (C->need_stack_bang(framesize))
    st->print("# stack bang size=%d\n\t", framesize);

  if (framesize == 0) {
    // Is this even possible?
    st->print("stp  lr, rfp, [sp, #%d]!", -(2 * wordSize)); 
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("sub  sp, sp, #%d\n\t", framesize);
    st->print("stp  rfp, lr, [sp, #%d]", framesize - 2 * wordSize);
  } else {
    st->print("stp  lr, rfp, [sp, #%d]!\n\t", -(2 * wordSize)); 
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("sub  sp, sp, rscratch1");
  }
}
#endif

void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);

  // n.b. frame size includes space for return pc and rfp
  long framesize = ((long)C->frame_slots()) << LogBytesPerInt;
  assert(framesize%(2*wordSize) == 0, "must preserve 2*wordSize alignment");

  // insert a nop at the start of the prolog so we can patch in a
  // branch if we need to invalidate the method later
  __ nop();

  if (C->need_stack_bang(framesize))
    __ generate_stack_overflow_check(framesize);

  __ build_frame(framesize);

  if (NotifySimulator) {
    __ notify(Assembler::method_entry);
  }

  if (VerifyStackAtCalls) {
    Unimplemented();
  }

  C->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    Compile::ConstantTable& constant_table = C->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0;
}

//=============================================================================

#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;
  int framesize = C->frame_slots() << LogBytesPerInt;

  st->print("# pop frame %d\n\t",framesize);

  if (framesize == 0) {
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("ldp  lr, rfp, [sp,#%d]\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, #%d\n\t", framesize);
  } else {
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, rscratch1\n\t");
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  }

  if (do_polling() && C->is_method_compilation()) {
    st->print("# touch polling page\n\t");
    st->print("mov  rscratch1, #0x%x\n\t", os::get_polling_page());
    st->print("ldr zr, [rscratch1]");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);
  int framesize = C->frame_slots() << LogBytesPerInt;

  __ remove_frame(framesize);

  if (NotifySimulator) {
    __ notify(Assembler::method_reentry);
  }

  if (do_polling() && C->is_method_compilation()) {
    address polling_page(os::get_polling_page());
    __ read_polling_page(rscratch1, polling_page, relocInfo::poll_return_type);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // 1 for polling page.
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

// This method seems to be obsolete. It is declared in machnode.hpp
// and defined in all *.ad files, but it is never called. Should we
// get rid of it?
int MachEpilogNode::safepoint_offset() const {
  assert(do_polling(), "no return for this epilog node");
  return 4;
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float or
// rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // we have 30 int registers * 2 halves
  // (rscratch1 and rscratch2 are omitted)

  if (reg < 60) {
    return rc_int;
  }

  // we have 32 float register * 2 halves
  if (reg < 60 + 64) {
    return rc_float;
  }

  // Between float regs & stack is the flags regs.
  assert(OptoReg::is_stack(reg), "blow up if spilling flags");

  return rc_stack;
}

uint MachSpillCopyNode::implementation(CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream *st) const {
  Compile* C = ra_->C;

  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");

  if (src_hi != OptoReg::Bad) {
    assert((src_lo&1)==0 && src_lo+1==src_hi &&
           (dst_lo&1)==0 && dst_lo+1==dst_hi,
           "expected aligned-adjacent pairs");
  }

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  switch (src_lo_rc) {
  case rc_int:
    if (dst_lo_rc == rc_int) {	// gpr --> gpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ mov(as_Register(Matcher::_regEncode[dst_lo]),
                 as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("mov  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ movw(as_Register(Matcher::_regEncode[dst_lo]),
                  as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("movw  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else if (dst_lo_rc == rc_float) { // gpr --> fpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovd  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovs  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else {			// gpr --> stack spill
      assert(dst_lo_rc == rc_stack, "spill to bad register class");
      int dst_offset = ra_->reg2offset(dst_lo);
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ str(as_Register(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("str  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ strw(as_Register(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("strw  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      }
    }
    return 4;
  case rc_float:
    if (dst_lo_rc == rc_int) {	// fpr --> gpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovd(as_Register(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovd  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovs(as_Register(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovs  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else if (dst_lo_rc == rc_float) { // fpr --> fpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovd  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovs  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else {			// fpr --> stack spill
      assert(dst_lo_rc == rc_stack, "spill to bad register class");
      int dst_offset = ra_->reg2offset(dst_lo);
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ strd(as_FloatRegister(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("strd  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ strs(as_FloatRegister(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("strs  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      }
    }
    return 4;
  case rc_stack:
    int src_offset = ra_->reg2offset(src_lo);
    if (dst_lo_rc == rc_int) {	// stack --> gpr load
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldr(as_Register(Matcher::_regEncode[dst_lo]),
                 Address(sp, src_offset));
        } else if (st) {
          st->print("ldr  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
		    src_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrw(as_Register(Matcher::_regEncode[dst_lo]),
                  Address(sp, src_offset));
        } else if (st) {
          st->print("ldr  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
                   src_offset);
        }
      }
      return 4;
    } else if (dst_lo_rc == rc_float) { // stack --> fpr load
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                 Address(sp, src_offset));
        } else if (st) {
          st->print("ldrd  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
		    src_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                  Address(sp, src_offset));
        } else if (st) {
          st->print("ldrs  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
                   src_offset);
        }
      }
      return 4;
    } else {			// stack --> stack copy
      assert(dst_lo_rc == rc_stack, "spill to bad register class");
      int dst_offset = ra_->reg2offset(dst_lo);
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldr(rscratch1, Address(sp, src_offset));
          __ str(rscratch1, Address(sp, dst_offset));
        } else if (st) {
          st->print("ldr  rscratch1, [sp, %d]\t# mem-mem spill",
		    src_offset);
          st->print("\n\t");
          st->print("str  rscratch1, [sp, %d]",
		    dst_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrw(rscratch1, Address(sp, src_offset));
          __ strw(rscratch1, Address(sp, dst_offset));
        } else if (st) {
          st->print("ldrw  rscratch1, [sp, %d]\t# mem-mem spill",
		    src_offset);
          st->print("\n\t");
          st->print("strw  rscratch1, [sp, %d]",
		    dst_offset);
        }
      }
      return 8;
    }
  }

  assert(false," bad rc_class for spill ");
  Unimplemented();
  return 0;

}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  if (!ra_)
    st->print("N%d = SpillCopy(N%d)", _idx, in(1)->_idx);
  else
    implementation(NULL, ra_, false, st);
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation(&cbuf, ra_, false, NULL);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return implementation(NULL, ra_, true, NULL);
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("add %s, rsp, #%d]\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);

  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg    = ra_->get_encode(this);

  if (Assembler::operand_valid_for_add_sub_immediate(offset)) {
    __ add(as_Register(reg), sp, offset);
  } else {
    ShouldNotReachHere();
  }
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_).
  return 4;
}

uint size_java_to_interp()
{
  // ob jdk7 we only need a mov oop and a branch
  return 2 * NativeInstruction::instruction_size;
}

// Offset from start of compiled java to interpreter stub to the load
// constant that loads the inline cache (IC) (0 on aarch64).
const int CompiledStaticCall::comp_to_int_load_offset = 0;

// emit call stub, compiled java to interpreter
 void emit_java_to_interp(CodeBuffer& cbuf, address mark)
{
  // Stub is fixed up when the corresponding call is converted from
  // calling compiled code to calling interpreted code.
  // movq rmethod, zr
  // here:
  // b(here) # jmp to self

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a stub.
  MacroAssembler _masm(&cbuf);

  address base = __ start_a_stub(Compile::MAX_stubs_size);

  int offset = __ offset();
  if (base == NULL)  return;  // CodeBuffer::expand failed
  // static stub relocation stores the instruction address of the call
  const RelocationHolder &rspec = static_stub_Relocation::spec(mark);
  __ relocate(rspec);
  // static stub relocation also tags the methodOop in the code-stream.
  //
  // n.b. for jdk7 we have to use movoop and locate the oop in the
  // cpool if we use an immediate then patching fails to update the
  // pool oop and GC overwrites the patch with movk/z 0x0000 again
  __ movoop(rmethod, (jobject) NULL);
  // This is recognized as unresolved by relocs/nativeinst/ic code
  __ b(__ pc());

  assert((__ offset() - offset) <= (int)size_java_to_interp(), "stub too big");
  // Update current stubs pointer and restore insts_end.
  __ end_a_stub();
}

// relocation entries for call stub, compiled java to interpretor
uint reloc_java_to_interp()
{
  // n.b. on jdk7 we use a movoop and a branch
  return 2;
}

//=============================================================================

#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  st->print_cr("# MachUEPNode");
  if (UseCompressedOops) {
    st->print_cr("\tldrw rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    if (Universe::narrow_oop_shift() != 0) {
      st->print_cr("\tdecode_heap_oop_not_null rscratch1, rscratch1");
    }
  } else {
   st->print_cr("\tldr rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
  }
  st->print_cr("\tcmp r0, rscratch1\t # Inline cache check");
  st->print_cr("\tbne, SharedRuntime::_ic_miss_stub");
}
#endif

void MachUEPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const
{
  // This is the unverified entry point.
  MacroAssembler _masm(&cbuf);

  // no need to worry about 4-byte of br alignment on AArch64
  __ cmp_klass(j_rarg0, rscratch2, rscratch1);
  Label skip;
  // TODO
  // can we avoid this skip and still use a reloc?
  __ br(Assembler::EQ, skip);
  __ b(RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  __ bind(skip);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_);
}

// REQUIRED EMIT CODE

//=============================================================================

uint size_exception_handler()
{
  // count up to 4 movz/n/k instructions and one branch instruction
  return 5 * NativeInstruction::instruction_size;
}

// Emit exception handler code.
int emit_exception_handler(CodeBuffer& cbuf)
{
  // mov rscratch1 #exception_blob_entry_point
  // br rscratch1
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_exception_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();
  __ b(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

uint size_deopt_handler()
{
  // count one adr and one branch instruction
  return 2 * NativeInstruction::instruction_size;
}

// Emit deopt handler code.
int emit_deopt_handler(CodeBuffer& cbuf)
{
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_deopt_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();

  __ adr(lr, __ pc());
  // should we load this into rscratch1 and use a br?
  __ b(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));

  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// REQUIRED MATCHER CODE

//=============================================================================

// !!! FIXME AARCH64 -- should we reg types Op_Vec? for vectors
// or specify NotAMachineReg?? we don't use vectors so we robably don't
// need them but do they do any harm?

// Map Types to machine register types
const int Matcher::base2reg[Type::lastype] = {
  Node::NotAMachineReg,0,0, Op_RegI, Op_RegL, 0, Op_RegN,
  Node::NotAMachineReg, Node::NotAMachineReg, /* tuple, array */
  Op_VecS, Op_VecD, Op_VecX, Op_VecY, /* Vectors */
  Op_RegP, Op_RegP, Op_RegP, Op_RegP, Op_RegP, Op_RegP, /* the pointers */
  0, 0/*abio*/,
  Op_RegP /* Return address */, 0, /* the memories */
  Op_RegF, Op_RegF, Op_RegF, Op_RegD, Op_RegD, Op_RegD,
  0  /*bottom*/
};

const bool Matcher::match_rule_supported(int opcode) {

  // TODO 
  // identify extra cases that we might want to provide match rules for
  // e.g. Op_StrEquals and other intrinsics
  if (!has_match_rule(opcode)) {
    return false;
  }

  return true;  // Per default match rules are supported.
}

int Matcher::regnum_to_fpu_offset(int regnum)
{
  Unimplemented();
  return 0;
}

bool Matcher::is_short_branch_offset(int rule, int br_size, int offset)
{
  Unimplemented();
  return false;
}

const bool Matcher::isSimpleConstant64(jlong value) {
  // Will one (StoreL ConL) be cheaper than two (StoreI ConI)?.
  // Probably always true, even if a temp register is required.
  return true;
}

// true just means we have fast l2f conversion
const bool Matcher::convL2FSupported(void) {
  return true;
}

// Vector width in bytes.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  // TODO fixme
  return 0;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}
const int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Min size which can be loaded into vector is 4 bytes.
  int size = (type2aelembytes(bt) == 1) ? 4 : 2;
  return MIN2(size,max_size);
}

// Vector ideal reg.
const int Matcher::vector_ideal_reg(int len) {
  // TODO fixme
  return Op_RegD;
}

// Only lowest bits of xmm reg are used for vector shift count.
const int Matcher::vector_shift_count_ideal_reg(int size) {
  // TODO fixme
  return Op_RegL;
}

// x86 supports misaligned vectors store/load.
const bool Matcher::misaligned_vectors_ok() {
  // TODO fixme
  // return !AlignVector; // can be changed by flag
  return false;
}

// false => size gets scaled to BytesPerLong, ok.
const bool Matcher::init_array_count_is_in_bytes = false;

// Threshold size for cleararray.
const int Matcher::init_array_short_size = 18 * BytesPerLong;

// Use conditional move (CMOVL)
const int Matcher::long_cmove_cost() {
  // long cmoves are no more expensive than int cmoves
  return 0;
}

const int Matcher::float_cmove_cost() {
  // float cmoves are no more expensive than int cmoves
  return 0;
}

// Does the CPU require late expand (see block.cpp for description of late expand)?
const bool Matcher::require_late_expand = false;

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?  True for Intel but false for most RISCs
const bool Matcher::clone_shift_expressions = false;

// Do we need to mask the count passed to shift instructions or does
// the cpu only look at the lower 5/6 bits anyway?
const bool Matcher::need_masked_shift_count = false;

// This affects two different things:
//  - how Decode nodes are matched
//  - how ImplicitNullCheck opportunities are recognized
// If true, the matcher will try to remove all Decodes and match them
// (as operands) into nodes. NullChecks are not prepared to deal with 
// Decodes by final_graph_reshaping().
// If false, final_graph_reshaping() forces the decode behind the Cmp
// for a NullCheck. The matcher matches the Decode node into a register.
// Implicit_null_check optimization moves the Decode along with the 
// memory operation back up before the NullCheck.
bool Matcher::narrow_oop_use_complex_address() {
  assert(UseCompressedOops, "only for compressed oops code");
  return Universe::narrow_oop_shift() == 0;
}

// Is it better to copy float constants, or load them directly from
// memory?  Intel can load a float constant from a direct address,
// requiring no extra registers.  Most RISCs will have to materialize
// an address into a register first, so they would do better to copy
// the constant from stack.
const bool Matcher::rematerialize_float_constants = false;

// If CPU can load and store mis-aligned doubles directly then no
// fixup is needed.  Else we split the double into 2 integer pieces
// and move it piece-by-piece.  Only happens when passing doubles into
// C code as the Java calling convention forces doubles to be aligned.
const bool Matcher::misaligned_doubles_ok = true;

// No-op on amd64
void Matcher::pd_implicit_null_fixup(MachNode *node, uint idx) {
  Unimplemented();
}

// Advertise here if the CPU requires explicit rounding operations to
// implement the UseStrictFP mode.
const bool Matcher::strict_fp_requires_explicit_rounding = false;

// Are floats converted to double when stored to stack during
// deoptimization?
bool Matcher::float_in_double() { return true; }

// Do ints take an entire long register or just half?
// The relevant question is how the int is callee-saved:
// the whole long is written but de-opt'ing will have to extract
// the relevant 32 bits.
const bool Matcher::int_in_long = true;

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  R0_num || reg == R0_H_num ||
    reg ==  R1_num || reg == R1_H_num ||
    reg ==  R2_num || reg == R2_H_num ||
    reg ==  R3_num || reg == R3_H_num ||
    reg ==  R4_num || reg == R4_H_num ||
    reg ==  R5_num || reg == R5_H_num ||
    reg ==  R6_num || reg == R6_H_num ||
    reg ==  R7_num || reg == R7_H_num ||
    reg ==  V0_num || reg == V0_H_num ||
    reg ==  V1_num || reg == V1_H_num ||
    reg ==  V2_num || reg == V2_H_num ||
    reg ==  V3_num || reg == V3_H_num ||
    reg ==  V4_num || reg == V4_H_num ||
    reg ==  V5_num || reg == V5_H_num ||
    reg ==  V6_num || reg == V6_H_num ||
    reg ==  V7_num || reg == V7_H_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI.
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL.
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL.
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

// helper for encoding java_to_runtime calls on sim
//
// this is needed to compute the extra arguments required when
// planting a call to the simulator blrt instruction. the TypeFunc
// can be queried to identify the counts for integral, and floating
// arguments and the return type

static void getCallInfo(const TypeFunc *tf, int &gpcnt, int &fpcnt, int &rtype)
{
  int gps = 0;
  int fps = 0;
  const TypeTuple *domain = tf->domain();
  int max = domain->cnt();
  for (int i = TypeFunc::Parms; i < max; i++) {
    const Type *t = domain->field_at(i);
    switch(t->basic_type()) {
    case T_FLOAT:
    case T_DOUBLE:
      fps++;
    default:
      gps++;
    }
  }
  gpcnt = gps;
  fpcnt = fps;
  BasicType rt = tf->return_type();
  switch (rt) {
  case T_VOID:
    rtype = MacroAssembler::ret_type_void;
    break;
  default:
    rtype = MacroAssembler::ret_type_integral;
    break;
  case T_FLOAT:
    rtype = MacroAssembler::ret_type_float;
    break;
  case T_DOUBLE:
    rtype = MacroAssembler::ret_type_double;
    break;
  }
}

#define MOV_VOLATILE(REG, BASE, INDEX, SCALE, DISP, SCRATCH, INSN)	\
  MacroAssembler _masm(&cbuf);						\
  {									\
    Register base = as_Register(BASE);					\
    if (INDEX == -1) {							\
	__ lea(SCRATCH, Address(base, DISP));				\
    } else {								\
	Register index_reg = as_Register(INDEX);			\
	if (DISP == 0) {						\
	  __ lea(SCRATCH, Address(base, index_reg, Address::lsl(SCALE))); \
	} else {							\
	  __ lea(SCRATCH, Address(base, DISP));				\
	  __ lea(SCRATCH, Address(SCRATCH, index_reg, Address::lsl(SCALE))); \
	}								\
    }									\
    __ INSN(REG, SCRATCH);						\
  }

typedef void (MacroAssembler::* mem_insn)(Register Rt, const Address &adr);
typedef void (MacroAssembler::* mem_float_insn)(FloatRegister Rt, const Address &adr);

  // Used for all non-volatile memory accesses.  The use of
  // $mem->opcode() to discover whether this pattern uses sign-extended
  // offsets is something of a kludge.
  static void loadStore(MacroAssembler masm, mem_insn insn,
			 Register reg, int opcode,
			 Register base, int index, int size, int disp)
  {
    Address::extend scale;

    // Hooboy, this is fugly.  We need a way to communicate to the
    // encoder that the index needs to be sign extended, so we have to
    // enumerate all the cases.
    switch (opcode) {
    case INDINDEXSCALEDOFFSETI2L:
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDOFFSETI2LN:
    case INDINDEXSCALEDI2LN:
    case INDINDEXOFFSETI2L:
    case INDINDEXOFFSETI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      (masm.*insn)(reg, Address(base, disp));
    } else {
      if (disp == 0) {
	(masm.*insn)(reg, Address(base, as_Register(index), scale));
      } else {
	masm.lea(rscratch1, Address(base, disp));
	(masm.*insn)(reg, Address(rscratch1, as_Register(index), scale));
      }
    }
  }

  static void loadStore(MacroAssembler masm, mem_float_insn insn,
			 FloatRegister reg, int opcode,
			 Register base, int index, int size, int disp)
  {
    Address::extend scale;

    switch (opcode) {
    case INDINDEXSCALEDOFFSETI2L:
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDOFFSETI2LN:
    case INDINDEXSCALEDI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

     if (index == -1) {
      (masm.*insn)(reg, Address(base, disp));
    } else {
      if (disp == 0) {
	(masm.*insn)(reg, Address(base, as_Register(index), scale));
      } else {
	masm.lea(rscratch1, Address(base, disp));
	(masm.*insn)(reg, Address(rscratch1, as_Register(index), scale));
      }
    }
  }


#line 1183 "../generated/adfiles/ad_aarch64.cpp"


//SourceForm

#line 66 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/os_cpu/linux_aarch64/vm/linux_aarch64.ad"



#line 1192 "../generated/adfiles/ad_aarch64.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( INSN_COST == 100, "Expect (100) to equal 100");
  assert( BRANCH_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( CALL_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( VOLATILE_REF_COST == 1000, "Expect (10 * INSN_COST) to equal 1000");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'N', // R27
  'N', // R27_H
  'N', // R28
  'N', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // V16
  'C', // V16_H
  'C', // V17
  'C', // V17_H
  'C', // V18
  'C', // V18_H
  'C', // V19
  'C', // V19_H
  'C', // V20
  'C', // V20_H
  'C', // V21
  'C', // V21_H
  'C', // V22
  'C', // V22_H
  'C', // V23
  'C', // V23_H
  'C', // V24
  'C', // V24_H
  'C', // V25
  'C', // V25_H
  'C', // V26
  'C', // V26_H
  'C', // V27
  'C', // V27_H
  'C', // V28
  'C', // V28_H
  'C', // V29
  'C', // V29_H
  'C', // V30
  'C', // V30_H
  'C', // V31
  'C', // V31_H
  'C', // V0
  'C', // V0_H
  'C', // V1
  'C', // V1_H
  'C', // V2
  'C', // V2_H
  'C', // V3
  'C', // V3_H
  'C', // V4
  'C', // V4_H
  'C', // V5
  'C', // V5_H
  'C', // V6
  'C', // V6_H
  'C', // V7
  'C', // V7_H
  'C', // V8
  'C', // V8_H
  'C', // V9
  'C', // V9_H
  'C', // V10
  'C', // V10_H
  'C', // V11
  'C', // V11_H
  'C', // V12
  'C', // V12_H
  'C', // V13
  'C', // V13_H
  'C', // V14
  'C', // V14_H
  'C', // V15
  'C', // V15_H
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'E', // R19
  'E', // R19_H
  'E', // R20
  'E', // R20_H
  'E', // R21
  'E', // R21_H
  'E', // R22
  'E', // R22_H
  'E', // R23
  'E', // R23_H
  'E', // R24
  'E', // R24_H
  'E', // R25
  'E', // R25_H
  'E', // R26
  'E', // R26_H
  'E', // R27
  'E', // R27_H
  'E', // R28
  'E', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // V16
  'C', // V16_H
  'C', // V17
  'C', // V17_H
  'C', // V18
  'C', // V18_H
  'C', // V19
  'C', // V19_H
  'C', // V20
  'C', // V20_H
  'C', // V21
  'C', // V21_H
  'C', // V22
  'C', // V22_H
  'C', // V23
  'C', // V23_H
  'C', // V24
  'C', // V24_H
  'C', // V25
  'C', // V25_H
  'C', // V26
  'C', // V26_H
  'C', // V27
  'C', // V27_H
  'C', // V28
  'C', // V28_H
  'C', // V29
  'C', // V29_H
  'C', // V30
  'C', // V30_H
  'C', // V31
  'C', // V31_H
  'C', // V0
  'C', // V0_H
  'C', // V1
  'C', // V1_H
  'C', // V2
  'C', // V2_H
  'C', // V3
  'C', // V3_H
  'C', // V4
  'C', // V4_H
  'C', // V5
  'C', // V5_H
  'C', // V6
  'C', // V6_H
  'C', // V7
  'C', // V7_H
  'E', // V8
  'E', // V8_H
  'E', // V9
  'E', // V9_H
  'E', // V10
  'E', // V10_H
  'E', // V11
  'E', // V11_H
  'E', // V12
  'E', // V12_H
  'E', // V13
  'E', // V13_H
  'E', // V14
  'E', // V14_H
  'E', // V15
  'E', // V15_H
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immI_le_4_rule,
  /*   13 */  immI_31_rule,
  /*   14 */  immI_8_rule,
  /*   15 */  immI_16_rule,
  /*   16 */  immI_24_rule,
  /*   17 */  immI_32_rule,
  /*   18 */  immI_48_rule,
  /*   19 */  immI_56_rule,
  /*   20 */  immI_64_rule,
  /*   21 */  immI_255_rule,
  /*   22 */  immI_65535_rule,
  /*   23 */  immL_63_rule,
  /*   24 */  immL_255_rule,
  /*   25 */  immL_65535_rule,
  /*   26 */  immL_4294967295_rule,
  /*   27 */  immL_bitmask_rule,
  /*   28 */  immI_bitmask_rule,
  /*   29 */  immIScale_rule,
  /*   30 */  immI26_rule,
  /*   31 */  immI19_rule,
  /*   32 */  immIU12_rule,
  /*   33 */  immLU12_rule,
  /*   34 */  immIOffset_rule,
  /*   35 */  immLoffset_rule,
  /*   36 */  immIAddSub_rule,
  /*   37 */  immILog_rule,
  /*   38 */  immL_rule,
  /*   39 */  immL0_rule,
  /*   40 */  immL_1_rule,
  /*   41 */  immL_M1_rule,
  /*   42 */  immL_pc_off_rule,
  /*   43 */  immLAddSub_rule,
  /*   44 */  immLLog_rule,
  /*   45 */  immL_32bits_rule,
  /*   46 */  immP_rule,
  /*   47 */  immP0_rule,
  /*   48 */  immP_1_rule,
  /*   49 */  immPollPage_rule,
  /*   50 */  immByteMapBase_rule,
  /*   51 */  immP_M1_rule,
  /*   52 */  immP_M2_rule,
  /*   53 */  immD_rule,
  /*   54 */  immD0_rule,
  /*   55 */  immDPacked_rule,
  /*   56 */  immF_rule,
  /*   57 */  immF0_rule,
  /*   58 */  immFPacked_rule,
  /*   59 */  immN_rule,
  /*   60 */  immN0_rule,
  /*   61 */  iRegI_rule,
  /*   62 */  iRegINoSp_rule,
  /*   63 */  iRegL_rule,
  /*   64 */  iRegLNoSp_rule,
  /*   65 */  iRegP_rule,
  /*   66 */  iRegPNoSp_rule,
  /*   67 */  iRegP_R0_rule,
  /*   68 */  iRegP_R1_rule,
  /*   69 */  iRegP_R2_rule,
  /*   70 */  iRegP_R3_rule,
  /*   71 */  iRegP_R4_rule,
  /*   72 */  iRegP_R5_rule,
  /*   73 */  iRegP_R10_rule,
  /*   74 */  iRegL_R11_rule,
  /*   75 */  iRegP_FP_rule,
  /*   76 */  iRegI_R0_rule,
  /*   77 */  iRegI_R2_rule,
  /*   78 */  iRegI_R4_rule,
  /*   79 */  iRegN_rule,
  /*   80 */  iRegNNoSp_rule,
  /*   81 */  iRegIHeapbase_rule,
  /*   82 */  vRegF_rule,
  /*   83 */  vRegD_rule,
  /*   84 */  rFlagsReg_rule,
  /*   85 */  rFlagsRegU_rule,
  /*   86 */  inline_cache_RegP_rule,
  /*   87 */  interpreter_method_oop_RegP_rule,
  /*   88 */  thread_RegP_rule,
  /*   89 */  lr_RegP_rule,
  /*   90 */  indirect_rule,
  /*   91 */  indIndexScaledOffsetI_rule,
  /*   92 */  indIndexScaledOffsetL_rule,
  /*   93 */  indIndexOffsetI2L_rule,
  /*   94 */  indIndexScaledOffsetI2L_rule,
  /*   95 */  indIndexScaledI2L_rule,
  /*   96 */  indIndexScaled_rule,
  /*   97 */  indIndex_rule,
  /*   98 */  indOffI_rule,
  /*   99 */  indOffL_rule,
  /*  100 */  indirectN_rule,
  /*  101 */  indIndexScaledOffsetIN_rule,
  /*  102 */  indIndexScaledOffsetLN_rule,
  /*  103 */  indIndexOffsetI2LN_rule,
  /*  104 */  indIndexScaledOffsetI2LN_rule,
  /*  105 */  indIndexScaledI2LN_rule,
  /*  106 */  indIndexScaledN_rule,
  /*  107 */  indIndexN_rule,
  /*  108 */  indOffIN_rule,
  /*  109 */  indOffLN_rule,
  /*  110 */  thread_anchor_pc_rule,
  /*  111 */  stackSlotP_rule,
  /*  112 */  stackSlotI_rule,
  /*  113 */  stackSlotF_rule,
  /*  114 */  stackSlotD_rule,
  /*  115 */  stackSlotL_rule,
  /*  116 */  cmpOp_rule,
  /*  117 */  cmpOpU_rule,
  /*  118 */  iRegL2I_rule,
  // last operand
  /*  119 */  memory_rule,
  /*  120 */  iRegIorL2I_rule,
  // last operand class
  /*  121 */  _LShiftL_iRegL_immIScale_rule,
  /*  122 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*  123 */  _ConvI2L_iRegI__rule,
  /*  124 */  _AddP_iRegP__ConvI2L_iRegI__rule,
  /*  125 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  126 */  _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  127 */  _DecodeN_iRegN__rule,
  /*  128 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  129 */  _AddP__DecodeN_iRegN___ConvI2L_iRegI__rule,
  /*  130 */  _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  131 */  _LoadB_memory__rule,
  /*  132 */  _LoadUB_memory__rule,
  /*  133 */  _LoadS_memory__rule,
  /*  134 */  _LoadUS_memory__rule,
  /*  135 */  _LoadI_memory__rule,
  /*  136 */  _ConvI2L__LoadI_memory___rule,
  /*  137 */  _CastP2X_iRegP__rule,
  /*  138 */  _CastP2X__DecodeN_iRegN___rule,
  /*  139 */  _Binary_iRegP_iRegP_rule,
  /*  140 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  141 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  142 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  143 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  144 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  145 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  146 */  _Binary_immI0_iRegIorL2I_rule,
  /*  147 */  _Binary_iRegIorL2I_immI0_rule,
  /*  148 */  _Binary_immI_1_immI0_rule,
  /*  149 */  _Binary_iRegL_iRegL_rule,
  /*  150 */  _Binary_iRegL_immL0_rule,
  /*  151 */  _Binary_immL0_iRegL_rule,
  /*  152 */  _Binary_iRegP_immP0_rule,
  /*  153 */  _Binary_immP0_iRegP_rule,
  /*  154 */  _Binary_iRegN_iRegN_rule,
  /*  155 */  _Binary_iRegN_immN0_rule,
  /*  156 */  _Binary_immN0_iRegN_rule,
  /*  157 */  _Binary_vRegF_vRegF_rule,
  /*  158 */  _Binary_vRegD_vRegD_rule,
  /*  159 */  _ConvL2I_iRegL__rule,
  /*  160 */  _ConvI2L_iRegIorL2I__rule,
  /*  161 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  162 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  163 */  _MulL_iRegL_iRegL_rule,
  /*  164 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  165 */  _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule,
  /*  166 */  _RShiftL_iRegL_immL_63_rule,
  /*  167 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  168 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  169 */  _XorL_iRegL_immL_M1_rule,
  /*  170 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  171 */  _XorL_iRegL_iRegL_rule,
  /*  172 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  173 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  174 */  _URShiftL_iRegL_immI_rule,
  /*  175 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  176 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  177 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  178 */  _RShiftL_iRegL_immI_rule,
  /*  179 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  180 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  181 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  182 */  _LShiftL_iRegL_immI_rule,
  /*  183 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  184 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  185 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  186 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  187 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  188 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  189 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  190 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  191 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  192 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  193 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  194 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  195 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  196 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  197 */  _LShiftL_iRegL_iRegI_rule,
  /*  198 */  _SubI_immI_64_iRegI_rule,
  /*  199 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  200 */  _SubI_immI0_iRegI_rule,
  /*  201 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  202 */  _LShiftI_iRegL_iRegI_rule,
  /*  203 */  _SubI_immI_32_iRegI_rule,
  /*  204 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  205 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  206 */  _URShiftL_iRegL_iRegI_rule,
  /*  207 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  208 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  209 */  _URShiftI_iRegL_iRegI_rule,
  /*  210 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  211 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  212 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  213 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  214 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  215 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  216 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  217 */  _LShiftL_iRegL_immI_48_rule,
  /*  218 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  219 */  _LShiftL_iRegL_immI_32_rule,
  /*  220 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  221 */  _LShiftL_iRegL_immI_56_rule,
  /*  222 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  223 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  224 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  225 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  226 */  _AndL_iRegL_immL_255_rule,
  /*  227 */  _AndL_iRegL_immL_65535_rule,
  /*  228 */  _AndL_iRegL_immL_4294967295_rule,
  /*  229 */  _ConvF2D_vRegF__rule,
  /*  230 */  _SqrtD__ConvF2D_vRegF___rule,
  /*  231 */  _CmpI_iRegIorL2I_immI0_rule,
  /*  232 */  _CmpL_iRegL_immL0_rule,
  /*  233 */  _CmpP_iRegP_immP0_rule,
  /*  234 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  235 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  236 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  237 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  238 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  239 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  240 */  _Binary_iRegP_R1_iRegP_R3_rule,
  // last internally defined operand
  /*  241 */  iRegINoSp_rule,
  /*  242 */  iRegLNoSp_rule,
  /*  243 */  iRegPNoSp_rule,
  /*  244 */  iRegPNoSp_rule,
  /*  245 */  iRegPNoSp_rule,
  /*  246 */  iRegPNoSp_rule,
  /*  247 */  iRegPNoSp_rule,
  /*  248 */  iRegNNoSp_rule,
  /*  249 */  iRegNNoSp_rule,
  /*  250 */  vRegF_rule,
  /*  251 */  vRegF_rule,
  /*  252 */  vRegD_rule,
  /*  253 */  vRegD_rule,
  /*  254 */  iRegINoSp_rule,
  /*  255 */  iRegINoSp_rule,
  /*  256 */  iRegINoSp_rule,
  /*  257 */  iRegINoSp_rule,
  /*  258 */  iRegPNoSp_rule,
  /*  259 */  iRegLNoSp_rule,
  /*  260 */  iRegPNoSp_rule,
  /*  261 */  iRegPNoSp_rule,
  /*  262 */  iRegI_rule,
  /*  263 */  rFlagsReg_rule,
  /*  264 */  rFlagsReg_rule,
  /*  265 */  rFlagsReg_rule,
  /*  266 */  vRegF_rule,
  /*  267 */  vRegD_rule,
  /*  268 */  vRegF_rule,
  /*  269 */  vRegD_rule,
  /*  270 */  iRegINoSp_rule,
  /*  271 */  vRegF_rule,
  /*  272 */  iRegLNoSp_rule,
  /*  273 */  vRegD_rule,
  /*  274 */  iRegINoSp_rule,
  /*  275 */  vRegF_rule,
  /*  276 */  iRegLNoSp_rule,
  /*  277 */  vRegD_rule,
  /*  278 */  rFlagsReg_rule,
  /*  279 */  rFlagsReg_rule,
  /*  280 */  rFlagsReg_rule,
  /*  281 */  rFlagsReg_rule,
  /*  282 */  rFlagsRegU_rule,
  /*  283 */  rFlagsRegU_rule,
  /*  284 */  rFlagsRegU_rule,
  /*  285 */  rFlagsRegU_rule,
  /*  286 */  rFlagsReg_rule,
  /*  287 */  rFlagsReg_rule,
  /*  288 */  rFlagsReg_rule,
  /*  289 */  rFlagsReg_rule,
  /*  290 */  rFlagsRegU_rule,
  /*  291 */  rFlagsRegU_rule,
  /*  292 */  rFlagsRegU_rule,
  /*  293 */  rFlagsRegU_rule,
  /*  294 */  rFlagsReg_rule,
  /*  295 */  rFlagsReg_rule,
  /*  296 */  rFlagsReg_rule,
  /*  297 */  rFlagsReg_rule,
  /*  298 */  rFlagsReg_rule,
  /*  299 */  rFlagsReg_rule,
  /*  300 */  rFlagsReg_rule,
  /*  301 */  thread_RegP_rule,
  /*  302 */  iRegINoSp_rule,
  /*  303 */  iRegLNoSp_rule,
  /*  304 */  iRegINoSp_rule,
  /*  305 */  iRegLNoSp_rule,
  /*  306 */  iRegINoSp_rule,
  /*  307 */  iRegLNoSp_rule,
  /*  308 */  iRegINoSp_rule,
  /*  309 */  iRegLNoSp_rule,
  /*  310 */  iRegINoSp_rule,
  /*  311 */  iRegLNoSp_rule,
  /*  312 */  iRegLNoSp_rule,
  /*  313 */  iRegLNoSp_rule,
  /*  314 */  iRegINoSp_rule,
  /*  315 */  iRegPNoSp_rule,
  /*  316 */  iRegNNoSp_rule,
  /*  317 */  iRegPNoSp_rule,
  /*  318 */  iRegNNoSp_rule,
  /*  319 */  vRegF_rule,
  /*  320 */  vRegD_rule,
  /*  321 */  Universe_rule,
  /*  322 */  Universe_rule,
  /*  323 */  Universe_rule,
  /*  324 */  Universe_rule,
  /*  325 */  Universe_rule,
  /*  326 */  Universe_rule,
  /*  327 */  Universe_rule,
  /*  328 */  Universe_rule,
  /*  329 */  Universe_rule,
  /*  330 */  Universe_rule,
  /*  331 */  Universe_rule,
  /*  332 */  Universe_rule,
  /*  333 */  Universe_rule,
  /*  334 */  Universe_rule,
  /*  335 */  Universe_rule,
  /*  336 */  Universe_rule,
  /*  337 */  Universe_rule,
  /*  338 */  Universe_rule,
  /*  339 */  Universe_rule,
  /*  340 */  Universe_rule,
  /*  341 */  iRegINoSp_rule,
  /*  342 */  iRegLNoSp_rule,
  /*  343 */  iRegINoSp_rule,
  /*  344 */  iRegINoSp_rule,
  /*  345 */  Universe_rule,
  /*  346 */  Universe_rule,
  /*  347 */  Universe_rule,
  /*  348 */  Universe_rule,
  /*  349 */  Universe_rule,
  /*  350 */  Universe_rule,
  /*  351 */  Universe_rule,
  /*  352 */  iRegINoSp_rule,
  /*  353 */  iRegINoSp_rule,
  /*  354 */  iRegNNoSp_rule,
  /*  355 */  iRegNNoSp_rule,
  /*  356 */  iRegPNoSp_rule,
  /*  357 */  iRegPNoSp_rule,
  /*  358 */  iRegPNoSp_rule,
  /*  359 */  iRegINoSp_rule,
  /*  360 */  iRegINoSp_rule,
  /*  361 */  iRegINoSp_rule,
  /*  362 */  iRegINoSp_rule,
  /*  363 */  iRegI_rule,
  /*  364 */  iRegL_rule,
  /*  365 */  iRegI_rule,
  /*  366 */  iRegP_rule,
  /*  367 */  iRegLNoSp_rule,
  /*  368 */  Universe_rule,
  /*  369 */  iRegLNoSp_rule,
  /*  370 */  Universe_rule,
  /*  371 */  iRegINoSp_rule,
  /*  372 */  Universe_rule,
  /*  373 */  iRegINoSp_rule,
  /*  374 */  Universe_rule,
  /*  375 */  iRegINoSp_rule,
  /*  376 */  iRegINoSp_rule,
  /*  377 */  iRegINoSp_rule,
  /*  378 */  iRegINoSp_rule,
  /*  379 */  iRegINoSp_rule,
  /*  380 */  iRegINoSp_rule,
  /*  381 */  iRegINoSp_rule,
  /*  382 */  iRegINoSp_rule,
  /*  383 */  iRegLNoSp_rule,
  /*  384 */  iRegLNoSp_rule,
  /*  385 */  iRegLNoSp_rule,
  /*  386 */  iRegLNoSp_rule,
  /*  387 */  iRegLNoSp_rule,
  /*  388 */  iRegLNoSp_rule,
  /*  389 */  iRegPNoSp_rule,
  /*  390 */  iRegPNoSp_rule,
  /*  391 */  iRegPNoSp_rule,
  /*  392 */  iRegPNoSp_rule,
  /*  393 */  iRegPNoSp_rule,
  /*  394 */  iRegPNoSp_rule,
  /*  395 */  iRegNNoSp_rule,
  /*  396 */  iRegNNoSp_rule,
  /*  397 */  iRegNNoSp_rule,
  /*  398 */  iRegNNoSp_rule,
  /*  399 */  iRegNNoSp_rule,
  /*  400 */  iRegNNoSp_rule,
  /*  401 */  vRegF_rule,
  /*  402 */  vRegF_rule,
  /*  403 */  vRegD_rule,
  /*  404 */  vRegD_rule,
  /*  405 */  iRegINoSp_rule,
  /*  406 */  iRegINoSp_rule,
  /*  407 */  iRegINoSp_rule,
  /*  408 */  iRegPNoSp_rule,
  /*  409 */  iRegPNoSp_rule,
  /*  410 */  iRegPNoSp_rule,
  /*  411 */  iRegPNoSp_rule,
  /*  412 */  iRegLNoSp_rule,
  /*  413 */  iRegPNoSp_rule,
  /*  414 */  iRegLNoSp_rule,
  /*  415 */  iRegLNoSp_rule,
  /*  416 */  iRegINoSp_rule,
  /*  417 */  iRegINoSp_rule,
  /*  418 */  iRegLNoSp_rule,
  /*  419 */  iRegLNoSp_rule,
  /*  420 */  iRegINoSp_rule,
  /*  421 */  iRegLNoSp_rule,
  /*  422 */  iRegINoSp_rule,
  /*  423 */  iRegLNoSp_rule,
  /*  424 */  iRegLNoSp_rule,
  /*  425 */  iRegLNoSp_rule,
  /*  426 */  iRegLNoSp_rule,
  /*  427 */  iRegINoSp_rule,
  /*  428 */  iRegINoSp_rule,
  /*  429 */  iRegINoSp_rule,
  /*  430 */  iRegLNoSp_rule,
  /*  431 */  iRegLNoSp_rule,
  /*  432 */  iRegLNoSp_rule,
  /*  433 */  iRegINoSp_rule,
  /*  434 */  iRegINoSp_rule,
  /*  435 */  iRegINoSp_rule,
  /*  436 */  iRegINoSp_rule,
  /*  437 */  iRegLNoSp_rule,
  /*  438 */  iRegLNoSp_rule,
  /*  439 */  iRegLNoSp_rule,
  /*  440 */  iRegLNoSp_rule,
  /*  441 */  iRegINoSp_rule,
  /*  442 */  iRegLNoSp_rule,
  /*  443 */  iRegINoSp_rule,
  /*  444 */  iRegINoSp_rule,
  /*  445 */  iRegINoSp_rule,
  /*  446 */  iRegINoSp_rule,
  /*  447 */  iRegINoSp_rule,
  /*  448 */  iRegINoSp_rule,
  /*  449 */  iRegLNoSp_rule,
  /*  450 */  iRegLNoSp_rule,
  /*  451 */  iRegLNoSp_rule,
  /*  452 */  iRegLNoSp_rule,
  /*  453 */  iRegLNoSp_rule,
  /*  454 */  iRegLNoSp_rule,
  /*  455 */  iRegLNoSp_rule,
  /*  456 */  iRegLNoSp_rule,
  /*  457 */  iRegINoSp_rule,
  /*  458 */  iRegINoSp_rule,
  /*  459 */  iRegINoSp_rule,
  /*  460 */  iRegLNoSp_rule,
  /*  461 */  iRegLNoSp_rule,
  /*  462 */  iRegINoSp_rule,
  /*  463 */  iRegINoSp_rule,
  /*  464 */  iRegLNoSp_rule,
  /*  465 */  iRegLNoSp_rule,
  /*  466 */  iRegINoSp_rule,
  /*  467 */  iRegINoSp_rule,
  /*  468 */  iRegLNoSp_rule,
  /*  469 */  iRegLNoSp_rule,
  /*  470 */  iRegINoSp_rule,
  /*  471 */  iRegINoSp_rule,
  /*  472 */  iRegLNoSp_rule,
  /*  473 */  iRegLNoSp_rule,
  /*  474 */  iRegINoSp_rule,
  /*  475 */  iRegINoSp_rule,
  /*  476 */  iRegLNoSp_rule,
  /*  477 */  iRegLNoSp_rule,
  /*  478 */  iRegINoSp_rule,
  /*  479 */  iRegINoSp_rule,
  /*  480 */  iRegLNoSp_rule,
  /*  481 */  iRegLNoSp_rule,
  /*  482 */  iRegINoSp_rule,
  /*  483 */  iRegINoSp_rule,
  /*  484 */  iRegINoSp_rule,
  /*  485 */  iRegINoSp_rule,
  /*  486 */  iRegLNoSp_rule,
  /*  487 */  iRegLNoSp_rule,
  /*  488 */  iRegLNoSp_rule,
  /*  489 */  iRegLNoSp_rule,
  /*  490 */  iRegINoSp_rule,
  /*  491 */  iRegINoSp_rule,
  /*  492 */  iRegINoSp_rule,
  /*  493 */  iRegINoSp_rule,
  /*  494 */  iRegLNoSp_rule,
  /*  495 */  iRegLNoSp_rule,
  /*  496 */  iRegLNoSp_rule,
  /*  497 */  iRegLNoSp_rule,
  /*  498 */  iRegINoSp_rule,
  /*  499 */  iRegINoSp_rule,
  /*  500 */  iRegINoSp_rule,
  /*  501 */  iRegINoSp_rule,
  /*  502 */  iRegLNoSp_rule,
  /*  503 */  iRegLNoSp_rule,
  /*  504 */  iRegLNoSp_rule,
  /*  505 */  iRegLNoSp_rule,
  /*  506 */  iRegINoSp_rule,
  /*  507 */  iRegINoSp_rule,
  /*  508 */  iRegLNoSp_rule,
  /*  509 */  iRegLNoSp_rule,
  /*  510 */  iRegINoSp_rule,
  /*  511 */  iRegINoSp_rule,
  /*  512 */  iRegLNoSp_rule,
  /*  513 */  iRegLNoSp_rule,
  /*  514 */  iRegINoSp_rule,
  /*  515 */  iRegINoSp_rule,
  /*  516 */  iRegLNoSp_rule,
  /*  517 */  iRegLNoSp_rule,
  /*  518 */  iRegINoSp_rule,
  /*  519 */  iRegINoSp_rule,
  /*  520 */  iRegLNoSp_rule,
  /*  521 */  iRegLNoSp_rule,
  /*  522 */  iRegINoSp_rule,
  /*  523 */  iRegINoSp_rule,
  /*  524 */  iRegLNoSp_rule,
  /*  525 */  iRegLNoSp_rule,
  /*  526 */  iRegINoSp_rule,
  /*  527 */  iRegINoSp_rule,
  /*  528 */  iRegLNoSp_rule,
  /*  529 */  iRegLNoSp_rule,
  /*  530 */  iRegINoSp_rule,
  /*  531 */  iRegINoSp_rule,
  /*  532 */  iRegLNoSp_rule,
  /*  533 */  iRegLNoSp_rule,
  /*  534 */  iRegINoSp_rule,
  /*  535 */  iRegINoSp_rule,
  /*  536 */  iRegLNoSp_rule,
  /*  537 */  iRegLNoSp_rule,
  /*  538 */  iRegINoSp_rule,
  /*  539 */  iRegINoSp_rule,
  /*  540 */  iRegLNoSp_rule,
  /*  541 */  iRegLNoSp_rule,
  /*  542 */  iRegINoSp_rule,
  /*  543 */  iRegINoSp_rule,
  /*  544 */  iRegLNoSp_rule,
  /*  545 */  iRegLNoSp_rule,
  /*  546 */  iRegINoSp_rule,
  /*  547 */  iRegINoSp_rule,
  /*  548 */  iRegLNoSp_rule,
  /*  549 */  iRegLNoSp_rule,
  /*  550 */  iRegINoSp_rule,
  /*  551 */  iRegINoSp_rule,
  /*  552 */  iRegLNoSp_rule,
  /*  553 */  iRegLNoSp_rule,
  /*  554 */  iRegINoSp_rule,
  /*  555 */  iRegINoSp_rule,
  /*  556 */  iRegLNoSp_rule,
  /*  557 */  iRegLNoSp_rule,
  /*  558 */  iRegINoSp_rule,
  /*  559 */  iRegINoSp_rule,
  /*  560 */  iRegLNoSp_rule,
  /*  561 */  iRegLNoSp_rule,
  /*  562 */  iRegINoSp_rule,
  /*  563 */  iRegINoSp_rule,
  /*  564 */  iRegLNoSp_rule,
  /*  565 */  iRegLNoSp_rule,
  /*  566 */  iRegINoSp_rule,
  /*  567 */  iRegLNoSp_rule,
  /*  568 */  iRegINoSp_rule,
  /*  569 */  iRegLNoSp_rule,
  /*  570 */  iRegINoSp_rule,
  /*  571 */  iRegLNoSp_rule,
  /*  572 */  iRegLNoSp_rule,
  /*  573 */  iRegINoSp_rule,
  /*  574 */  iRegLNoSp_rule,
  /*  575 */  iRegINoSp_rule,
  /*  576 */  iRegINoSp_rule,
  /*  577 */  iRegLNoSp_rule,
  /*  578 */  iRegLNoSp_rule,
  /*  579 */  iRegLNoSp_rule,
  /*  580 */  iRegLNoSp_rule,
  /*  581 */  iRegINoSp_rule,
  /*  582 */  iRegINoSp_rule,
  /*  583 */  iRegLNoSp_rule,
  /*  584 */  iRegLNoSp_rule,
  /*  585 */  iRegINoSp_rule,
  /*  586 */  iRegINoSp_rule,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  iRegLNoSp_rule,
  /*  590 */  iRegLNoSp_rule,
  /*  591 */  iRegLNoSp_rule,
  /*  592 */  iRegLNoSp_rule,
  /*  593 */  iRegLNoSp_rule,
  /*  594 */  iRegLNoSp_rule,
  /*  595 */  iRegLNoSp_rule,
  /*  596 */  iRegLNoSp_rule,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  iRegLNoSp_rule,
  /*  600 */  iRegLNoSp_rule,
  /*  601 */  iRegLNoSp_rule,
  /*  602 */  iRegLNoSp_rule,
  /*  603 */  iRegLNoSp_rule,
  /*  604 */  iRegLNoSp_rule,
  /*  605 */  iRegLNoSp_rule,
  /*  606 */  iRegLNoSp_rule,
  /*  607 */  iRegLNoSp_rule,
  /*  608 */  iRegLNoSp_rule,
  /*  609 */  iRegLNoSp_rule,
  /*  610 */  iRegINoSp_rule,
  /*  611 */  iRegINoSp_rule,
  /*  612 */  iRegINoSp_rule,
  /*  613 */  iRegINoSp_rule,
  /*  614 */  iRegINoSp_rule,
  /*  615 */  iRegINoSp_rule,
  /*  616 */  iRegLNoSp_rule,
  /*  617 */  iRegLNoSp_rule,
  /*  618 */  iRegLNoSp_rule,
  /*  619 */  iRegLNoSp_rule,
  /*  620 */  iRegLNoSp_rule,
  /*  621 */  iRegLNoSp_rule,
  /*  622 */  iRegLNoSp_rule,
  /*  623 */  iRegLNoSp_rule,
  /*  624 */  iRegINoSp_rule,
  /*  625 */  iRegINoSp_rule,
  /*  626 */  iRegINoSp_rule,
  /*  627 */  iRegINoSp_rule,
  /*  628 */  iRegLNoSp_rule,
  /*  629 */  iRegLNoSp_rule,
  /*  630 */  iRegLNoSp_rule,
  /*  631 */  iRegLNoSp_rule,
  /*  632 */  iRegLNoSp_rule,
  /*  633 */  iRegLNoSp_rule,
  /*  634 */  iRegINoSp_rule,
  /*  635 */  iRegINoSp_rule,
  /*  636 */  iRegLNoSp_rule,
  /*  637 */  iRegLNoSp_rule,
  /*  638 */  iRegLNoSp_rule,
  /*  639 */  vRegF_rule,
  /*  640 */  vRegD_rule,
  /*  641 */  vRegF_rule,
  /*  642 */  vRegD_rule,
  /*  643 */  vRegF_rule,
  /*  644 */  vRegD_rule,
  /*  645 */  vRegF_rule,
  /*  646 */  vRegD_rule,
  /*  647 */  vRegD_rule,
  /*  648 */  vRegF_rule,
  /*  649 */  iRegINoSp_rule,
  /*  650 */  iRegINoSp_rule,
  /*  651 */  iRegINoSp_rule,
  /*  652 */  iRegINoSp_rule,
  /*  653 */  iRegINoSp_rule,
  /*  654 */  iRegINoSp_rule,
  /*  655 */  iRegLNoSp_rule,
  /*  656 */  iRegLNoSp_rule,
  /*  657 */  iRegLNoSp_rule,
  /*  658 */  iRegLNoSp_rule,
  /*  659 */  iRegLNoSp_rule,
  /*  660 */  iRegLNoSp_rule,
  /*  661 */  iRegLNoSp_rule,
  /*  662 */  iRegLNoSp_rule,
  /*  663 */  iRegINoSp_rule,
  /*  664 */  iRegINoSp_rule,
  /*  665 */  iRegINoSp_rule,
  /*  666 */  vRegF_rule,
  /*  667 */  vRegD_rule,
  /*  668 */  iRegINoSp_rule,
  /*  669 */  iRegLNoSp_rule,
  /*  670 */  vRegF_rule,
  /*  671 */  vRegF_rule,
  /*  672 */  iRegINoSp_rule,
  /*  673 */  iRegLNoSp_rule,
  /*  674 */  vRegD_rule,
  /*  675 */  vRegD_rule,
  /*  676 */  stackSlotI_rule,
  /*  677 */  stackSlotF_rule,
  /*  678 */  stackSlotL_rule,
  /*  679 */  stackSlotD_rule,
  /*  680 */  Universe_rule,
  /*  681 */  iRegINoSp_rule,
  /*  682 */  iRegINoSp_rule,
  /*  683 */  iRegINoSp_rule,
  /*  684 */  iRegINoSp_rule,
  /*  685 */  iRegINoSp_rule,
  /*  686 */  iRegINoSp_rule,
  /*  687 */  iRegINoSp_rule,
  /*  688 */  iRegINoSp_rule,
  /*  689 */  iRegINoSp_rule,
  /*  690 */  Universe_rule,
  /*  691 */  Universe_rule,
  /*  692 */  Universe_rule,
  /*  693 */  Universe_rule,
  /*  694 */  Universe_rule,
  /*  695 */  Universe_rule,
  /*  696 */  Universe_rule,
  /*  697 */  Universe_rule,
  /*  698 */  Universe_rule,
  /*  699 */  Universe_rule,
  /*  700 */  Universe_rule,
  /*  701 */  Universe_rule,
  /*  702 */  Universe_rule,
  /*  703 */  Universe_rule,
  /*  704 */  Universe_rule,
  /*  705 */  Universe_rule,
  /*  706 */  Universe_rule,
  /*  707 */  iRegP_R0_rule,
  /*  708 */  Universe_rule,
  /*  709 */  Universe_rule,
  /*  710 */  Universe_rule,
  /*  711 */  iRegP_R5_rule,
  /*  712 */  iRegI_R0_rule,
  /*  713 */  iRegI_R0_rule,
  /*  714 */  iRegI_R0_rule,
  /*  715 */  iRegI_R0_rule,
  /*  716 */  iRegI_R0_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*   92 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*   93 */  _AddP_iRegP__ConvI2L_iRegI__rule,
  /*   94 */  _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*   95 */  iRegP_rule,
  /*   96 */  iRegP_rule,
  /*   97 */  iRegP_rule,
  /*   98 */  iRegP_rule,
  /*   99 */  iRegP_rule,
  /*  100 */  iRegN_rule,
  /*  101 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  102 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  103 */  _AddP__DecodeN_iRegN___ConvI2L_iRegI__rule,
  /*  104 */  _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  105 */  _DecodeN_iRegN__rule,
  /*  106 */  _DecodeN_iRegN__rule,
  /*  107 */  _DecodeN_iRegN__rule,
  /*  108 */  _DecodeN_iRegN__rule,
  /*  109 */  _DecodeN_iRegN__rule,
  /*  110 */  thread_RegP_rule,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  iRegL_rule,
  // last operand
  /*  119 */  0,
  /*  120 */  0,
  // last operand class
  /*  121 */  iRegL_rule,
  /*  122 */  iRegP_rule,
  /*  123 */  iRegI_rule,
  /*  124 */  iRegP_rule,
  /*  125 */  _ConvI2L_iRegI__rule,
  /*  126 */  iRegP_rule,
  /*  127 */  iRegN_rule,
  /*  128 */  _DecodeN_iRegN__rule,
  /*  129 */  _DecodeN_iRegN__rule,
  /*  130 */  _DecodeN_iRegN__rule,
  /*  131 */  memory_rule,
  /*  132 */  memory_rule,
  /*  133 */  memory_rule,
  /*  134 */  memory_rule,
  /*  135 */  memory_rule,
  /*  136 */  _LoadI_memory__rule,
  /*  137 */  iRegP_rule,
  /*  138 */  _DecodeN_iRegN__rule,
  /*  139 */  iRegP_rule,
  /*  140 */  iRegLNoSp_rule,
  /*  141 */  iRegINoSp_rule,
  /*  142 */  iRegNNoSp_rule,
  /*  143 */  cmpOp_rule,
  /*  144 */  iRegIorL2I_rule,
  /*  145 */  cmpOpU_rule,
  /*  146 */  immI0_rule,
  /*  147 */  iRegIorL2I_rule,
  /*  148 */  immI_1_rule,
  /*  149 */  iRegL_rule,
  /*  150 */  iRegL_rule,
  /*  151 */  immL0_rule,
  /*  152 */  iRegP_rule,
  /*  153 */  immP0_rule,
  /*  154 */  iRegN_rule,
  /*  155 */  iRegN_rule,
  /*  156 */  immN0_rule,
  /*  157 */  vRegF_rule,
  /*  158 */  vRegD_rule,
  /*  159 */  iRegL_rule,
  /*  160 */  iRegIorL2I_rule,
  /*  161 */  _ConvI2L_iRegIorL2I__rule,
  /*  162 */  iRegIorL2I_rule,
  /*  163 */  iRegL_rule,
  /*  164 */  iRegIorL2I_rule,
  /*  165 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  166 */  iRegL_rule,
  /*  167 */  _RShiftL_iRegL_immL_63_rule,
  /*  168 */  iRegIorL2I_rule,
  /*  169 */  iRegL_rule,
  /*  170 */  iRegIorL2I_rule,
  /*  171 */  iRegL_rule,
  /*  172 */  iRegIorL2I_rule,
  /*  173 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  174 */  iRegL_rule,
  /*  175 */  _URShiftL_iRegL_immI_rule,
  /*  176 */  iRegIorL2I_rule,
  /*  177 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  178 */  iRegL_rule,
  /*  179 */  _RShiftL_iRegL_immI_rule,
  /*  180 */  iRegIorL2I_rule,
  /*  181 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  182 */  iRegL_rule,
  /*  183 */  _LShiftL_iRegL_immI_rule,
  /*  184 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  185 */  iRegIorL2I_rule,
  /*  186 */  _URShiftL_iRegL_immI_rule,
  /*  187 */  iRegL_rule,
  /*  188 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  189 */  iRegIorL2I_rule,
  /*  190 */  _RShiftL_iRegL_immI_rule,
  /*  191 */  iRegL_rule,
  /*  192 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  193 */  iRegIorL2I_rule,
  /*  194 */  _LShiftL_iRegL_immI_rule,
  /*  195 */  iRegL_rule,
  /*  196 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  197 */  iRegL_rule,
  /*  198 */  immI_64_rule,
  /*  199 */  iRegL_rule,
  /*  200 */  immI0_rule,
  /*  201 */  iRegL_rule,
  /*  202 */  iRegL_rule,
  /*  203 */  immI_32_rule,
  /*  204 */  iRegL_rule,
  /*  205 */  iRegL_rule,
  /*  206 */  iRegL_rule,
  /*  207 */  iRegL_rule,
  /*  208 */  iRegL_rule,
  /*  209 */  iRegL_rule,
  /*  210 */  iRegL_rule,
  /*  211 */  iRegL_rule,
  /*  212 */  iRegIorL2I_rule,
  /*  213 */  _LShiftI_iRegIorL2I_immI_16_rule,
  /*  214 */  iRegIorL2I_rule,
  /*  215 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  216 */  _LShiftI_iRegIorL2I_immI_24_rule,
  /*  217 */  iRegL_rule,
  /*  218 */  _LShiftL_iRegL_immI_48_rule,
  /*  219 */  iRegL_rule,
  /*  220 */  _LShiftL_iRegL_immI_32_rule,
  /*  221 */  iRegL_rule,
  /*  222 */  _LShiftL_iRegL_immI_56_rule,
  /*  223 */  _LShiftL_iRegL_immI_56_rule,
  /*  224 */  iRegIorL2I_rule,
  /*  225 */  iRegIorL2I_rule,
  /*  226 */  iRegL_rule,
  /*  227 */  iRegL_rule,
  /*  228 */  iRegL_rule,
  /*  229 */  vRegF_rule,
  /*  230 */  _ConvF2D_vRegF__rule,
  /*  231 */  iRegIorL2I_rule,
  /*  232 */  iRegL_rule,
  /*  233 */  iRegP_rule,
  /*  234 */  iRegP_R4_rule,
  /*  235 */  iRegP_R1_rule,
  /*  236 */  iRegP_R3_rule,
  /*  237 */  iRegP_R1_rule,
  /*  238 */  iRegP_R3_rule,
  /*  239 */  iRegP_R3_rule,
  /*  240 */  iRegP_R1_rule,
  // last internally defined operand
  /*  241 */  immI_rule,
  /*  242 */  immL_rule,
  /*  243 */  immP_rule,
  /*  244 */  immP0_rule,
  /*  245 */  immP_1_rule,
  /*  246 */  immPollPage_rule,
  /*  247 */  immByteMapBase_rule,
  /*  248 */  immN_rule,
  /*  249 */  immN0_rule,
  /*  250 */  immFPacked_rule,
  /*  251 */  immF_rule,
  /*  252 */  immDPacked_rule,
  /*  253 */  immD_rule,
  /*  254 */  iRegIorL2I_rule,
  /*  255 */  iRegL_rule,
  /*  256 */  iRegIorL2I_rule,
  /*  257 */  iRegL_rule,
  /*  258 */  iRegL_rule,
  /*  259 */  iRegP_rule,
  /*  260 */  iRegPNoSp_rule,
  /*  261 */  iRegPNoSp_rule,
  /*  262 */  iRegI_rule,
  /*  263 */  memory_rule,
  /*  264 */  memory_rule,
  /*  265 */  memory_rule,
  /*  266 */  vRegF_rule,
  /*  267 */  vRegD_rule,
  /*  268 */  vRegF_rule,
  /*  269 */  vRegD_rule,
  /*  270 */  stackSlotF_rule,
  /*  271 */  stackSlotI_rule,
  /*  272 */  stackSlotD_rule,
  /*  273 */  stackSlotL_rule,
  /*  274 */  vRegF_rule,
  /*  275 */  iRegI_rule,
  /*  276 */  vRegD_rule,
  /*  277 */  iRegL_rule,
  /*  278 */  iRegI_rule,
  /*  279 */  iRegI_rule,
  /*  280 */  iRegI_rule,
  /*  281 */  iRegI_rule,
  /*  282 */  iRegI_rule,
  /*  283 */  iRegI_rule,
  /*  284 */  iRegI_rule,
  /*  285 */  iRegI_rule,
  /*  286 */  iRegL_rule,
  /*  287 */  iRegL_rule,
  /*  288 */  iRegL_rule,
  /*  289 */  iRegL_rule,
  /*  290 */  iRegP_rule,
  /*  291 */  iRegN_rule,
  /*  292 */  iRegP_rule,
  /*  293 */  iRegN_rule,
  /*  294 */  vRegF_rule,
  /*  295 */  vRegF_rule,
  /*  296 */  vRegD_rule,
  /*  297 */  vRegD_rule,
  /*  298 */  iRegP_rule,
  /*  299 */  iRegP_rule,
  /*  300 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  301 */  0,
  /*  302 */  memory_rule,
  /*  303 */  _LoadB_memory__rule,
  /*  304 */  memory_rule,
  /*  305 */  _LoadUB_memory__rule,
  /*  306 */  memory_rule,
  /*  307 */  _LoadS_memory__rule,
  /*  308 */  memory_rule,
  /*  309 */  _LoadUS_memory__rule,
  /*  310 */  memory_rule,
  /*  311 */  _LoadI_memory__rule,
  /*  312 */  _ConvI2L__LoadI_memory___rule,
  /*  313 */  memory_rule,
  /*  314 */  memory_rule,
  /*  315 */  memory_rule,
  /*  316 */  memory_rule,
  /*  317 */  memory_rule,
  /*  318 */  memory_rule,
  /*  319 */  memory_rule,
  /*  320 */  memory_rule,
  /*  321 */  memory_rule,
  /*  322 */  memory_rule,
  /*  323 */  memory_rule,
  /*  324 */  memory_rule,
  /*  325 */  memory_rule,
  /*  326 */  memory_rule,
  /*  327 */  memory_rule,
  /*  328 */  memory_rule,
  /*  329 */  memory_rule,
  /*  330 */  memory_rule,
  /*  331 */  memory_rule,
  /*  332 */  thread_anchor_pc_rule,
  /*  333 */  thread_anchor_pc_rule,
  /*  334 */  memory_rule,
  /*  335 */  memory_rule,
  /*  336 */  memory_rule,
  /*  337 */  memory_rule,
  /*  338 */  memory_rule,
  /*  339 */  memory_rule,
  /*  340 */  memory_rule,
  /*  341 */  iRegIorL2I_rule,
  /*  342 */  iRegL_rule,
  /*  343 */  iRegIorL2I_rule,
  /*  344 */  iRegIorL2I_rule,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  0,
  /*  350 */  0,
  /*  351 */  0,
  /*  352 */  _CastP2X_iRegP__rule,
  /*  353 */  _CastP2X__DecodeN_iRegN___rule,
  /*  354 */  iRegP_rule,
  /*  355 */  iRegP_rule,
  /*  356 */  iRegN_rule,
  /*  357 */  iRegN_rule,
  /*  358 */  memory_rule,
  /*  359 */  memory_rule,
  /*  360 */  memory_rule,
  /*  361 */  memory_rule,
  /*  362 */  memory_rule,
  /*  363 */  indirect_rule,
  /*  364 */  indirect_rule,
  /*  365 */  indirect_rule,
  /*  366 */  indirect_rule,
  /*  367 */  indirect_rule,
  /*  368 */  indirect_rule,
  /*  369 */  indirect_rule,
  /*  370 */  indirect_rule,
  /*  371 */  indirect_rule,
  /*  372 */  indirect_rule,
  /*  373 */  indirect_rule,
  /*  374 */  indirect_rule,
  /*  375 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  376 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  377 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  378 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  379 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  380 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  381 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  382 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  383 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  384 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  385 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  386 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  387 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  388 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  389 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  390 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  391 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  392 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  393 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  394 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  395 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  396 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  397 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  398 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  399 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  400 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  401 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  402 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  403 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  404 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  405 */  iRegIorL2I_rule,
  /*  406 */  iRegIorL2I_rule,
  /*  407 */  _ConvL2I_iRegL__rule,
  /*  408 */  iRegP_rule,
  /*  409 */  iRegP_rule,
  /*  410 */  iRegP_rule,
  /*  411 */  iRegP_rule,
  /*  412 */  _ConvI2L_iRegIorL2I__rule,
  /*  413 */  iRegP_rule,
  /*  414 */  iRegL_rule,
  /*  415 */  iRegL_rule,
  /*  416 */  iRegIorL2I_rule,
  /*  417 */  iRegIorL2I_rule,
  /*  418 */  iRegL_rule,
  /*  419 */  iRegL_rule,
  /*  420 */  immI0_rule,
  /*  421 */  immL0_rule,
  /*  422 */  iRegIorL2I_rule,
  /*  423 */  _ConvI2L_iRegIorL2I__rule,
  /*  424 */  _ConvI2L_iRegIorL2I__rule,
  /*  425 */  iRegL_rule,
  /*  426 */  iRegL_rule,
  /*  427 */  iRegIorL2I_rule,
  /*  428 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  429 */  iRegIorL2I_rule,
  /*  430 */  iRegL_rule,
  /*  431 */  _MulL_iRegL_iRegL_rule,
  /*  432 */  iRegL_rule,
  /*  433 */  iRegIorL2I_rule,
  /*  434 */  _RShiftI_iRegIorL2I_immI_31_rule,
  /*  435 */  iRegIorL2I_rule,
  /*  436 */  _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule,
  /*  437 */  iRegL_rule,
  /*  438 */  _RShiftL_iRegL_immL_63_rule,
  /*  439 */  iRegL_rule,
  /*  440 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  441 */  iRegIorL2I_rule,
  /*  442 */  iRegL_rule,
  /*  443 */  iRegIorL2I_rule,
  /*  444 */  iRegIorL2I_rule,
  /*  445 */  iRegIorL2I_rule,
  /*  446 */  iRegIorL2I_rule,
  /*  447 */  iRegIorL2I_rule,
  /*  448 */  iRegIorL2I_rule,
  /*  449 */  iRegL_rule,
  /*  450 */  iRegL_rule,
  /*  451 */  iRegL_rule,
  /*  452 */  iRegL_rule,
  /*  453 */  _CastP2X_iRegP__rule,
  /*  454 */  iRegL_rule,
  /*  455 */  iRegL_rule,
  /*  456 */  iRegL_rule,
  /*  457 */  iRegIorL2I_rule,
  /*  458 */  iRegIorL2I_rule,
  /*  459 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  460 */  iRegL_rule,
  /*  461 */  _XorL_iRegL_immL_M1_rule,
  /*  462 */  iRegIorL2I_rule,
  /*  463 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  464 */  iRegL_rule,
  /*  465 */  _XorL_iRegL_immL_M1_rule,
  /*  466 */  immI_M1_rule,
  /*  467 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  468 */  immL_M1_rule,
  /*  469 */  _XorL_iRegL_iRegL_rule,
  /*  470 */  iRegIorL2I_rule,
  /*  471 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  472 */  iRegL_rule,
  /*  473 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  474 */  iRegIorL2I_rule,
  /*  475 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  476 */  iRegL_rule,
  /*  477 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  478 */  iRegIorL2I_rule,
  /*  479 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  480 */  iRegL_rule,
  /*  481 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  482 */  immI_M1_rule,
  /*  483 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  484 */  immI_M1_rule,
  /*  485 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  486 */  immL_M1_rule,
  /*  487 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  488 */  immL_M1_rule,
  /*  489 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  490 */  immI_M1_rule,
  /*  491 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  492 */  immI_M1_rule,
  /*  493 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  494 */  immL_M1_rule,
  /*  495 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  496 */  immL_M1_rule,
  /*  497 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  498 */  immI_M1_rule,
  /*  499 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  500 */  immI_M1_rule,
  /*  501 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  502 */  immL_M1_rule,
  /*  503 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  504 */  immL_M1_rule,
  /*  505 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  506 */  iRegIorL2I_rule,
  /*  507 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  508 */  iRegL_rule,
  /*  509 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  510 */  iRegIorL2I_rule,
  /*  511 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  512 */  iRegL_rule,
  /*  513 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  514 */  iRegIorL2I_rule,
  /*  515 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  516 */  iRegL_rule,
  /*  517 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  518 */  iRegIorL2I_rule,
  /*  519 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  520 */  iRegL_rule,
  /*  521 */  _URShiftL_iRegL_immI_rule,
  /*  522 */  iRegIorL2I_rule,
  /*  523 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  524 */  iRegL_rule,
  /*  525 */  _RShiftL_iRegL_immI_rule,
  /*  526 */  iRegIorL2I_rule,
  /*  527 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  528 */  iRegL_rule,
  /*  529 */  _LShiftL_iRegL_immI_rule,
  /*  530 */  iRegIorL2I_rule,
  /*  531 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  532 */  iRegL_rule,
  /*  533 */  _URShiftL_iRegL_immI_rule,
  /*  534 */  iRegIorL2I_rule,
  /*  535 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  536 */  iRegL_rule,
  /*  537 */  _RShiftL_iRegL_immI_rule,
  /*  538 */  iRegIorL2I_rule,
  /*  539 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  540 */  iRegL_rule,
  /*  541 */  _LShiftL_iRegL_immI_rule,
  /*  542 */  iRegIorL2I_rule,
  /*  543 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  544 */  iRegL_rule,
  /*  545 */  _URShiftL_iRegL_immI_rule,
  /*  546 */  iRegIorL2I_rule,
  /*  547 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  548 */  iRegL_rule,
  /*  549 */  _RShiftL_iRegL_immI_rule,
  /*  550 */  iRegIorL2I_rule,
  /*  551 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  552 */  iRegL_rule,
  /*  553 */  _LShiftL_iRegL_immI_rule,
  /*  554 */  iRegIorL2I_rule,
  /*  555 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  556 */  iRegL_rule,
  /*  557 */  _URShiftL_iRegL_immI_rule,
  /*  558 */  iRegIorL2I_rule,
  /*  559 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  560 */  iRegL_rule,
  /*  561 */  _RShiftL_iRegL_immI_rule,
  /*  562 */  iRegIorL2I_rule,
  /*  563 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  564 */  iRegL_rule,
  /*  565 */  _LShiftL_iRegL_immI_rule,
  /*  566 */  iRegIorL2I_rule,
  /*  567 */  iRegL_rule,
  /*  568 */  iRegIorL2I_rule,
  /*  569 */  iRegL_rule,
  /*  570 */  iRegIorL2I_rule,
  /*  571 */  iRegL_rule,
  /*  572 */  _LShiftL_iRegL_immI_rule,
  /*  573 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  574 */  _LShiftL_iRegL_immI_rule,
  /*  575 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  576 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  577 */  _URShiftL_iRegL_immI_rule,
  /*  578 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  579 */  _LShiftL_iRegL_immI_rule,
  /*  580 */  _URShiftL_iRegL_immI_rule,
  /*  581 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  582 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  583 */  _LShiftL_iRegL_immI_rule,
  /*  584 */  _URShiftL_iRegL_immI_rule,
  /*  585 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  586 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  _LShiftL_iRegL_iRegI_rule,
  /*  590 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  591 */  _LShiftL_iRegL_iRegI_rule,
  /*  592 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  593 */  _LShiftI_iRegL_iRegI_rule,
  /*  594 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  595 */  _LShiftI_iRegL_iRegI_rule,
  /*  596 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  _URShiftL_iRegL_iRegI_rule,
  /*  600 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  601 */  _URShiftL_iRegL_iRegI_rule,
  /*  602 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  603 */  _URShiftI_iRegL_iRegI_rule,
  /*  604 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  605 */  _URShiftI_iRegL_iRegI_rule,
  /*  606 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  607 */  iRegL_rule,
  /*  608 */  _ConvI2L_iRegIorL2I__rule,
  /*  609 */  iRegL_rule,
  /*  610 */  iRegIorL2I_rule,
  /*  611 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  612 */  iRegIorL2I_rule,
  /*  613 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  614 */  iRegIorL2I_rule,
  /*  615 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  616 */  iRegL_rule,
  /*  617 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  618 */  iRegL_rule,
  /*  619 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  620 */  iRegL_rule,
  /*  621 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  622 */  iRegL_rule,
  /*  623 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  624 */  iRegIorL2I_rule,
  /*  625 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  626 */  iRegIorL2I_rule,
  /*  627 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  628 */  iRegL_rule,
  /*  629 */  _AndL_iRegL_immL_255_rule,
  /*  630 */  iRegL_rule,
  /*  631 */  _AndL_iRegL_immL_65535_rule,
  /*  632 */  iRegL_rule,
  /*  633 */  _AndL_iRegL_immL_4294967295_rule,
  /*  634 */  iRegIorL2I_rule,
  /*  635 */  iRegIorL2I_rule,
  /*  636 */  iRegL_rule,
  /*  637 */  iRegL_rule,
  /*  638 */  iRegL_rule,
  /*  639 */  vRegF_rule,
  /*  640 */  vRegD_rule,
  /*  641 */  vRegF_rule,
  /*  642 */  vRegD_rule,
  /*  643 */  vRegF_rule,
  /*  644 */  vRegD_rule,
  /*  645 */  vRegF_rule,
  /*  646 */  vRegD_rule,
  /*  647 */  vRegD_rule,
  /*  648 */  _SqrtD__ConvF2D_vRegF___rule,
  /*  649 */  iRegIorL2I_rule,
  /*  650 */  iRegIorL2I_rule,
  /*  651 */  iRegIorL2I_rule,
  /*  652 */  iRegIorL2I_rule,
  /*  653 */  iRegIorL2I_rule,
  /*  654 */  iRegIorL2I_rule,
  /*  655 */  iRegL_rule,
  /*  656 */  iRegL_rule,
  /*  657 */  iRegL_rule,
  /*  658 */  iRegL_rule,
  /*  659 */  iRegL_rule,
  /*  660 */  iRegL_rule,
  /*  661 */  iRegIorL2I_rule,
  /*  662 */  _ConvI2L_iRegIorL2I__rule,
  /*  663 */  iRegL_rule,
  /*  664 */  iRegIorL2I_rule,
  /*  665 */  iRegP_rule,
  /*  666 */  vRegD_rule,
  /*  667 */  vRegF_rule,
  /*  668 */  vRegF_rule,
  /*  669 */  vRegF_rule,
  /*  670 */  iRegIorL2I_rule,
  /*  671 */  iRegL_rule,
  /*  672 */  vRegD_rule,
  /*  673 */  vRegD_rule,
  /*  674 */  iRegIorL2I_rule,
  /*  675 */  iRegL_rule,
  /*  676 */  vRegF_rule,
  /*  677 */  iRegI_rule,
  /*  678 */  vRegD_rule,
  /*  679 */  iRegL_rule,
  /*  680 */  iRegL_R11_rule,
  /*  681 */  vRegF_rule,
  /*  682 */  vRegD_rule,
  /*  683 */  vRegF_rule,
  /*  684 */  vRegD_rule,
  /*  685 */  iRegL_rule,
  /*  686 */  iRegIorL2I_rule,
  /*  687 */  iRegIorL2I_rule,
  /*  688 */  iRegI_rule,
  /*  689 */  iRegI_rule,
  /*  690 */  0,
  /*  691 */  cmpOp_rule,
  /*  692 */  cmpOpU_rule,
  /*  693 */  cmpOp_rule,
  /*  694 */  cmpOp_rule,
  /*  695 */  cmpOp_rule,
  /*  696 */  cmpOp_rule,
  /*  697 */  cmpOpU_rule,
  /*  698 */  iRegP_rule,
  /*  699 */  0,
  /*  700 */  0,
  /*  701 */  0,
  /*  702 */  0,
  /*  703 */  0,
  /*  704 */  0,
  /*  705 */  iRegPNoSp_rule,
  /*  706 */  iRegPNoSp_rule,
  /*  707 */  0,
  /*  708 */  0,
  /*  709 */  0,
  /*  710 */  0,
  /*  711 */  iRegP_R4_rule,
  /*  712 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  713 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  714 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  715 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  716 */  iRegP_R1_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  immIU12_rule,
  /*   92 */  immLU12_rule,
  /*   93 */  immLU12_rule,
  /*   94 */  immLU12_rule,
  /*   95 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*   96 */  _LShiftL_iRegL_immIScale_rule,
  /*   97 */  iRegL_rule,
  /*   98 */  immIOffset_rule,
  /*   99 */  immLoffset_rule,
  /*  100 */  0,
  /*  101 */  immIU12_rule,
  /*  102 */  immLU12_rule,
  /*  103 */  immLU12_rule,
  /*  104 */  immLU12_rule,
  /*  105 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  106 */  _LShiftL_iRegL_immIScale_rule,
  /*  107 */  iRegL_rule,
  /*  108 */  immIOffset_rule,
  /*  109 */  immLoffset_rule,
  /*  110 */  immL_pc_off_rule,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  // last operand
  /*  119 */  0,
  /*  120 */  0,
  // last operand class
  /*  121 */  immIScale_rule,
  /*  122 */  _LShiftL_iRegL_immIScale_rule,
  /*  123 */  0,
  /*  124 */  _ConvI2L_iRegI__rule,
  /*  125 */  immIScale_rule,
  /*  126 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  127 */  0,
  /*  128 */  _LShiftL_iRegL_immIScale_rule,
  /*  129 */  _ConvI2L_iRegI__rule,
  /*  130 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  iRegP_rule,
  /*  140 */  iRegLNoSp_rule,
  /*  141 */  iRegINoSp_rule,
  /*  142 */  iRegNNoSp_rule,
  /*  143 */  rFlagsReg_rule,
  /*  144 */  iRegIorL2I_rule,
  /*  145 */  rFlagsRegU_rule,
  /*  146 */  iRegIorL2I_rule,
  /*  147 */  immI0_rule,
  /*  148 */  immI0_rule,
  /*  149 */  iRegL_rule,
  /*  150 */  immL0_rule,
  /*  151 */  iRegL_rule,
  /*  152 */  immP0_rule,
  /*  153 */  iRegP_rule,
  /*  154 */  iRegN_rule,
  /*  155 */  immN0_rule,
  /*  156 */  iRegN_rule,
  /*  157 */  vRegF_rule,
  /*  158 */  vRegD_rule,
  /*  159 */  0,
  /*  160 */  0,
  /*  161 */  immIScale_rule,
  /*  162 */  iRegIorL2I_rule,
  /*  163 */  iRegL_rule,
  /*  164 */  immI_31_rule,
  /*  165 */  immI_31_rule,
  /*  166 */  immL_63_rule,
  /*  167 */  immL_63_rule,
  /*  168 */  immI_M1_rule,
  /*  169 */  immL_M1_rule,
  /*  170 */  iRegIorL2I_rule,
  /*  171 */  iRegL_rule,
  /*  172 */  immI_rule,
  /*  173 */  immI_M1_rule,
  /*  174 */  immI_rule,
  /*  175 */  immL_M1_rule,
  /*  176 */  immI_rule,
  /*  177 */  immI_M1_rule,
  /*  178 */  immI_rule,
  /*  179 */  immL_M1_rule,
  /*  180 */  immI_rule,
  /*  181 */  immI_M1_rule,
  /*  182 */  immI_rule,
  /*  183 */  immL_M1_rule,
  /*  184 */  iRegIorL2I_rule,
  /*  185 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  186 */  iRegL_rule,
  /*  187 */  _URShiftL_iRegL_immI_rule,
  /*  188 */  iRegIorL2I_rule,
  /*  189 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  190 */  iRegL_rule,
  /*  191 */  _RShiftL_iRegL_immI_rule,
  /*  192 */  iRegIorL2I_rule,
  /*  193 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  194 */  iRegL_rule,
  /*  195 */  _LShiftL_iRegL_immI_rule,
  /*  196 */  immI_bitmask_rule,
  /*  197 */  iRegI_rule,
  /*  198 */  iRegI_rule,
  /*  199 */  _SubI_immI_64_iRegI_rule,
  /*  200 */  iRegI_rule,
  /*  201 */  _SubI_immI0_iRegI_rule,
  /*  202 */  iRegI_rule,
  /*  203 */  iRegI_rule,
  /*  204 */  _SubI_immI_32_iRegI_rule,
  /*  205 */  _SubI_immI0_iRegI_rule,
  /*  206 */  iRegI_rule,
  /*  207 */  _SubI_immI_64_iRegI_rule,
  /*  208 */  _SubI_immI0_iRegI_rule,
  /*  209 */  iRegI_rule,
  /*  210 */  _SubI_immI_32_iRegI_rule,
  /*  211 */  _SubI_immI0_iRegI_rule,
  /*  212 */  immI_16_rule,
  /*  213 */  immI_16_rule,
  /*  214 */  immI_24_rule,
  /*  215 */  immI_24_rule,
  /*  216 */  immI_24_rule,
  /*  217 */  immI_48_rule,
  /*  218 */  immI_48_rule,
  /*  219 */  immI_32_rule,
  /*  220 */  immI_32_rule,
  /*  221 */  immI_56_rule,
  /*  222 */  immI_56_rule,
  /*  223 */  immI_56_rule,
  /*  224 */  immI_255_rule,
  /*  225 */  immI_65535_rule,
  /*  226 */  immL_255_rule,
  /*  227 */  immL_65535_rule,
  /*  228 */  immL_4294967295_rule,
  /*  229 */  0,
  /*  230 */  0,
  /*  231 */  immI0_rule,
  /*  232 */  immL0_rule,
  /*  233 */  immP0_rule,
  /*  234 */  iRegP_R0_rule,
  /*  235 */  iRegI_R2_rule,
  /*  236 */  iRegI_R4_rule,
  /*  237 */  iRegI_R4_rule,
  /*  238 */  iRegI_R2_rule,
  /*  239 */  immI_le_4_rule,
  /*  240 */  iRegP_R3_rule,
  // last internally defined operand
  /*  241 */  0,
  /*  242 */  0,
  /*  243 */  0,
  /*  244 */  0,
  /*  245 */  0,
  /*  246 */  0,
  /*  247 */  0,
  /*  248 */  0,
  /*  249 */  0,
  /*  250 */  0,
  /*  251 */  0,
  /*  252 */  0,
  /*  253 */  0,
  /*  254 */  0,
  /*  255 */  0,
  /*  256 */  0,
  /*  257 */  0,
  /*  258 */  0,
  /*  259 */  0,
  /*  260 */  0,
  /*  261 */  0,
  /*  262 */  0,
  /*  263 */  _Binary_iRegP_iRegP_rule,
  /*  264 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  265 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  266 */  0,
  /*  267 */  0,
  /*  268 */  0,
  /*  269 */  0,
  /*  270 */  0,
  /*  271 */  0,
  /*  272 */  0,
  /*  273 */  0,
  /*  274 */  0,
  /*  275 */  0,
  /*  276 */  0,
  /*  277 */  0,
  /*  278 */  iRegI_rule,
  /*  279 */  immI0_rule,
  /*  280 */  immIAddSub_rule,
  /*  281 */  immI_rule,
  /*  282 */  iRegI_rule,
  /*  283 */  immI0_rule,
  /*  284 */  immIAddSub_rule,
  /*  285 */  immI_rule,
  /*  286 */  iRegL_rule,
  /*  287 */  immI0_rule,
  /*  288 */  immLAddSub_rule,
  /*  289 */  immL_rule,
  /*  290 */  iRegP_rule,
  /*  291 */  iRegN_rule,
  /*  292 */  immP0_rule,
  /*  293 */  immN0_rule,
  /*  294 */  vRegF_rule,
  /*  295 */  immF0_rule,
  /*  296 */  vRegD_rule,
  /*  297 */  immD0_rule,
  /*  298 */  iRegP_rule,
  /*  299 */  iRegP_rule,
  /*  300 */  immP0_rule,
  /*  301 */  0,
  /*  302 */  0,
  /*  303 */  0,
  /*  304 */  0,
  /*  305 */  0,
  /*  306 */  0,
  /*  307 */  0,
  /*  308 */  0,
  /*  309 */  0,
  /*  310 */  0,
  /*  311 */  0,
  /*  312 */  immL_32bits_rule,
  /*  313 */  0,
  /*  314 */  0,
  /*  315 */  0,
  /*  316 */  0,
  /*  317 */  0,
  /*  318 */  0,
  /*  319 */  0,
  /*  320 */  0,
  /*  321 */  immI0_rule,
  /*  322 */  iRegIorL2I_rule,
  /*  323 */  immI0_rule,
  /*  324 */  iRegIorL2I_rule,
  /*  325 */  immI0_rule,
  /*  326 */  iRegIorL2I_rule,
  /*  327 */  immI0_rule,
  /*  328 */  iRegL_rule,
  /*  329 */  immL0_rule,
  /*  330 */  iRegP_rule,
  /*  331 */  immP0_rule,
  /*  332 */  immP_M1_rule,
  /*  333 */  immP_M2_rule,
  /*  334 */  iRegN_rule,
  /*  335 */  immN0_rule,
  /*  336 */  vRegF_rule,
  /*  337 */  vRegD_rule,
  /*  338 */  0,
  /*  339 */  0,
  /*  340 */  0,
  /*  341 */  0,
  /*  342 */  0,
  /*  343 */  0,
  /*  344 */  0,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  0,
  /*  350 */  0,
  /*  351 */  0,
  /*  352 */  0,
  /*  353 */  0,
  /*  354 */  0,
  /*  355 */  0,
  /*  356 */  0,
  /*  357 */  0,
  /*  358 */  0,
  /*  359 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  360 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  361 */  _Binary_iRegP_iRegP_rule,
  /*  362 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  363 */  iRegINoSp_rule,
  /*  364 */  iRegLNoSp_rule,
  /*  365 */  iRegNNoSp_rule,
  /*  366 */  iRegPNoSp_rule,
  /*  367 */  iRegL_rule,
  /*  368 */  iRegL_rule,
  /*  369 */  immLAddSub_rule,
  /*  370 */  immLAddSub_rule,
  /*  371 */  iRegIorL2I_rule,
  /*  372 */  iRegIorL2I_rule,
  /*  373 */  immIAddSub_rule,
  /*  374 */  immIAddSub_rule,
  /*  375 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  376 */  _Binary_iRegIorL2I_iRegIorL2I_rule,
  /*  377 */  _Binary_immI0_iRegIorL2I_rule,
  /*  378 */  _Binary_immI0_iRegIorL2I_rule,
  /*  379 */  _Binary_iRegIorL2I_immI0_rule,
  /*  380 */  _Binary_iRegIorL2I_immI0_rule,
  /*  381 */  _Binary_immI_1_immI0_rule,
  /*  382 */  _Binary_immI_1_immI0_rule,
  /*  383 */  _Binary_iRegL_iRegL_rule,
  /*  384 */  _Binary_iRegL_iRegL_rule,
  /*  385 */  _Binary_iRegL_immL0_rule,
  /*  386 */  _Binary_iRegL_immL0_rule,
  /*  387 */  _Binary_immL0_iRegL_rule,
  /*  388 */  _Binary_immL0_iRegL_rule,
  /*  389 */  _Binary_iRegP_iRegP_rule,
  /*  390 */  _Binary_iRegP_iRegP_rule,
  /*  391 */  _Binary_iRegP_immP0_rule,
  /*  392 */  _Binary_iRegP_immP0_rule,
  /*  393 */  _Binary_immP0_iRegP_rule,
  /*  394 */  _Binary_immP0_iRegP_rule,
  /*  395 */  _Binary_iRegN_iRegN_rule,
  /*  396 */  _Binary_iRegN_iRegN_rule,
  /*  397 */  _Binary_iRegN_immN0_rule,
  /*  398 */  _Binary_iRegN_immN0_rule,
  /*  399 */  _Binary_immN0_iRegN_rule,
  /*  400 */  _Binary_immN0_iRegN_rule,
  /*  401 */  _Binary_vRegF_vRegF_rule,
  /*  402 */  _Binary_vRegF_vRegF_rule,
  /*  403 */  _Binary_vRegD_vRegD_rule,
  /*  404 */  _Binary_vRegD_vRegD_rule,
  /*  405 */  iRegIorL2I_rule,
  /*  406 */  immIAddSub_rule,
  /*  407 */  immIAddSub_rule,
  /*  408 */  iRegL_rule,
  /*  409 */  _ConvI2L_iRegIorL2I__rule,
  /*  410 */  _LShiftL_iRegL_immIScale_rule,
  /*  411 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  412 */  immI_rule,
  /*  413 */  immLAddSub_rule,
  /*  414 */  iRegL_rule,
  /*  415 */  immLAddSub_rule,
  /*  416 */  iRegIorL2I_rule,
  /*  417 */  immIAddSub_rule,
  /*  418 */  iRegL_rule,
  /*  419 */  immLAddSub_rule,
  /*  420 */  iRegIorL2I_rule,
  /*  421 */  iRegIorL2I_rule,
  /*  422 */  iRegIorL2I_rule,
  /*  423 */  _ConvI2L_iRegIorL2I__rule,
  /*  424 */  _ConvI2L_iRegIorL2I__rule,
  /*  425 */  iRegL_rule,
  /*  426 */  iRegL_rule,
  /*  427 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  428 */  iRegIorL2I_rule,
  /*  429 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  430 */  _MulL_iRegL_iRegL_rule,
  /*  431 */  iRegL_rule,
  /*  432 */  _MulL_iRegL_iRegL_rule,
  /*  433 */  iRegIorL2I_rule,
  /*  434 */  immI_31_rule,
  /*  435 */  _URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31_rule,
  /*  436 */  iRegIorL2I_rule,
  /*  437 */  iRegL_rule,
  /*  438 */  immL_63_rule,
  /*  439 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  440 */  iRegL_rule,
  /*  441 */  iRegIorL2I_rule,
  /*  442 */  iRegL_rule,
  /*  443 */  iRegIorL2I_rule,
  /*  444 */  immI_rule,
  /*  445 */  iRegIorL2I_rule,
  /*  446 */  immI_rule,
  /*  447 */  iRegIorL2I_rule,
  /*  448 */  immI_rule,
  /*  449 */  iRegIorL2I_rule,
  /*  450 */  immI_rule,
  /*  451 */  iRegIorL2I_rule,
  /*  452 */  immI_rule,
  /*  453 */  immI_rule,
  /*  454 */  iRegIorL2I_rule,
  /*  455 */  immI_rule,
  /*  456 */  immL_M1_rule,
  /*  457 */  immI_M1_rule,
  /*  458 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  459 */  iRegIorL2I_rule,
  /*  460 */  _XorL_iRegL_immL_M1_rule,
  /*  461 */  iRegL_rule,
  /*  462 */  _XorI_iRegIorL2I_immI_M1_rule,
  /*  463 */  iRegIorL2I_rule,
  /*  464 */  _XorL_iRegL_immL_M1_rule,
  /*  465 */  iRegL_rule,
  /*  466 */  _XorI_iRegIorL2I_iRegIorL2I_rule,
  /*  467 */  immI_M1_rule,
  /*  468 */  _XorL_iRegL_iRegL_rule,
  /*  469 */  immL_M1_rule,
  /*  470 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  471 */  iRegIorL2I_rule,
  /*  472 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  473 */  iRegL_rule,
  /*  474 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  475 */  iRegIorL2I_rule,
  /*  476 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  477 */  iRegL_rule,
  /*  478 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  479 */  iRegIorL2I_rule,
  /*  480 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  481 */  iRegL_rule,
  /*  482 */  _XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  483 */  immI_M1_rule,
  /*  484 */  _XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI_rule,
  /*  485 */  immI_M1_rule,
  /*  486 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  487 */  immL_M1_rule,
  /*  488 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  489 */  immL_M1_rule,
  /*  490 */  _XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  491 */  immI_M1_rule,
  /*  492 */  _XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI_rule,
  /*  493 */  immI_M1_rule,
  /*  494 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  495 */  immL_M1_rule,
  /*  496 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  497 */  immL_M1_rule,
  /*  498 */  _XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I_rule,
  /*  499 */  immI_M1_rule,
  /*  500 */  _XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI_rule,
  /*  501 */  immI_M1_rule,
  /*  502 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  503 */  immL_M1_rule,
  /*  504 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  505 */  immL_M1_rule,
  /*  506 */  _XorI__URShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  507 */  iRegIorL2I_rule,
  /*  508 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  509 */  iRegL_rule,
  /*  510 */  _XorI__RShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  511 */  iRegIorL2I_rule,
  /*  512 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  513 */  iRegL_rule,
  /*  514 */  _XorI__LShiftI_iRegIorL2I_immI_immI_M1_rule,
  /*  515 */  iRegIorL2I_rule,
  /*  516 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  517 */  iRegL_rule,
  /*  518 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  519 */  iRegIorL2I_rule,
  /*  520 */  _URShiftL_iRegL_immI_rule,
  /*  521 */  iRegL_rule,
  /*  522 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  523 */  iRegIorL2I_rule,
  /*  524 */  _RShiftL_iRegL_immI_rule,
  /*  525 */  iRegL_rule,
  /*  526 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  527 */  iRegIorL2I_rule,
  /*  528 */  _LShiftL_iRegL_immI_rule,
  /*  529 */  iRegL_rule,
  /*  530 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  531 */  iRegIorL2I_rule,
  /*  532 */  _URShiftL_iRegL_immI_rule,
  /*  533 */  iRegL_rule,
  /*  534 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  535 */  iRegIorL2I_rule,
  /*  536 */  _RShiftL_iRegL_immI_rule,
  /*  537 */  iRegL_rule,
  /*  538 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  539 */  iRegIorL2I_rule,
  /*  540 */  _LShiftL_iRegL_immI_rule,
  /*  541 */  iRegL_rule,
  /*  542 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  543 */  iRegIorL2I_rule,
  /*  544 */  _URShiftL_iRegL_immI_rule,
  /*  545 */  iRegL_rule,
  /*  546 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  547 */  iRegIorL2I_rule,
  /*  548 */  _RShiftL_iRegL_immI_rule,
  /*  549 */  iRegL_rule,
  /*  550 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  551 */  iRegIorL2I_rule,
  /*  552 */  _LShiftL_iRegL_immI_rule,
  /*  553 */  iRegL_rule,
  /*  554 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  555 */  iRegIorL2I_rule,
  /*  556 */  _URShiftL_iRegL_immI_rule,
  /*  557 */  iRegL_rule,
  /*  558 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  559 */  iRegIorL2I_rule,
  /*  560 */  _RShiftL_iRegL_immI_rule,
  /*  561 */  iRegL_rule,
  /*  562 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  563 */  iRegIorL2I_rule,
  /*  564 */  _LShiftL_iRegL_immI_rule,
  /*  565 */  iRegL_rule,
  /*  566 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  567 */  _URShiftL_iRegL_immI_rule,
  /*  568 */  _RShiftI_iRegIorL2I_immI_rule,
  /*  569 */  _RShiftL_iRegL_immI_rule,
  /*  570 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  571 */  _LShiftL_iRegL_immI_rule,
  /*  572 */  immI_rule,
  /*  573 */  immI_rule,
  /*  574 */  immI_rule,
  /*  575 */  immI_rule,
  /*  576 */  immI_bitmask_rule,
  /*  577 */  immL_bitmask_rule,
  /*  578 */  0,
  /*  579 */  _URShiftL_iRegL_immI_rule,
  /*  580 */  _LShiftL_iRegL_immI_rule,
  /*  581 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  582 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  583 */  _URShiftL_iRegL_immI_rule,
  /*  584 */  _LShiftL_iRegL_immI_rule,
  /*  585 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  586 */  _LShiftI_iRegIorL2I_immI_rule,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  590 */  _LShiftL_iRegL_iRegI_rule,
  /*  591 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  592 */  _LShiftL_iRegL_iRegI_rule,
  /*  593 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  594 */  _LShiftI_iRegL_iRegI_rule,
  /*  595 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  596 */  _LShiftI_iRegL_iRegI_rule,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  600 */  _URShiftL_iRegL_iRegI_rule,
  /*  601 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  602 */  _URShiftL_iRegL_iRegI_rule,
  /*  603 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  604 */  _URShiftI_iRegL_iRegI_rule,
  /*  605 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  606 */  _URShiftI_iRegL_iRegI_rule,
  /*  607 */  _ConvI2L_iRegIorL2I__rule,
  /*  608 */  iRegL_rule,
  /*  609 */  _ConvI2L_iRegIorL2I__rule,
  /*  610 */  _RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16_rule,
  /*  611 */  iRegIorL2I_rule,
  /*  612 */  _RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  613 */  iRegIorL2I_rule,
  /*  614 */  _URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24_rule,
  /*  615 */  iRegIorL2I_rule,
  /*  616 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  617 */  iRegL_rule,
  /*  618 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  619 */  iRegL_rule,
  /*  620 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  621 */  iRegL_rule,
  /*  622 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  623 */  iRegL_rule,
  /*  624 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  625 */  iRegIorL2I_rule,
  /*  626 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  627 */  iRegIorL2I_rule,
  /*  628 */  _AndL_iRegL_immL_255_rule,
  /*  629 */  iRegL_rule,
  /*  630 */  _AndL_iRegL_immL_65535_rule,
  /*  631 */  iRegL_rule,
  /*  632 */  _AndL_iRegL_immL_4294967295_rule,
  /*  633 */  iRegL_rule,
  /*  634 */  _AndI_iRegIorL2I_immI_255_rule,
  /*  635 */  _AndI_iRegIorL2I_immI_65535_rule,
  /*  636 */  _AndL_iRegL_immL_255_rule,
  /*  637 */  _AndL_iRegL_immL_65535_rule,
  /*  638 */  _AndL_iRegL_immL_4294967295_rule,
  /*  639 */  vRegF_rule,
  /*  640 */  vRegD_rule,
  /*  641 */  vRegF_rule,
  /*  642 */  vRegD_rule,
  /*  643 */  vRegF_rule,
  /*  644 */  vRegD_rule,
  /*  645 */  vRegF_rule,
  /*  646 */  vRegD_rule,
  /*  647 */  0,
  /*  648 */  0,
  /*  649 */  iRegIorL2I_rule,
  /*  650 */  immILog_rule,
  /*  651 */  iRegIorL2I_rule,
  /*  652 */  immILog_rule,
  /*  653 */  iRegIorL2I_rule,
  /*  654 */  immILog_rule,
  /*  655 */  iRegL_rule,
  /*  656 */  immLLog_rule,
  /*  657 */  iRegL_rule,
  /*  658 */  immLLog_rule,
  /*  659 */  iRegL_rule,
  /*  660 */  immLLog_rule,
  /*  661 */  0,
  /*  662 */  immL_32bits_rule,
  /*  663 */  0,
  /*  664 */  0,
  /*  665 */  0,
  /*  666 */  0,
  /*  667 */  0,
  /*  668 */  0,
  /*  669 */  0,
  /*  670 */  0,
  /*  671 */  0,
  /*  672 */  0,
  /*  673 */  0,
  /*  674 */  0,
  /*  675 */  0,
  /*  676 */  0,
  /*  677 */  0,
  /*  678 */  0,
  /*  679 */  0,
  /*  680 */  iRegP_R10_rule,
  /*  681 */  vRegF_rule,
  /*  682 */  vRegD_rule,
  /*  683 */  immF0_rule,
  /*  684 */  immD0_rule,
  /*  685 */  iRegL_rule,
  /*  686 */  iRegIorL2I_rule,
  /*  687 */  immI0_rule,
  /*  688 */  iRegI_rule,
  /*  689 */  iRegI_rule,
  /*  690 */  0,
  /*  691 */  rFlagsReg_rule,
  /*  692 */  rFlagsRegU_rule,
  /*  693 */  _CmpI_iRegIorL2I_immI0_rule,
  /*  694 */  _CmpL_iRegL_immL0_rule,
  /*  695 */  _CmpP_iRegP_immP0_rule,
  /*  696 */  rFlagsReg_rule,
  /*  697 */  rFlagsRegU_rule,
  /*  698 */  0,
  /*  699 */  0,
  /*  700 */  0,
  /*  701 */  0,
  /*  702 */  0,
  /*  703 */  0,
  /*  704 */  0,
  /*  705 */  inline_cache_RegP_rule,
  /*  706 */  iRegP_R0_rule,
  /*  707 */  0,
  /*  708 */  0,
  /*  709 */  0,
  /*  710 */  0,
  /*  711 */  iRegP_R0_rule,
  /*  712 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  713 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  714 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  715 */  iRegI_R4_rule,
  /*  716 */  iRegP_R2_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMI_LE_4",
  /*   13 */  "IMMI_31",
  /*   14 */  "IMMI_8",
  /*   15 */  "IMMI_16",
  /*   16 */  "IMMI_24",
  /*   17 */  "IMMI_32",
  /*   18 */  "IMMI_48",
  /*   19 */  "IMMI_56",
  /*   20 */  "IMMI_64",
  /*   21 */  "IMMI_255",
  /*   22 */  "IMMI_65535",
  /*   23 */  "IMML_63",
  /*   24 */  "IMML_255",
  /*   25 */  "IMML_65535",
  /*   26 */  "IMML_4294967295",
  /*   27 */  "IMML_BITMASK",
  /*   28 */  "IMMI_BITMASK",
  /*   29 */  "IMMISCALE",
  /*   30 */  "IMMI26",
  /*   31 */  "IMMI19",
  /*   32 */  "IMMIU12",
  /*   33 */  "IMMLU12",
  /*   34 */  "IMMIOFFSET",
  /*   35 */  "IMMLOFFSET",
  /*   36 */  "IMMIADDSUB",
  /*   37 */  "IMMILOG",
  /*   38 */  "IMML",
  /*   39 */  "IMML0",
  /*   40 */  "IMML_1",
  /*   41 */  "IMML_M1",
  /*   42 */  "IMML_PC_OFF",
  /*   43 */  "IMMLADDSUB",
  /*   44 */  "IMMLLOG",
  /*   45 */  "IMML_32BITS",
  /*   46 */  "IMMP",
  /*   47 */  "IMMP0",
  /*   48 */  "IMMP_1",
  /*   49 */  "IMMPOLLPAGE",
  /*   50 */  "IMMBYTEMAPBASE",
  /*   51 */  "IMMP_M1",
  /*   52 */  "IMMP_M2",
  /*   53 */  "IMMD",
  /*   54 */  "IMMD0",
  /*   55 */  "IMMDPACKED",
  /*   56 */  "IMMF",
  /*   57 */  "IMMF0",
  /*   58 */  "IMMFPACKED",
  /*   59 */  "IMMN",
  /*   60 */  "IMMN0",
  /*   61 */  "IREGI",
  /*   62 */  "IREGINOSP",
  /*   63 */  "IREGL",
  /*   64 */  "IREGLNOSP",
  /*   65 */  "IREGP",
  /*   66 */  "IREGPNOSP",
  /*   67 */  "IREGP_R0",
  /*   68 */  "IREGP_R1",
  /*   69 */  "IREGP_R2",
  /*   70 */  "IREGP_R3",
  /*   71 */  "IREGP_R4",
  /*   72 */  "IREGP_R5",
  /*   73 */  "IREGP_R10",
  /*   74 */  "IREGL_R11",
  /*   75 */  "IREGP_FP",
  /*   76 */  "IREGI_R0",
  /*   77 */  "IREGI_R2",
  /*   78 */  "IREGI_R4",
  /*   79 */  "IREGN",
  /*   80 */  "IREGNNOSP",
  /*   81 */  "IREGIHEAPBASE",
  /*   82 */  "VREGF",
  /*   83 */  "VREGD",
  /*   84 */  "RFLAGSREG",
  /*   85 */  "RFLAGSREGU",
  /*   86 */  "INLINE_CACHE_REGP",
  /*   87 */  "INTERPRETER_METHOD_OOP_REGP",
  /*   88 */  "THREAD_REGP",
  /*   89 */  "LR_REGP",
  /*   90 */  "INDIRECT",
  /*   91 */  "INDINDEXSCALEDOFFSETI",
  /*   92 */  "INDINDEXSCALEDOFFSETL",
  /*   93 */  "INDINDEXOFFSETI2L",
  /*   94 */  "INDINDEXSCALEDOFFSETI2L",
  /*   95 */  "INDINDEXSCALEDI2L",
  /*   96 */  "INDINDEXSCALED",
  /*   97 */  "INDINDEX",
  /*   98 */  "INDOFFI",
  /*   99 */  "INDOFFL",
  /*  100 */  "INDIRECTN",
  /*  101 */  "INDINDEXSCALEDOFFSETIN",
  /*  102 */  "INDINDEXSCALEDOFFSETLN",
  /*  103 */  "INDINDEXOFFSETI2LN",
  /*  104 */  "INDINDEXSCALEDOFFSETI2LN",
  /*  105 */  "INDINDEXSCALEDI2LN",
  /*  106 */  "INDINDEXSCALEDN",
  /*  107 */  "INDINDEXN",
  /*  108 */  "INDOFFIN",
  /*  109 */  "INDOFFLN",
  /*  110 */  "THREAD_ANCHOR_PC",
  /*  111 */  "STACKSLOTP",
  /*  112 */  "STACKSLOTI",
  /*  113 */  "STACKSLOTF",
  /*  114 */  "STACKSLOTD",
  /*  115 */  "STACKSLOTL",
  /*  116 */  "CMPOP",
  /*  117 */  "CMPOPU",
  /*  118 */  "IREGL2I",
  // last operand
  /*  119 */  "MEMORY",
  /*  120 */  "IREGIORL2I",
  // last operand class
  /*  121 */  "_LShiftL_iRegL_immIScale",
  /*  122 */  "_AddP_iRegP__LShiftL_iRegL_immIScale",
  /*  123 */  "_ConvI2L_iRegI_",
  /*  124 */  "_AddP_iRegP__ConvI2L_iRegI_",
  /*  125 */  "_LShiftL__ConvI2L_iRegI__immIScale",
  /*  126 */  "_AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale",
  /*  127 */  "_DecodeN_iRegN_",
  /*  128 */  "_AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale",
  /*  129 */  "_AddP__DecodeN_iRegN___ConvI2L_iRegI_",
  /*  130 */  "_AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale",
  /*  131 */  "_LoadB_memory_",
  /*  132 */  "_LoadUB_memory_",
  /*  133 */  "_LoadS_memory_",
  /*  134 */  "_LoadUS_memory_",
  /*  135 */  "_LoadI_memory_",
  /*  136 */  "_ConvI2L__LoadI_memory__",
  /*  137 */  "_CastP2X_iRegP_",
  /*  138 */  "_CastP2X__DecodeN_iRegN__",
  /*  139 */  "_Binary_iRegP_iRegP",
  /*  140 */  "_Binary_iRegLNoSp_iRegLNoSp",
  /*  141 */  "_Binary_iRegINoSp_iRegINoSp",
  /*  142 */  "_Binary_iRegNNoSp_iRegNNoSp",
  /*  143 */  "_Binary_cmpOp_rFlagsReg",
  /*  144 */  "_Binary_iRegIorL2I_iRegIorL2I",
  /*  145 */  "_Binary_cmpOpU_rFlagsRegU",
  /*  146 */  "_Binary_immI0_iRegIorL2I",
  /*  147 */  "_Binary_iRegIorL2I_immI0",
  /*  148 */  "_Binary_immI_1_immI0",
  /*  149 */  "_Binary_iRegL_iRegL",
  /*  150 */  "_Binary_iRegL_immL0",
  /*  151 */  "_Binary_immL0_iRegL",
  /*  152 */  "_Binary_iRegP_immP0",
  /*  153 */  "_Binary_immP0_iRegP",
  /*  154 */  "_Binary_iRegN_iRegN",
  /*  155 */  "_Binary_iRegN_immN0",
  /*  156 */  "_Binary_immN0_iRegN",
  /*  157 */  "_Binary_vRegF_vRegF",
  /*  158 */  "_Binary_vRegD_vRegD",
  /*  159 */  "_ConvL2I_iRegL_",
  /*  160 */  "_ConvI2L_iRegIorL2I_",
  /*  161 */  "_LShiftL__ConvI2L_iRegIorL2I__immIScale",
  /*  162 */  "_MulI_iRegIorL2I_iRegIorL2I",
  /*  163 */  "_MulL_iRegL_iRegL",
  /*  164 */  "_RShiftI_iRegIorL2I_immI_31",
  /*  165 */  "_URShiftI__RShiftI_iRegIorL2I_immI_31_immI_31",
  /*  166 */  "_RShiftL_iRegL_immL_63",
  /*  167 */  "_URShiftL__RShiftL_iRegL_immL_63_immL_63",
  /*  168 */  "_XorI_iRegIorL2I_immI_M1",
  /*  169 */  "_XorL_iRegL_immL_M1",
  /*  170 */  "_XorI_iRegIorL2I_iRegIorL2I",
  /*  171 */  "_XorL_iRegL_iRegL",
  /*  172 */  "_URShiftI_iRegIorL2I_immI",
  /*  173 */  "_XorI__URShiftI_iRegIorL2I_immI_immI_M1",
  /*  174 */  "_URShiftL_iRegL_immI",
  /*  175 */  "_XorL__URShiftL_iRegL_immI_immL_M1",
  /*  176 */  "_RShiftI_iRegIorL2I_immI",
  /*  177 */  "_XorI__RShiftI_iRegIorL2I_immI_immI_M1",
  /*  178 */  "_RShiftL_iRegL_immI",
  /*  179 */  "_XorL__RShiftL_iRegL_immI_immL_M1",
  /*  180 */  "_LShiftI_iRegIorL2I_immI",
  /*  181 */  "_XorI__LShiftI_iRegIorL2I_immI_immI_M1",
  /*  182 */  "_LShiftL_iRegL_immI",
  /*  183 */  "_XorL__LShiftL_iRegL_immI_immL_M1",
  /*  184 */  "_XorI__URShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  185 */  "_XorI_iRegIorL2I__URShiftI_iRegIorL2I_immI",
  /*  186 */  "_XorL__URShiftL_iRegL_immI_iRegL",
  /*  187 */  "_XorL_iRegL__URShiftL_iRegL_immI",
  /*  188 */  "_XorI__RShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  189 */  "_XorI_iRegIorL2I__RShiftI_iRegIorL2I_immI",
  /*  190 */  "_XorL__RShiftL_iRegL_immI_iRegL",
  /*  191 */  "_XorL_iRegL__RShiftL_iRegL_immI",
  /*  192 */  "_XorI__LShiftI_iRegIorL2I_immI_iRegIorL2I",
  /*  193 */  "_XorI_iRegIorL2I__LShiftI_iRegIorL2I_immI",
  /*  194 */  "_XorL__LShiftL_iRegL_immI_iRegL",
  /*  195 */  "_XorL_iRegL__LShiftL_iRegL_immI",
  /*  196 */  "_AndI__URShiftI_iRegIorL2I_immI_immI_bitmask",
  /*  197 */  "_LShiftL_iRegL_iRegI",
  /*  198 */  "_SubI_immI_64_iRegI",
  /*  199 */  "_URShiftL_iRegL__SubI_immI_64_iRegI",
  /*  200 */  "_SubI_immI0_iRegI",
  /*  201 */  "_URShiftL_iRegL__SubI_immI0_iRegI",
  /*  202 */  "_LShiftI_iRegL_iRegI",
  /*  203 */  "_SubI_immI_32_iRegI",
  /*  204 */  "_URShiftI_iRegL__SubI_immI_32_iRegI",
  /*  205 */  "_URShiftI_iRegL__SubI_immI0_iRegI",
  /*  206 */  "_URShiftL_iRegL_iRegI",
  /*  207 */  "_LShiftL_iRegL__SubI_immI_64_iRegI",
  /*  208 */  "_LShiftL_iRegL__SubI_immI0_iRegI",
  /*  209 */  "_URShiftI_iRegL_iRegI",
  /*  210 */  "_LShiftI_iRegL__SubI_immI_32_iRegI",
  /*  211 */  "_LShiftI_iRegL__SubI_immI0_iRegI",
  /*  212 */  "_LShiftI_iRegIorL2I_immI_16",
  /*  213 */  "_RShiftI__LShiftI_iRegIorL2I_immI_16_immI_16",
  /*  214 */  "_LShiftI_iRegIorL2I_immI_24",
  /*  215 */  "_RShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  216 */  "_URShiftI__LShiftI_iRegIorL2I_immI_24_immI_24",
  /*  217 */  "_LShiftL_iRegL_immI_48",
  /*  218 */  "_RShiftL__LShiftL_iRegL_immI_48_immI_48",
  /*  219 */  "_LShiftL_iRegL_immI_32",
  /*  220 */  "_RShiftL__LShiftL_iRegL_immI_32_immI_32",
  /*  221 */  "_LShiftL_iRegL_immI_56",
  /*  222 */  "_RShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  223 */  "_URShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  224 */  "_AndI_iRegIorL2I_immI_255",
  /*  225 */  "_AndI_iRegIorL2I_immI_65535",
  /*  226 */  "_AndL_iRegL_immL_255",
  /*  227 */  "_AndL_iRegL_immL_65535",
  /*  228 */  "_AndL_iRegL_immL_4294967295",
  /*  229 */  "_ConvF2D_vRegF_",
  /*  230 */  "_SqrtD__ConvF2D_vRegF__",
  /*  231 */  "_CmpI_iRegIorL2I_immI0",
  /*  232 */  "_CmpL_iRegL_immL0",
  /*  233 */  "_CmpP_iRegP_immP0",
  /*  234 */  "_PartialSubtypeCheck_iRegP_R4_iRegP_R0",
  /*  235 */  "_Binary_iRegP_R1_iRegI_R2",
  /*  236 */  "_Binary_iRegP_R3_iRegI_R4",
  /*  237 */  "_Binary_iRegP_R1_iRegI_R4",
  /*  238 */  "_Binary_iRegP_R3_iRegI_R2",
  /*  239 */  "_Binary_iRegP_R3_immI_le_4",
  /*  240 */  "_Binary_iRegP_R1_iRegP_R3",
  // last internally defined operand
  /*  241 */  "loadConI",
  /*  242 */  "loadConL",
  /*  243 */  "loadConP",
  /*  244 */  "loadConP0",
  /*  245 */  "loadConP1",
  /*  246 */  "loadConPollPage",
  /*  247 */  "loadByteMapBase",
  /*  248 */  "loadConN",
  /*  249 */  "loadConN0",
  /*  250 */  "loadConF_packed",
  /*  251 */  "loadConF",
  /*  252 */  "loadConD_packed",
  /*  253 */  "loadConD",
  /*  254 */  "countLeadingZerosI",
  /*  255 */  "countLeadingZerosL",
  /*  256 */  "countTrailingZerosI",
  /*  257 */  "countTrailingZerosL",
  /*  258 */  "castX2P",
  /*  259 */  "castP2X",
  /*  260 */  "checkCastPP",
  /*  261 */  "castPP",
  /*  262 */  "castII",
  /*  263 */  "storePConditional",
  /*  264 */  "storeLConditional",
  /*  265 */  "storeIConditional",
  /*  266 */  "negF_reg_reg",
  /*  267 */  "negD_reg_reg",
  /*  268 */  "absF_reg",
  /*  269 */  "absD_reg",
  /*  270 */  "MoveF2I_stack_reg",
  /*  271 */  "MoveI2F_stack_reg",
  /*  272 */  "MoveD2L_stack_reg",
  /*  273 */  "MoveL2D_stack_reg",
  /*  274 */  "MoveF2I_reg_reg",
  /*  275 */  "MoveI2F_reg_reg",
  /*  276 */  "MoveD2L_reg_reg",
  /*  277 */  "MoveL2D_reg_reg",
  /*  278 */  "compI_reg_reg",
  /*  279 */  "compI_reg_immI0",
  /*  280 */  "compI_reg_immIAddSub",
  /*  281 */  "compI_reg_immI",
  /*  282 */  "compU_reg_reg",
  /*  283 */  "compU_reg_immI0",
  /*  284 */  "compU_reg_immIAddSub",
  /*  285 */  "compU_reg_immI",
  /*  286 */  "compL_reg_reg",
  /*  287 */  "compL_reg_immI0",
  /*  288 */  "compL_reg_immLAddSub",
  /*  289 */  "compL_reg_immL",
  /*  290 */  "compP_reg_reg",
  /*  291 */  "compN_reg_reg",
  /*  292 */  "testP_reg",
  /*  293 */  "testN_reg",
  /*  294 */  "compF_reg_reg",
  /*  295 */  "compF_reg_zero",
  /*  296 */  "compD_reg_reg",
  /*  297 */  "compD_reg_zero",
  /*  298 */  "cmpFastLock",
  /*  299 */  "cmpFastUnlock",
  /*  300 */  "partialSubtypeCheckVsZero",
  /*  301 */  "tlsLoadP",
  /*  302 */  "loadB",
  /*  303 */  "loadB2L",
  /*  304 */  "loadUB",
  /*  305 */  "loadUB2L",
  /*  306 */  "loadS",
  /*  307 */  "loadS2L",
  /*  308 */  "loadUS",
  /*  309 */  "loadUS2L",
  /*  310 */  "loadI",
  /*  311 */  "loadI2L",
  /*  312 */  "loadUI2L",
  /*  313 */  "loadL",
  /*  314 */  "loadRange",
  /*  315 */  "loadP",
  /*  316 */  "loadN",
  /*  317 */  "loadKlass",
  /*  318 */  "loadNKlass",
  /*  319 */  "loadF",
  /*  320 */  "loadD",
  /*  321 */  "storeimmCM0",
  /*  322 */  "storeB",
  /*  323 */  "storeimmB0",
  /*  324 */  "storeC",
  /*  325 */  "storeimmC0",
  /*  326 */  "storeI",
  /*  327 */  "storeimmI0",
  /*  328 */  "storeL",
  /*  329 */  "storeimmL0",
  /*  330 */  "storeP",
  /*  331 */  "storeimmP0",
  /*  332 */  "storeLastJavaPC_no_retaddr",
  /*  333 */  "storeLastJavaPC_with_retaddr",
  /*  334 */  "storeN",
  /*  335 */  "storeImmN0",
  /*  336 */  "storeF",
  /*  337 */  "storeD",
  /*  338 */  "prefetchr",
  /*  339 */  "prefetchw",
  /*  340 */  "prefetchnta",
  /*  341 */  "bytes_reverse_int",
  /*  342 */  "bytes_reverse_long",
  /*  343 */  "bytes_reverse_unsigned_short",
  /*  344 */  "bytes_reverse_short",
  /*  345 */  "membar_acquire",
  /*  346 */  "membar_release",
  /*  347 */  "membar_volatile",
  /*  348 */  "unnecessary_membar_volatile",
  /*  349 */  "membar_storestore",
  /*  350 */  "membar_acquire_lock",
  /*  351 */  "membar_release_lock",
  /*  352 */  "convP2I",
  /*  353 */  "convN2I",
  /*  354 */  "encodeHeapOop",
  /*  355 */  "encodeHeapOop_not_null",
  /*  356 */  "decodeHeapOop",
  /*  357 */  "decodeHeapOop_not_null",
  /*  358 */  "loadPLocked",
  /*  359 */  "compareAndSwapI",
  /*  360 */  "compareAndSwapL",
  /*  361 */  "compareAndSwapP",
  /*  362 */  "compareAndSwapN",
  /*  363 */  "get_and_setI",
  /*  364 */  "get_and_setL",
  /*  365 */  "get_and_setN",
  /*  366 */  "get_and_setP",
  /*  367 */  "get_and_addL",
  /*  368 */  "get_and_addL_no_res",
  /*  369 */  "get_and_addLi",
  /*  370 */  "get_and_addLi_no_res",
  /*  371 */  "get_and_addI",
  /*  372 */  "get_and_addI_no_res",
  /*  373 */  "get_and_addIi",
  /*  374 */  "get_and_addIi_no_res",
  /*  375 */  "cmovI_reg_reg",
  /*  376 */  "cmovUI_reg_reg",
  /*  377 */  "cmovI_zero_reg",
  /*  378 */  "cmovUI_zero_reg",
  /*  379 */  "cmovI_reg_zero",
  /*  380 */  "cmovUI_reg_zero",
  /*  381 */  "cmovI_reg_zero_one",
  /*  382 */  "cmovUI_reg_zero_one",
  /*  383 */  "cmovL_reg_reg",
  /*  384 */  "cmovUL_reg_reg",
  /*  385 */  "cmovL_reg_zero",
  /*  386 */  "cmovUL_reg_zero",
  /*  387 */  "cmovL_zero_reg",
  /*  388 */  "cmovUL_zero_reg",
  /*  389 */  "cmovP_reg_reg",
  /*  390 */  "cmovUP_reg_reg",
  /*  391 */  "cmovP_reg_zero",
  /*  392 */  "cmovUP_reg_zero",
  /*  393 */  "cmovP_zero_reg",
  /*  394 */  "cmovUP_zero_reg",
  /*  395 */  "cmovN_reg_reg",
  /*  396 */  "cmovUN_reg_reg",
  /*  397 */  "cmovN_reg_zero",
  /*  398 */  "cmovUN_reg_zero",
  /*  399 */  "cmovN_zero_reg",
  /*  400 */  "cmovUN_zero_reg",
  /*  401 */  "cmovF_reg",
  /*  402 */  "cmovUF_reg",
  /*  403 */  "cmovD_reg",
  /*  404 */  "cmovUD_reg",
  /*  405 */  "addI_reg_reg",
  /*  406 */  "addI_reg_imm",
  /*  407 */  "addI_reg_imm_i2l",
  /*  408 */  "addP_reg_reg",
  /*  409 */  "addP_reg_reg_ext",
  /*  410 */  "addP_reg_reg_lsl",
  /*  411 */  "addP_reg_reg_ext_shift",
  /*  412 */  "lshift_ext",
  /*  413 */  "addP_reg_imm",
  /*  414 */  "addL_reg_reg",
  /*  415 */  "addL_reg_imm",
  /*  416 */  "subI_reg_reg",
  /*  417 */  "subI_reg_imm",
  /*  418 */  "subL_reg_reg",
  /*  419 */  "subL_reg_imm",
  /*  420 */  "negI_reg",
  /*  421 */  "negL_reg",
  /*  422 */  "mulI",
  /*  423 */  "smulI",
  /*  424 */  "smulI_0",
  /*  425 */  "mulL",
  /*  426 */  "mulHiL_rReg",
  /*  427 */  "maddI",
  /*  428 */  "maddI_0",
  /*  429 */  "msubI",
  /*  430 */  "maddL",
  /*  431 */  "maddL_0",
  /*  432 */  "msubL",
  /*  433 */  "divI",
  /*  434 */  "signExtract",
  /*  435 */  "div2Round",
  /*  436 */  "div2Round_0",
  /*  437 */  "divL",
  /*  438 */  "signExtractL",
  /*  439 */  "div2RoundL",
  /*  440 */  "div2RoundL_0",
  /*  441 */  "modI",
  /*  442 */  "modL",
  /*  443 */  "lShiftI_reg_reg",
  /*  444 */  "lShiftI_reg_imm",
  /*  445 */  "urShiftI_reg_reg",
  /*  446 */  "urShiftI_reg_imm",
  /*  447 */  "rShiftI_reg_reg",
  /*  448 */  "rShiftI_reg_imm",
  /*  449 */  "lShiftL_reg_reg",
  /*  450 */  "lShiftL_reg_imm",
  /*  451 */  "urShiftL_reg_reg",
  /*  452 */  "urShiftL_reg_imm",
  /*  453 */  "urShiftP_reg_imm",
  /*  454 */  "rShiftL_reg_reg",
  /*  455 */  "rShiftL_reg_imm",
  /*  456 */  "regL_not_reg",
  /*  457 */  "regI_not_reg",
  /*  458 */  "AndI_reg_not_reg",
  /*  459 */  "AndI_reg_not_reg_0",
  /*  460 */  "AndL_reg_not_reg",
  /*  461 */  "AndL_reg_not_reg_0",
  /*  462 */  "OrI_reg_not_reg",
  /*  463 */  "OrI_reg_not_reg_0",
  /*  464 */  "OrL_reg_not_reg",
  /*  465 */  "OrL_reg_not_reg_0",
  /*  466 */  "XorI_reg_not_reg",
  /*  467 */  "XorI_reg_not_reg_0",
  /*  468 */  "XorL_reg_not_reg",
  /*  469 */  "XorL_reg_not_reg_0",
  /*  470 */  "AndI_reg_URShift_not_reg",
  /*  471 */  "AndI_reg_URShift_not_reg_0",
  /*  472 */  "AndL_reg_URShift_not_reg",
  /*  473 */  "AndL_reg_URShift_not_reg_0",
  /*  474 */  "AndI_reg_RShift_not_reg",
  /*  475 */  "AndI_reg_RShift_not_reg_0",
  /*  476 */  "AndL_reg_RShift_not_reg",
  /*  477 */  "AndL_reg_RShift_not_reg_0",
  /*  478 */  "AndI_reg_LShift_not_reg",
  /*  479 */  "AndI_reg_LShift_not_reg_0",
  /*  480 */  "AndL_reg_LShift_not_reg",
  /*  481 */  "AndL_reg_LShift_not_reg_0",
  /*  482 */  "XorI_reg_URShift_not_reg",
  /*  483 */  "XorI_reg_URShift_not_reg_1",
  /*  484 */  "XorI_reg_URShift_not_reg_0",
  /*  485 */  "XorI_reg_URShift_not_reg_2",
  /*  486 */  "XorL_reg_URShift_not_reg",
  /*  487 */  "XorL_reg_URShift_not_reg_1",
  /*  488 */  "XorL_reg_URShift_not_reg_0",
  /*  489 */  "XorL_reg_URShift_not_reg_2",
  /*  490 */  "XorI_reg_RShift_not_reg",
  /*  491 */  "XorI_reg_RShift_not_reg_1",
  /*  492 */  "XorI_reg_RShift_not_reg_0",
  /*  493 */  "XorI_reg_RShift_not_reg_2",
  /*  494 */  "XorL_reg_RShift_not_reg",
  /*  495 */  "XorL_reg_RShift_not_reg_1",
  /*  496 */  "XorL_reg_RShift_not_reg_0",
  /*  497 */  "XorL_reg_RShift_not_reg_2",
  /*  498 */  "XorI_reg_LShift_not_reg",
  /*  499 */  "XorI_reg_LShift_not_reg_1",
  /*  500 */  "XorI_reg_LShift_not_reg_0",
  /*  501 */  "XorI_reg_LShift_not_reg_2",
  /*  502 */  "XorL_reg_LShift_not_reg",
  /*  503 */  "XorL_reg_LShift_not_reg_1",
  /*  504 */  "XorL_reg_LShift_not_reg_0",
  /*  505 */  "XorL_reg_LShift_not_reg_2",
  /*  506 */  "OrI_reg_URShift_not_reg",
  /*  507 */  "OrI_reg_URShift_not_reg_0",
  /*  508 */  "OrL_reg_URShift_not_reg",
  /*  509 */  "OrL_reg_URShift_not_reg_0",
  /*  510 */  "OrI_reg_RShift_not_reg",
  /*  511 */  "OrI_reg_RShift_not_reg_0",
  /*  512 */  "OrL_reg_RShift_not_reg",
  /*  513 */  "OrL_reg_RShift_not_reg_0",
  /*  514 */  "OrI_reg_LShift_not_reg",
  /*  515 */  "OrI_reg_LShift_not_reg_0",
  /*  516 */  "OrL_reg_LShift_not_reg",
  /*  517 */  "OrL_reg_LShift_not_reg_0",
  /*  518 */  "AndI_reg_URShift_reg",
  /*  519 */  "AndI_reg_URShift_reg_0",
  /*  520 */  "AndL_reg_URShift_reg",
  /*  521 */  "AndL_reg_URShift_reg_0",
  /*  522 */  "AndI_reg_RShift_reg",
  /*  523 */  "AndI_reg_RShift_reg_0",
  /*  524 */  "AndL_reg_RShift_reg",
  /*  525 */  "AndL_reg_RShift_reg_0",
  /*  526 */  "AndI_reg_LShift_reg",
  /*  527 */  "AndI_reg_LShift_reg_0",
  /*  528 */  "AndL_reg_LShift_reg",
  /*  529 */  "AndL_reg_LShift_reg_0",
  /*  530 */  "XorI_reg_URShift_reg",
  /*  531 */  "XorI_reg_URShift_reg_0",
  /*  532 */  "XorL_reg_URShift_reg",
  /*  533 */  "XorL_reg_URShift_reg_0",
  /*  534 */  "XorI_reg_RShift_reg",
  /*  535 */  "XorI_reg_RShift_reg_0",
  /*  536 */  "XorL_reg_RShift_reg",
  /*  537 */  "XorL_reg_RShift_reg_0",
  /*  538 */  "XorI_reg_LShift_reg",
  /*  539 */  "XorI_reg_LShift_reg_0",
  /*  540 */  "XorL_reg_LShift_reg",
  /*  541 */  "XorL_reg_LShift_reg_0",
  /*  542 */  "OrI_reg_URShift_reg",
  /*  543 */  "OrI_reg_URShift_reg_0",
  /*  544 */  "OrL_reg_URShift_reg",
  /*  545 */  "OrL_reg_URShift_reg_0",
  /*  546 */  "OrI_reg_RShift_reg",
  /*  547 */  "OrI_reg_RShift_reg_0",
  /*  548 */  "OrL_reg_RShift_reg",
  /*  549 */  "OrL_reg_RShift_reg_0",
  /*  550 */  "OrI_reg_LShift_reg",
  /*  551 */  "OrI_reg_LShift_reg_0",
  /*  552 */  "OrL_reg_LShift_reg",
  /*  553 */  "OrL_reg_LShift_reg_0",
  /*  554 */  "AddI_reg_URShift_reg",
  /*  555 */  "AddI_reg_URShift_reg_0",
  /*  556 */  "AddL_reg_URShift_reg",
  /*  557 */  "AddL_reg_URShift_reg_0",
  /*  558 */  "AddI_reg_RShift_reg",
  /*  559 */  "AddI_reg_RShift_reg_0",
  /*  560 */  "AddL_reg_RShift_reg",
  /*  561 */  "AddL_reg_RShift_reg_0",
  /*  562 */  "AddI_reg_LShift_reg",
  /*  563 */  "AddI_reg_LShift_reg_0",
  /*  564 */  "AddL_reg_LShift_reg",
  /*  565 */  "AddL_reg_LShift_reg_0",
  /*  566 */  "SubI_reg_URShift_reg",
  /*  567 */  "SubL_reg_URShift_reg",
  /*  568 */  "SubI_reg_RShift_reg",
  /*  569 */  "SubL_reg_RShift_reg",
  /*  570 */  "SubI_reg_LShift_reg",
  /*  571 */  "SubL_reg_LShift_reg",
  /*  572 */  "sbfmL",
  /*  573 */  "sbfmwI",
  /*  574 */  "ubfmL",
  /*  575 */  "ubfmwI",
  /*  576 */  "ubfxwI",
  /*  577 */  "ubfxL",
  /*  578 */  "ubfxIConvI2L",
  /*  579 */  "extrOrL",
  /*  580 */  "extrOrL_0",
  /*  581 */  "extrOrI",
  /*  582 */  "extrOrI_0",
  /*  583 */  "extrAddL",
  /*  584 */  "extrAddL_0",
  /*  585 */  "extrAddI",
  /*  586 */  "extrAddI_0",
  /*  587 */  "rolL_rReg",
  /*  588 */  "rolI_rReg",
  /*  589 */  "rolL_rReg_Var_C_64",
  /*  590 */  "rolL_rReg_Var_C_64_0",
  /*  591 */  "rolL_rReg_Var_C0",
  /*  592 */  "rolL_rReg_Var_C0_0",
  /*  593 */  "rolI_rReg_Var_C_32",
  /*  594 */  "rolI_rReg_Var_C_32_0",
  /*  595 */  "rolI_rReg_Var_C0",
  /*  596 */  "rolI_rReg_Var_C0_0",
  /*  597 */  "rorL_rReg",
  /*  598 */  "rorI_rReg",
  /*  599 */  "rorL_rReg_Var_C_64",
  /*  600 */  "rorL_rReg_Var_C_64_0",
  /*  601 */  "rorL_rReg_Var_C0",
  /*  602 */  "rorL_rReg_Var_C0_0",
  /*  603 */  "rorI_rReg_Var_C_32",
  /*  604 */  "rorI_rReg_Var_C_32_0",
  /*  605 */  "rorI_rReg_Var_C0",
  /*  606 */  "rorI_rReg_Var_C0_0",
  /*  607 */  "AddExtI",
  /*  608 */  "AddExtI_0",
  /*  609 */  "SubExtI",
  /*  610 */  "AddExtI_sxth",
  /*  611 */  "AddExtI_sxth_0",
  /*  612 */  "AddExtI_sxtb",
  /*  613 */  "AddExtI_sxtb_0",
  /*  614 */  "AddExtI_uxtb",
  /*  615 */  "AddExtI_uxtb_0",
  /*  616 */  "AddExtL_sxth",
  /*  617 */  "AddExtL_sxth_0",
  /*  618 */  "AddExtL_sxtw",
  /*  619 */  "AddExtL_sxtw_0",
  /*  620 */  "AddExtL_sxtb",
  /*  621 */  "AddExtL_sxtb_0",
  /*  622 */  "AddExtL_uxtb",
  /*  623 */  "AddExtL_uxtb_0",
  /*  624 */  "AddExtI_uxtb_and",
  /*  625 */  "AddExtI_uxtb_and_0",
  /*  626 */  "AddExtI_uxth_and",
  /*  627 */  "AddExtI_uxth_and_0",
  /*  628 */  "AddExtL_uxtb_and",
  /*  629 */  "AddExtL_uxtb_and_0",
  /*  630 */  "AddExtL_uxth_and",
  /*  631 */  "AddExtL_uxth_and_0",
  /*  632 */  "AddExtL_uxtw_and",
  /*  633 */  "AddExtL_uxtw_and_0",
  /*  634 */  "SubExtI_uxtb_and",
  /*  635 */  "SubExtI_uxth_and",
  /*  636 */  "SubExtL_uxtb_and",
  /*  637 */  "SubExtL_uxth_and",
  /*  638 */  "SubExtL_uxtw_and",
  /*  639 */  "addF_reg_reg",
  /*  640 */  "addD_reg_reg",
  /*  641 */  "subF_reg_reg",
  /*  642 */  "subD_reg_reg",
  /*  643 */  "mulF_reg_reg",
  /*  644 */  "mulD_reg_reg",
  /*  645 */  "divF_reg_reg",
  /*  646 */  "divD_reg_reg",
  /*  647 */  "sqrtD_reg",
  /*  648 */  "sqrtF_reg",
  /*  649 */  "andI_reg_reg",
  /*  650 */  "andI_reg_imm",
  /*  651 */  "orI_reg_reg",
  /*  652 */  "orI_reg_imm",
  /*  653 */  "xorI_reg_reg",
  /*  654 */  "xorI_reg_imm",
  /*  655 */  "andL_reg_reg",
  /*  656 */  "andL_reg_imm",
  /*  657 */  "orL_reg_reg",
  /*  658 */  "orL_reg_imm",
  /*  659 */  "xorL_reg_reg",
  /*  660 */  "xorL_reg_imm",
  /*  661 */  "convI2L_reg_reg",
  /*  662 */  "convUI2L_reg_reg",
  /*  663 */  "convL2I_reg",
  /*  664 */  "convI2B",
  /*  665 */  "convP2B",
  /*  666 */  "convD2F_reg",
  /*  667 */  "convF2D_reg",
  /*  668 */  "convF2I_reg_reg",
  /*  669 */  "convF2L_reg_reg",
  /*  670 */  "convI2F_reg_reg",
  /*  671 */  "convL2F_reg_reg",
  /*  672 */  "convD2I_reg_reg",
  /*  673 */  "convD2L_reg_reg",
  /*  674 */  "convI2D_reg_reg",
  /*  675 */  "convL2D_reg_reg",
  /*  676 */  "MoveF2I_reg_stack",
  /*  677 */  "MoveI2F_reg_stack",
  /*  678 */  "MoveD2L_reg_stack",
  /*  679 */  "MoveL2D_reg_stack",
  /*  680 */  "clearArray_reg_reg",
  /*  681 */  "compF3_reg_reg",
  /*  682 */  "compD3_reg_reg",
  /*  683 */  "compF3_reg_immF0",
  /*  684 */  "compD3_reg_immD0",
  /*  685 */  "cmpL3_reg_reg",
  /*  686 */  "cmpLTMask_reg_reg",
  /*  687 */  "cmpLTMask_reg_zero",
  /*  688 */  "minI_rReg",
  /*  689 */  "maxI_rReg",
  /*  690 */  "branch",
  /*  691 */  "branchCon",
  /*  692 */  "branchConU",
  /*  693 */  "cmpI_imm0_branch",
  /*  694 */  "cmpL_imm0_branch",
  /*  695 */  "cmpP_imm0_branch",
  /*  696 */  "branchLoopEnd",
  /*  697 */  "branchLoopEndU",
  /*  698 */  "safePoint",
  /*  699 */  "CallStaticJavaDirect",
  /*  700 */  "CallStaticJavaDirectHandle",
  /*  701 */  "CallDynamicJavaDirect",
  /*  702 */  "CallRuntimeDirect",
  /*  703 */  "CallLeafDirect",
  /*  704 */  "CallLeafNoFPDirect",
  /*  705 */  "TailCalljmpInd",
  /*  706 */  "TailjmpInd",
  /*  707 */  "CreateException",
  /*  708 */  "RethrowException",
  /*  709 */  "Ret",
  /*  710 */  "ShouldNotReachHere",
  /*  711 */  "partialSubtypeCheck",
  /*  712 */  "string_compare",
  /*  713 */  "string_indexof",
  /*  714 */  "string_indexof_con",
  /*  715 */  "string_equals",
  /*  716 */  "array_equals",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  true,
  /*   60 */  true,
  /*   61 */  false,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  true,
  /*  117 */  true,
  /*  118 */  false,
  // last operand
  /*  119 */  false,
  /*  120 */  false,
  // last operand class
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  // last internally defined operand
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // RegFlags: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // _last_machine_leaf: 13
  0, // AbsD: 14
  0, // AbsF: 15
  0, // AbsI: 16
  0, // AddD: 17
  0, // AddF: 18
  0, // AddI: 19
  0, // AddL: 20
  0, // AddP: 21
  0, // Allocate: 22
  0, // AllocateArray: 23
  0, // AndI: 24
  0, // AndL: 25
  0, // AryEq: 26
  0, // AtanD: 27
  1, // Binary: 28
  1, // Bool: 29
  0, // BoxLock: 30
  0, // ReverseBytesI: 31
  0, // ReverseBytesL: 32
  0, // ReverseBytesUS: 33
  0, // ReverseBytesS: 34
  0, // CProj: 35
  0, // CallDynamicJava: 36
  0, // CallJava: 37
  0, // CallLeaf: 38
  0, // CallLeafNoFP: 39
  0, // CallRuntime: 40
  0, // CallStaticJava: 41
  0, // CastII: 42
  0, // CastX2P: 43
  0, // CastP2X: 44
  0, // CastPP: 45
  0, // Catch: 46
  0, // CatchProj: 47
  0, // CheckCastPP: 48
  0, // ClearArray: 49
  0, // ConstraintCast: 50
  0, // CMoveD: 51
  0, // CMoveF: 52
  0, // CMoveI: 53
  0, // CMoveL: 54
  0, // CMoveP: 55
  0, // CMoveN: 56
  1, // CmpN: 57
  1, // CmpD: 58
  0, // CmpD3: 59
  1, // CmpF: 60
  0, // CmpF3: 61
  1, // CmpI: 62
  1, // CmpL: 63
  0, // CmpL3: 64
  0, // CmpLTMask: 65
  1, // CmpP: 66
  1, // CmpU: 67
  0, // CompareAndSwapI: 68
  0, // CompareAndSwapL: 69
  0, // CompareAndSwapP: 70
  0, // CompareAndSwapN: 71
  0, // GetAndAddI: 72
  0, // GetAndAddL: 73
  0, // GetAndSetI: 74
  0, // GetAndSetL: 75
  0, // GetAndSetP: 76
  0, // GetAndSetN: 77
  0, // Con: 78
  0, // ConN: 79
  0, // ConD: 80
  0, // ConF: 81
  0, // ConI: 82
  0, // ConL: 83
  0, // ConP: 84
  0, // Conv2B: 85
  0, // ConvD2F: 86
  0, // ConvD2I: 87
  0, // ConvD2L: 88
  0, // ConvF2D: 89
  0, // ConvF2I: 90
  0, // ConvF2L: 91
  0, // ConvI2D: 92
  0, // ConvI2F: 93
  0, // ConvI2L: 94
  0, // ConvL2D: 95
  0, // ConvL2F: 96
  0, // ConvL2I: 97
  0, // CosD: 98
  0, // CountedLoop: 99
  0, // CountedLoopEnd: 100
  0, // CountLeadingZerosI: 101
  0, // CountLeadingZerosL: 102
  0, // CountTrailingZerosI: 103
  0, // CountTrailingZerosL: 104
  0, // CreateEx: 105
  0, // DecodeN: 106
  0, // DivD: 107
  0, // DivF: 108
  0, // DivI: 109
  0, // DivL: 110
  0, // DivMod: 111
  0, // DivModI: 112
  0, // DivModL: 113
  0, // EncodeP: 114
  0, // ExpD: 115
  1, // FastLock: 116
  1, // FastUnlock: 117
  0, // Goto: 118
  0, // Halt: 119
  0, // If: 120
  0, // IfFalse: 121
  0, // IfTrue: 122
  0, // Initialize: 123
  0, // JProj: 124
  0, // Jump: 125
  0, // JumpProj: 126
  0, // LShiftI: 127
  0, // LShiftL: 128
  0, // LoadB: 129
  0, // LoadUB: 130
  0, // LoadUS: 131
  0, // LoadD: 132
  0, // LoadD_unaligned: 133
  0, // LoadF: 134
  0, // LoadI: 135
  0, // LoadKlass: 136
  0, // LoadNKlass: 137
  0, // LoadL: 138
  0, // LoadL_unaligned: 139
  0, // LoadPLocked: 140
  0, // LoadP: 141
  0, // LoadN: 142
  0, // LoadRange: 143
  0, // LoadS: 144
  0, // Lock: 145
  0, // LogD: 146
  0, // Log10D: 147
  0, // Loop: 148
  0, // LoopLimit: 149
  0, // Mach: 150
  0, // MachProj: 151
  0, // MaxI: 152
  0, // MemBarAcquire: 153
  0, // MemBarAcquireLock: 154
  0, // MemBarCPUOrder: 155
  0, // MemBarRelease: 156
  0, // MemBarReleaseLock: 157
  0, // MemBarVolatile: 158
  0, // MemBarStoreStore: 159
  0, // MergeMem: 160
  0, // MinI: 161
  0, // ModD: 162
  0, // ModF: 163
  0, // ModI: 164
  0, // ModL: 165
  0, // MoveI2F: 166
  0, // MoveF2I: 167
  0, // MoveL2D: 168
  0, // MoveD2L: 169
  0, // MulD: 170
  0, // MulF: 171
  0, // MulHiL: 172
  0, // MulI: 173
  0, // MulL: 174
  0, // Multi: 175
  0, // NegD: 176
  0, // NegF: 177
  0, // NeverBranch: 178
  0, // Opaque1: 179
  0, // Opaque2: 180
  0, // OrI: 181
  0, // OrL: 182
  0, // PCTable: 183
  0, // Parm: 184
  0, // PartialSubtypeCheck: 185
  0, // Phi: 186
  0, // PopCountI: 187
  0, // PopCountL: 188
  0, // PowD: 189
  0, // PrefetchAllocation: 190
  0, // PrefetchRead: 191
  0, // PrefetchWrite: 192
  0, // Proj: 193
  0, // RShiftI: 194
  0, // RShiftL: 195
  0, // Region: 196
  0, // Rethrow: 197
  0, // Return: 198
  0, // Root: 199
  0, // RoundDouble: 200
  0, // RoundFloat: 201
  0, // SafePoint: 202
  0, // SafePointScalarObject: 203
  0, // SCMemProj: 204
  0, // SinD: 205
  0, // SqrtD: 206
  0, // Start: 207
  0, // StartOSR: 208
  0, // StoreB: 209
  0, // StoreC: 210
  0, // StoreCM: 211
  0, // StorePConditional: 212
  0, // StoreIConditional: 213
  0, // StoreLConditional: 214
  0, // StoreD: 215
  0, // StoreF: 216
  0, // StoreI: 217
  0, // StoreL: 218
  0, // StoreP: 219
  0, // StoreN: 220
  0, // StrComp: 221
  0, // StrEquals: 222
  0, // StrIndexOf: 223
  0, // SubD: 224
  0, // SubF: 225
  0, // SubI: 226
  0, // SubL: 227
  0, // TailCall: 228
  0, // TailJump: 229
  0, // TanD: 230
  0, // ThreadLocal: 231
  0, // Unlock: 232
  0, // URShiftI: 233
  0, // URShiftL: 234
  0, // XorI: 235
  0, // XorL: 236
  0, // Vector: 237
  0, // AddVB: 238
  0, // AddVS: 239
  0, // AddVI: 240
  0, // AddVL: 241
  0, // AddVF: 242
  0, // AddVD: 243
  0, // SubVB: 244
  0, // SubVS: 245
  0, // SubVI: 246
  0, // SubVL: 247
  0, // SubVF: 248
  0, // SubVD: 249
  0, // MulVS: 250
  0, // MulVI: 251
  0, // MulVF: 252
  0, // MulVD: 253
  0, // DivVF: 254
  0, // DivVD: 255
  0, // LShiftCntV: 256
  0, // RShiftCntV: 257
  0, // LShiftVB: 258
  0, // LShiftVS: 259
  0, // LShiftVI: 260
  0, // LShiftVL: 261
  0, // RShiftVB: 262
  0, // RShiftVS: 263
  0, // RShiftVI: 264
  0, // RShiftVL: 265
  0, // URShiftVB: 266
  0, // URShiftVS: 267
  0, // URShiftVI: 268
  0, // URShiftVL: 269
  0, // AndV: 270
  0, // OrV: 271
  0, // XorV: 272
  0, // LoadVector: 273
  0, // StoreVector: 274
  0, // Pack: 275
  0, // PackB: 276
  0, // PackS: 277
  0, // PackI: 278
  0, // PackL: 279
  0, // PackF: 280
  0, // PackD: 281
  0, // Pack2L: 282
  0, // Pack2D: 283
  0, // ReplicateB: 284
  0, // ReplicateS: 285
  0, // ReplicateI: 286
  0, // ReplicateL: 287
  0, // ReplicateF: 288
  0, // ReplicateD: 289
  0, // Extract: 290
  0, // ExtractB: 291
  0, // ExtractUB: 292
  0, // ExtractC: 293
  0, // ExtractS: 294
  0, // ExtractI: 295
  0, // ExtractL: 296
  0, // ExtractF: 297
  0 // no trailing comma // ExtractD: 298
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R12",
  "R12_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R18",
  "R18_H",
  "R0",
  "R0_H",
  "R1",
  "R1_H",
  "R2",
  "R2_H",
  "R3",
  "R3_H",
  "R4",
  "R4_H",
  "R5",
  "R5_H",
  "R6",
  "R6_H",
  "R7",
  "R7_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R23",
  "R23_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R27",
  "R27_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "V16",
  "V16_H",
  "V17",
  "V17_H",
  "V18",
  "V18_H",
  "V19",
  "V19_H",
  "V20",
  "V20_H",
  "V21",
  "V21_H",
  "V22",
  "V22_H",
  "V23",
  "V23_H",
  "V24",
  "V24_H",
  "V25",
  "V25_H",
  "V26",
  "V26_H",
  "V27",
  "V27_H",
  "V28",
  "V28_H",
  "V29",
  "V29_H",
  "V30",
  "V30_H",
  "V31",
  "V31_H",
  "V0",
  "V0_H",
  "V1",
  "V1_H",
  "V2",
  "V2_H",
  "V3",
  "V3_H",
  "V4",
  "V4_H",
  "V5",
  "V5_H",
  "V6",
  "V6_H",
  "V7",
  "V7_H",
  "V8",
  "V8_H",
  "V9",
  "V9_H",
  "V10",
  "V10_H",
  "V11",
  "V11_H",
  "V12",
  "V12_H",
  "V13",
  "V13_H",
  "V14",
  "V14_H",
  "V15",
  "V15_H",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	r10->as_VMReg()        ,
	r10->as_VMReg()->next(),
	r11->as_VMReg()        ,
	r11->as_VMReg()->next(),
	r12->as_VMReg()        ,
	r12->as_VMReg()->next(),
	r13->as_VMReg()        ,
	r13->as_VMReg()->next(),
	r14->as_VMReg()        ,
	r14->as_VMReg()->next(),
	r15->as_VMReg()        ,
	r15->as_VMReg()->next(),
	r16->as_VMReg()        ,
	r16->as_VMReg()->next(),
	r17->as_VMReg()        ,
	r17->as_VMReg()->next(),
	r18->as_VMReg()        ,
	r18->as_VMReg()->next(),
	r0->as_VMReg()         ,
	r0->as_VMReg()->next() ,
	r1->as_VMReg()         ,
	r1->as_VMReg()->next() ,
	r2->as_VMReg()         ,
	r2->as_VMReg()->next() ,
	r3->as_VMReg()         ,
	r3->as_VMReg()->next() ,
	r4->as_VMReg()         ,
	r4->as_VMReg()->next() ,
	r5->as_VMReg()         ,
	r5->as_VMReg()->next() ,
	r6->as_VMReg()         ,
	r6->as_VMReg()->next() ,
	r7->as_VMReg()         ,
	r7->as_VMReg()->next() ,
	r19->as_VMReg()        ,
	r19->as_VMReg()->next(),
	r20->as_VMReg()        ,
	r20->as_VMReg()->next(),
	r21->as_VMReg()        ,
	r21->as_VMReg()->next(),
	r22->as_VMReg()        ,
	r22->as_VMReg()->next(),
	r23->as_VMReg()        ,
	r23->as_VMReg()->next(),
	r24->as_VMReg()        ,
	r24->as_VMReg()->next(),
	r25->as_VMReg()        ,
	r25->as_VMReg()->next(),
	r26->as_VMReg()        ,
	r26->as_VMReg()->next(),
	r27->as_VMReg()        ,
	r27->as_VMReg()->next(),
	r28->as_VMReg()        ,
	r28->as_VMReg()->next(),
	r29->as_VMReg()        ,
	r29->as_VMReg()->next(),
	r30->as_VMReg()        ,
	r30->as_VMReg()->next(),
	r31_sp->as_VMReg()     ,
	r31_sp->as_VMReg()->next(),
	v16->as_VMReg()        ,
	v16->as_VMReg()->next(),
	v17->as_VMReg()        ,
	v17->as_VMReg()->next(),
	v18->as_VMReg()        ,
	v18->as_VMReg()->next(),
	v19->as_VMReg()        ,
	v19->as_VMReg()->next(),
	v20->as_VMReg()        ,
	v20->as_VMReg()->next(),
	v21->as_VMReg()        ,
	v21->as_VMReg()->next(),
	v22->as_VMReg()        ,
	v22->as_VMReg()->next(),
	v23->as_VMReg()        ,
	v23->as_VMReg()->next(),
	v24->as_VMReg()        ,
	v24->as_VMReg()->next(),
	v25->as_VMReg()        ,
	v25->as_VMReg()->next(),
	v26->as_VMReg()        ,
	v26->as_VMReg()->next(),
	v27->as_VMReg()        ,
	v27->as_VMReg()->next(),
	v28->as_VMReg()        ,
	v28->as_VMReg()->next(),
	v29->as_VMReg()        ,
	v29->as_VMReg()->next(),
	v30->as_VMReg()        ,
	v30->as_VMReg()->next(),
	v31->as_VMReg()        ,
	v31->as_VMReg()->next(),
	v0->as_VMReg()         ,
	v0->as_VMReg()->next() ,
	v1->as_VMReg()         ,
	v1->as_VMReg()->next() ,
	v2->as_VMReg()         ,
	v2->as_VMReg()->next() ,
	v3->as_VMReg()         ,
	v3->as_VMReg()->next() ,
	v4->as_VMReg()         ,
	v4->as_VMReg()->next() ,
	v5->as_VMReg()         ,
	v5->as_VMReg()->next() ,
	v6->as_VMReg()         ,
	v6->as_VMReg()->next() ,
	v7->as_VMReg()         ,
	v7->as_VMReg()->next() ,
	v8->as_VMReg()         ,
	v8->as_VMReg()->next() ,
	v9->as_VMReg()         ,
	v9->as_VMReg()->next() ,
	v10->as_VMReg()        ,
	v10->as_VMReg()->next(),
	v11->as_VMReg()        ,
	v11->as_VMReg()->next(),
	v12->as_VMReg()        ,
	v12->as_VMReg()->next(),
	v13->as_VMReg()        ,
	v13->as_VMReg()->next(),
	v14->as_VMReg()        ,
	v14->as_VMReg()->next(),
	v15->as_VMReg()        ,
	v15->as_VMReg()->next(),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x1',  // R1
  (unsigned char)'\x1',  // R1_H
  (unsigned char)'\x2',  // R2
  (unsigned char)'\x2',  // R2_H
  (unsigned char)'\x3',  // R3
  (unsigned char)'\x3',  // R3_H
  (unsigned char)'\x4',  // R4
  (unsigned char)'\x4',  // R4_H
  (unsigned char)'\x5',  // R5
  (unsigned char)'\x5',  // R5_H
  (unsigned char)'\x6',  // R6
  (unsigned char)'\x6',  // R6_H
  (unsigned char)'\x7',  // R7
  (unsigned char)'\x7',  // R7_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\x10',  // V16
  (unsigned char)'\x10',  // V16_H
  (unsigned char)'\x11',  // V17
  (unsigned char)'\x11',  // V17_H
  (unsigned char)'\x12',  // V18
  (unsigned char)'\x12',  // V18_H
  (unsigned char)'\x13',  // V19
  (unsigned char)'\x13',  // V19_H
  (unsigned char)'\x14',  // V20
  (unsigned char)'\x14',  // V20_H
  (unsigned char)'\x15',  // V21
  (unsigned char)'\x15',  // V21_H
  (unsigned char)'\x16',  // V22
  (unsigned char)'\x16',  // V22_H
  (unsigned char)'\x17',  // V23
  (unsigned char)'\x17',  // V23_H
  (unsigned char)'\x18',  // V24
  (unsigned char)'\x18',  // V24_H
  (unsigned char)'\x19',  // V25
  (unsigned char)'\x19',  // V25_H
  (unsigned char)'\x1A',  // V26
  (unsigned char)'\x1A',  // V26_H
  (unsigned char)'\x1B',  // V27
  (unsigned char)'\x1B',  // V27_H
  (unsigned char)'\x1C',  // V28
  (unsigned char)'\x1C',  // V28_H
  (unsigned char)'\x1D',  // V29
  (unsigned char)'\x1D',  // V29_H
  (unsigned char)'\x1E',  // V30
  (unsigned char)'\x1E',  // V30_H
  (unsigned char)'\x1F',  // V31
  (unsigned char)'\x1F',  // V31_H
  (unsigned char)'\x0',  // V0
  (unsigned char)'\x0',  // V0_H
  (unsigned char)'\x1',  // V1
  (unsigned char)'\x1',  // V1_H
  (unsigned char)'\x2',  // V2
  (unsigned char)'\x2',  // V2_H
  (unsigned char)'\x3',  // V3
  (unsigned char)'\x3',  // V3_H
  (unsigned char)'\x4',  // V4
  (unsigned char)'\x4',  // V4_H
  (unsigned char)'\x5',  // V5
  (unsigned char)'\x5',  // V5_H
  (unsigned char)'\x6',  // V6
  (unsigned char)'\x6',  // V6_H
  (unsigned char)'\x7',  // V7
  (unsigned char)'\x7',  // V7_H
  (unsigned char)'\x8',  // V8
  (unsigned char)'\x8',  // V8_H
  (unsigned char)'\x9',  // V9
  (unsigned char)'\x9',  // V9_H
  (unsigned char)'\xA',  // V10
  (unsigned char)'\xA',  // V10_H
  (unsigned char)'\xB',  // V11
  (unsigned char)'\xB',  // V11_H
  (unsigned char)'\xC',  // V12
  (unsigned char)'\xC',  // V12_H
  (unsigned char)'\xD',  // V13
  (unsigned char)'\xD',  // V13_H
  (unsigned char)'\xE',  // V14
  (unsigned char)'\xE',  // V14_H
  (unsigned char)'\xF',  // V15
  (unsigned char)'\xF',  // V15_H
  (unsigned char)'\x20' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone(Compile* C) const {
  return  new (C) labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone(Compile* C) const {
  return  new (C) methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegINoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *iRegLNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *iRegPNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_PTR_REG_mask();
}

const RegMask *iRegP_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegP_R1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R1_REG_mask();
}

const RegMask *iRegP_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegP_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegP_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R4_REG_mask();
}

const RegMask *iRegP_R5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R5_REG_mask();
}

const RegMask *iRegP_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *iRegL_R11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R11_REG_mask();
}

const RegMask *iRegP_FPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_REG_mask();
}

const RegMask *iRegI_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R0_REG_mask();
}

const RegMask *iRegI_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R2_REG_mask();
}

const RegMask *iRegI_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R4_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegNNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegIHeapbaseOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &HEAPBASE_REG_mask();
}

const RegMask *vRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *vRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *inline_cache_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *interpreter_method_oop_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *thread_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &THREAD_REG_mask();
}

const RegMask *lr_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LR_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indIndexScaledOffsetIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOffsetI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indOffIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indirectNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledOffsetINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOffsetI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledOffsetI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indOffINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *thread_anchor_pcOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *iRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

//------------------Define members for classes derived from MachNode----------

// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode( MachNode* node, Compile* C) const {
  // This architecture does not have cisc or short branch instructions
  ShouldNotCallThis();
}

void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaDirectHandleNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP1Node::reloc() const {
  return 1;
}

int loadConPollPageNode::reloc() const {
  return 1;
}

int loadByteMapBaseNode::reloc() const {
  return 1;
}

int loadConF_packedNode::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_packedNode::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeimmCM0Node::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 3;
}

int storeimmB0Node::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 3;
}

int storeimmC0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeimmI0Node::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeimmL0Node::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeimmP0Node::reloc() const {
  return 3;
}

int storeLastJavaPC_no_retaddrNode::reloc() const {
  return 1;
}

int storeLastJavaPC_with_retaddrNode::reloc() const {
  return 1;
}

int storeNNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int prefetchrNode::reloc() const {
  return 1;
}

int prefetchwNode::reloc() const {
  return 1;
}

int prefetchntaNode::reloc() const {
  return 1;
}

int bytes_reverse_intNode::reloc() const {
  return 1;
}

int bytes_reverse_unsigned_shortNode::reloc() const {
  return 1;
}

int bytes_reverse_shortNode::reloc() const {
  return 1;
}

int countLeadingZerosINode::reloc() const {
  return 1;
}

int countTrailingZerosINode::reloc() const {
  return 1;
}

int loadPLockedNode::reloc() const {
  return 1;
}

int storePConditionalNode::reloc() const {
  return 1;
}

int storeLConditionalNode::reloc() const {
  return 1;
}

int storeIConditionalNode::reloc() const {
  return 1;
}

int compareAndSwapINode::reloc() const {
  return 1;
}

int compareAndSwapLNode::reloc() const {
  return 1;
}

int compareAndSwapPNode::reloc() const {
  return 1;
}

int compareAndSwapNNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int cmovI_reg_regNode::reloc() const {
  return 2;
}

int cmovUI_reg_regNode::reloc() const {
  return 2;
}

int cmovI_zero_regNode::reloc() const {
  return 1;
}

int cmovUI_zero_regNode::reloc() const {
  return 1;
}

int cmovI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUI_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_zero_regNode::reloc() const {
  return 1;
}

int cmovUP_zero_regNode::reloc() const {
  return 1;
}

int addI_reg_regNode::reloc() const {
  return 2;
}

int addI_reg_immNode::reloc() const {
  return 1;
}

int addP_reg_reg_extNode::reloc() const {
  return 1;
}

int addP_reg_reg_ext_shiftNode::reloc() const {
  return 1;
}

int lshift_extNode::reloc() const {
  return 1;
}

int subI_reg_regNode::reloc() const {
  return 2;
}

int subI_reg_immNode::reloc() const {
  return 1;
}

int negI_regNode::reloc() const {
  return 1;
}

int negL_regNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 2;
}

int smulINode::reloc() const {
  return 2;
}

int smulI_0Node::reloc() const {
  return 2;
}

int maddINode::reloc() const {
  return 3;
}

int maddI_0Node::reloc() const {
  return 3;
}

int msubINode::reloc() const {
  return 3;
}

int divINode::reloc() const {
  return 2;
}

int signExtractNode::reloc() const {
  return 1;
}

int div2RoundNode::reloc() const {
  return 2;
}

int div2Round_0Node::reloc() const {
  return 2;
}

int modINode::reloc() const {
  return 2;
}

int lShiftI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_immNode::reloc() const {
  return 1;
}

int urShiftI_reg_regNode::reloc() const {
  return 2;
}

int urShiftI_reg_immNode::reloc() const {
  return 1;
}

int rShiftI_reg_regNode::reloc() const {
  return 2;
}

int rShiftI_reg_immNode::reloc() const {
  return 1;
}

int lShiftL_reg_regNode::reloc() const {
  return 1;
}

int urShiftL_reg_regNode::reloc() const {
  return 1;
}

int rShiftL_reg_regNode::reloc() const {
  return 1;
}

int regI_not_regNode::reloc() const {
  return 1;
}

int AndI_reg_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_not_reg_2Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_1Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_not_reg_2Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_not_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_not_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AndI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AndI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_URShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_RShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int XorI_reg_LShift_regNode::reloc() const {
  return 2;
}

int XorI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_URShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_RShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int OrI_reg_LShift_regNode::reloc() const {
  return 2;
}

int OrI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_URShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_URShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_RShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_RShift_reg_0Node::reloc() const {
  return 2;
}

int AddI_reg_LShift_regNode::reloc() const {
  return 2;
}

int AddI_reg_LShift_reg_0Node::reloc() const {
  return 2;
}

int SubI_reg_URShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_RShift_regNode::reloc() const {
  return 2;
}

int SubI_reg_LShift_regNode::reloc() const {
  return 2;
}

int sbfmwINode::reloc() const {
  return 1;
}

int ubfmwINode::reloc() const {
  return 1;
}

int ubfxwINode::reloc() const {
  return 1;
}

int ubfxIConvI2LNode::reloc() const {
  return 1;
}

int extrOrINode::reloc() const {
  return 2;
}

int extrOrI_0Node::reloc() const {
  return 2;
}

int extrAddINode::reloc() const {
  return 2;
}

int extrAddI_0Node::reloc() const {
  return 2;
}

int AddExtINode::reloc() const {
  return 1;
}

int AddExtI_0Node::reloc() const {
  return 1;
}

int SubExtINode::reloc() const {
  return 1;
}

int AddExtI_sxthNode::reloc() const {
  return 2;
}

int AddExtI_sxth_0Node::reloc() const {
  return 2;
}

int AddExtI_sxtbNode::reloc() const {
  return 2;
}

int AddExtI_sxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtbNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_0Node::reloc() const {
  return 2;
}

int AddExtI_uxtb_andNode::reloc() const {
  return 2;
}

int AddExtI_uxtb_and_0Node::reloc() const {
  return 2;
}

int AddExtI_uxth_andNode::reloc() const {
  return 2;
}

int AddExtI_uxth_and_0Node::reloc() const {
  return 2;
}

int SubExtI_uxtb_andNode::reloc() const {
  return 2;
}

int SubExtI_uxth_andNode::reloc() const {
  return 2;
}

int andI_reg_regNode::reloc() const {
  return 2;
}

int andI_reg_immNode::reloc() const {
  return 1;
}

int orI_reg_regNode::reloc() const {
  return 2;
}

int orI_reg_immNode::reloc() const {
  return 1;
}

int xorI_reg_regNode::reloc() const {
  return 2;
}

int xorI_reg_immNode::reloc() const {
  return 1;
}

int convI2L_reg_regNode::reloc() const {
  return 1;
}

int convUI2L_reg_regNode::reloc() const {
  return 1;
}

int convI2BNode::reloc() const {
  return 1;
}

int convI2F_reg_regNode::reloc() const {
  return 1;
}

int convI2D_reg_regNode::reloc() const {
  return 1;
}

int testP_regNode::reloc() const {
  return 1;
}

int compF_reg_zeroNode::reloc() const {
  return 1;
}

int compD_reg_zeroNode::reloc() const {
  return 1;
}

int compF3_reg_immF0Node::reloc() const {
  return 1;
}

int compD3_reg_immD0Node::reloc() const {
  return 1;
}

int cmpLTMask_reg_regNode::reloc() const {
  return 2;
}

int cmpLTMask_reg_zeroNode::reloc() const {
  return 1;
}

int cmpI_imm0_branchNode::reloc() const {
  return 1;
}

int cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int safePointNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectHandleNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int TailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int partialSubtypeCheckVsZeroNode::reloc() const {
  return 1;
}


void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1910 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsbw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7272 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1916 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7289 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1928 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7306 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1928 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7323 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1934 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrshw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7340 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1940 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7357 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1952 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7374 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1952 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7391 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7408 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1970 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7425 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7443 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1976 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7460 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7477 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1976 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7494 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7511 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1976 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7528 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7545 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1982 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrs, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7562 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1988 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrd, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7579 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2524 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    u_int32_t con = (u_int32_t)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (con == 0) {
      __ movw(dst_reg, zr);
    } else {
      __ movw(dst_reg, con);
    }
  
#line 7601 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2535 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    u_int64_t con = (u_int64_t)opnd_array(1)->constantL();
    if (con == 0) {
      __ mov(dst_reg, zr);
    } else {
      __ mov(dst_reg, con);
    }
  
#line 7623 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2546 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL || con == (address)1) {
      ShouldNotReachHere();
    } else {
      // !!! FIXME AARCH64
      // when and why do we get a non oop value here?
      if (opnd_array(1)->constant_is_oop()) {
        __ movoop(dst_reg, (jobject)con);
      } else {
        __ movptr(dst_reg, (uintptr_t)con);
      }
    }
  
#line 7651 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2563 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 7668 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConP1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2569 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, (u_int64_t)1);
  
#line 7685 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConPollPageNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2575 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address page = (address)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    unsigned long off;
    __ adrp(dst_reg, Address(page, relocInfo::poll_type), off);
    assert(off == 0, "assumed offset == 0");
  
#line 7705 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadByteMapBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2584 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address page = (address)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    unsigned long off;
    __ adrp(dst_reg, ExternalAddress(page), off);
    assert((off & 0x3ffL) == 0, "assumed offset aligned to 0x400");
    // n.b. intra-page offset will never change even if this gets
    // relocated so it is safe to omit the lea when off == 0
    if (off != 0) {
      __ lea(dst_reg, Address(dst_reg, off));
    }
  
#line 7730 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2598 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      assert(opnd_array(1)->constant_is_oop(), "unexpected constant type");
      __ set_narrow_oop(dst_reg, (jobject)con);
    }
  
#line 7753 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2610 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 7770 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConF_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5591 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), (double)opnd_array(1)->constantF());
  
#line 7786 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5609 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 7802 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 5610 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 7811 "../generated/adfiles/ad_aarch64.cpp"
  }
}
void loadConD_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5622 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constantD());
  
#line 7826 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5639 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 7842 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 5640 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 7851 "../generated/adfiles/ad_aarch64.cpp"
  }
}
void storeimmCM0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2000 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7868 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1994 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strb, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7886 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmB0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2000 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7904 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2006 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strh, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7922 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmC0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2012 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strh, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7940 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2018 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7958 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2024 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7976 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2030 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8002 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2044 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8020 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2030 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8046 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2044 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8064 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLastJavaPC_no_retaddrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dummy_m1
  {

#line 2112 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Compile* C = ra_->C;
    int nargs = C->tf()->domain()->cnt() - TypeFunc::Parms;
    if ((0x0 /*primary()*/)) { nargs++; }
    assert(nargs <= 8, "opto runtime stub has more than 8 args!");
    MacroAssembler _masm(&cbuf);
    address pc = __ pc();
    int call_offset = (nargs + 11) * 4;
    int field_offset = in_bytes(JavaThread::frame_anchor_offset()) +
                       in_bytes(JavaFrameAnchor::last_Java_pc_offset());
    __ lea(rscratch1, InternalAddress(pc + call_offset));
    __ str(rscratch1, Address(rthread, field_offset));
  
#line 8090 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLastJavaPC_with_retaddrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dummy_m2
  {

#line 2112 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Compile* C = ra_->C;
    int nargs = C->tf()->domain()->cnt() - TypeFunc::Parms;
    if ((0x1 /*primary()*/)) { nargs++; }
    assert(nargs <= 8, "opto runtime stub has more than 8 args!");
    MacroAssembler _masm(&cbuf);
    address pc = __ pc();
    int call_offset = (nargs + 11) * 4;
    int field_offset = in_bytes(JavaThread::frame_anchor_offset()) +
                       in_bytes(JavaFrameAnchor::last_Java_pc_offset());
    __ lea(rscratch1, InternalAddress(pc + call_offset));
    __ str(rscratch1, Address(rthread, field_offset));
  
#line 8116 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2018 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8134 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeImmN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2018 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(R27_enc);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8152 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2050 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strs, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8170 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2056 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strd, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8188 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2415 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PLDL1KEEP);
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PLDL1KEEP);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PLDL1KEEP);
      }
    }
  
#line 8218 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2434 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1KEEP);
      __ nop();
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1KEEP);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1KEEP);
      }
    }
  
#line 8249 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchntaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2454 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1STRM);
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1STRM);
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1STRM);
      }
    }
  
#line 8279 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5938 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ revw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8295 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5951 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8311 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8327 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5978 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), 0U, 15U);
  
#line 8344 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5994 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8360 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6006 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8376 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6019 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rbitw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 8393 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6033 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rbit(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 8410 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6051 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::Membar_mask_bits(Assembler::LoadLoad|Assembler::LoadStore));
  
#line 8426 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6064 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

  __ membar(Assembler::AnyAny);
  
#line 8442 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6076 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::AnyAny);
  
#line 8458 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint unnecessary_membar_volatileNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6098 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 8487 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6110 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ block_comment("membar-acquire-lock");
    __ membar(Assembler::Membar_mask_bits(Assembler::LoadLoad|Assembler::LoadStore));
  
#line 8504 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6123 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ block_comment("MEMBAR-release-lock");
    __ membar(Assembler::AnyAny);
  
#line 8521 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6140 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 8539 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6155 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 8557 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convP2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6170 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 8573 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convN2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6186 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 8589 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6201 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ encode_heap_oop(d, s);
  
#line 8607 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6214 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 8623 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6226 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop(d, s);
  
#line 8641 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6240 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop_not_null(d, s);
  
#line 8659 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2267 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch1, Address(base, disp));
        __ ldaxr(dst_reg, rscratch1);
      } else {
        // TODO
        // should we ever get anything other than this case?
        __ ldaxr(dst_reg, base);
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch1, Address(base, index_reg, Address::lsl(scale)));
        __ ldaxr(dst_reg, rscratch1);
      } else {
        __ lea(rscratch1, Address(base, disp));
        __ lea(rscratch1, Address(rscratch1, index_reg, Address::lsl(scale)));
	__ ldaxr(dst_reg, rscratch1);
      }
    }
  
#line 8738 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// heap_top_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2296 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register src_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        __ stlxr(rscratch1, src_reg, rscratch2);
      } else {
        // TODO
        // should we ever get anything other than this case?
        __ stlxr(rscratch1, src_reg, base);
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        __ stlxr(rscratch1, src_reg, rscratch2);
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
	__ stlxr(rscratch1, src_reg, rscratch2);
      }
    }
    __ cmpw(rscratch1, zr);
  
#line 8781 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2326 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldaxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
    __ membar(__ AnyAny);
  
#line 8834 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2366 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldaxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
    __ membar(__ AnyAny);
  
#line 8887 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2366 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldaxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
    __ membar(__ AnyAny);
  
#line 8940 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2407 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 8950 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2326 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldaxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
    __ membar(__ AnyAny);
  
#line 9003 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2407 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9013 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2326 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldaxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
    __ membar(__ AnyAny);
  
#line 9066 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2407 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9076 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2366 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldaxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
    __ membar(__ AnyAny);
  
#line 9129 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2407 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9139 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6454 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9156 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6463 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9173 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6472 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9190 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6481 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9207 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6492 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9224 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6503 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9241 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6513 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9258 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6524 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9275 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6534 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9292 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6545 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9309 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addIiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6555 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9326 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6566 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9343 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6591 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9365 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6607 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9387 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6632 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9409 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6648 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9431 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6664 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9453 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6680 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9475 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6701 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     zr,
	     zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9500 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6720 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     zr,
	     zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9525 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6739 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9547 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6755 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9569 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6773 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9591 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6789 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9613 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6805 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9635 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6821 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9657 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6837 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9679 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6853 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9701 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6871 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9723 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6887 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9745 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6903 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9767 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6919 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9789 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6935 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9811 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6951 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9833 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6969 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9855 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 6985 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9877 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7001 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9899 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7017 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9921 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7034 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 9944 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7052 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 9967 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7070 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 9990 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7088 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 10013 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7117 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10032 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2618 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 10058 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_imm_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2618 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 10084 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7161 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10103 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7176 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
  
#line 10122 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_lslNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7191 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
		   Address::lsl(opnd_array(3)->constant())));
  
#line 10142 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_ext_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7206 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
		   Address::sxtw(opnd_array(3)->constant())));
  
#line 10162 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lshift_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7221 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sbfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
          opnd_array(2)->constant()& 63, MIN(32, (-opnd_array(2)->constant()) & 63));
  
#line 10181 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2632 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 10207 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7255 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10226 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2632 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 10252 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7286 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10271 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2618 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 10297 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7318 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10316 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2632 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 10342 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7350 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 10360 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7366 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 10378 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7382 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10397 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void smulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7397 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10416 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void smulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7397 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
	     as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 10435 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7414 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mul(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10454 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7430 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10473 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7447 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10494 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 7447 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 10515 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void msubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7463 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ msubw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10536 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7481 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10557 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 7481 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 10578 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void msubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7497 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ msub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10599 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2646 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 10619 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void signExtractNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7523 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 31);
  
#line 10637 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7534 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 31);
  
#line 10658 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2Round_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7534 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 31);
  
#line 10679 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2654 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 10699 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void signExtractLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7559 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 63);
  
#line 10717 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7570 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 63);
  
#line 10738 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7570 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 63);
  
#line 10759 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void modINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2662 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 10779 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void modLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2670 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 10799 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7614 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10818 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7630 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 10837 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7646 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10856 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7662 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 10875 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7678 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10894 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7694 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 10913 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7715 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10932 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7731 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x3f);
  
#line 10951 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7747 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10970 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7763 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 10989 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7779 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 11008 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7795 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11027 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7811 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 11046 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void regL_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7829 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 11066 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void regI_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7845 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 11086 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7862 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11107 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7862 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11128 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7879 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11149 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7879 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11170 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7896 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11191 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7896 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11212 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7913 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11233 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7913 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11254 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7930 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11275 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7930 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11296 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7947 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11317 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 7947 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11338 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 7964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11361 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7964 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11384 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 7982 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11407 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7982 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11430 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8000 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11453 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8000 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11476 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8018 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11499 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8018 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11522 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8036 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 11545 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8036 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 11568 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8054 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 11591 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8054 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 11614 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8072 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11637 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8072 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11660 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8072 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 11683 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8072 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11706 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8090 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11729 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8090 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11752 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8090 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 11775 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8090 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11798 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8108 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11821 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8108 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11844 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8108 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 11867 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8108 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11890 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8126 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11913 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8126 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11936 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8126 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 11959 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8126 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11982 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8144 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12005 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8144 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12028 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8144 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 12051 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8144 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12074 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8162 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12097 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8162 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12120 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8162 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 12143 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8162 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12166 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8180 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12189 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8180 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12212 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8198 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12235 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8198 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12258 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8216 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12281 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8216 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12304 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8234 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12327 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8234 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12350 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8252 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12373 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8252 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12396 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8270 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12419 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8270 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12442 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8289 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12464 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8289 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12486 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8308 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12508 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8308 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12530 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8327 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12552 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8327 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12574 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8346 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12596 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8346 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12618 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8365 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12640 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8365 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12662 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8384 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12684 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8384 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12706 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8403 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12728 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8403 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12750 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8422 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12772 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8422 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12794 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8441 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12816 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8441 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12838 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8460 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12860 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8460 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12882 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8479 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12904 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8479 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12926 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8498 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12948 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8498 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12970 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8517 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12992 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8517 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13014 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8536 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13036 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8536 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13058 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8555 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13080 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8555 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13102 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8574 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13124 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8574 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13146 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8593 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13168 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8593 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13190 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8612 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13212 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8612 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13234 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8631 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13256 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8631 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13278 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8650 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13300 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8650 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13322 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8669 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13344 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8669 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13366 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8688 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13388 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8688 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13410 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8707 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13432 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8707 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13454 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8726 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13476 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8726 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13498 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8745 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13520 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8764 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13542 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8783 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13564 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8802 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13586 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8821 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13608 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8840 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13630 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sbfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 8864 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ sbfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13653 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sbfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 8887 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13676 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 8910 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ ubfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13699 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 8933 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ ubfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13722 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 8952 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfxw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 13744 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 8967 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constantL();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 13766 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 8985 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 13788 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9005 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 13808 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9005 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 13828 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9020 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 13848 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9020 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 13868 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9035 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 13888 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9035 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 13908 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9050 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 13928 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9050 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 13948 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rolL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9066 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    rscratch1);
    
#line 13967 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rolI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9082 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    rscratch1);
    
#line 13986 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rorL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9134 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    
#line 14004 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rorI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9149 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    
#line 14022 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9200 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 14040 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9200 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 14058 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9213 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 14076 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9227 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 14096 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9227 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 14116 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9240 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 14136 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9240 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 14156 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9253 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14176 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9253 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14196 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9266 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 14216 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9266 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 14236 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9279 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 14256 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9279 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 14276 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9292 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 14296 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9292 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 14316 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9305 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14336 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9305 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14356 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9319 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14375 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9319 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14394 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9332 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14413 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9332 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 14432 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9345 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14451 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9345 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14470 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9358 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14489 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9358 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 14508 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9371 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 14527 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9371 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw);
   
#line 14546 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9384 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14565 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9397 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14584 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9410 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14603 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9423 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14622 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9436 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 14641 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9455 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14660 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9470 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ faddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14679 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9485 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14698 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9500 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14717 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9515 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmuls(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14736 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9530 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmuld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14755 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9678 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdivs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14774 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9693 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdivd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14793 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9708 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fnegs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14810 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9722 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fnegd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14827 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9735 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fabss(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14844 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9748 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fabsd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14861 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9761 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsqrtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14878 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9774 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsqrts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14895 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9796 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14914 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9811 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    (unsigned long)(opnd_array(2)->constant()));
  
#line 14933 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9828 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14952 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9843 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constant()));
  
#line 14971 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9860 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14990 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9875 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constant()));
  
#line 15009 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9893 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15028 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9908 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constantL()));
  
#line 15047 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9925 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15066 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9940 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (unsigned long)(opnd_array(2)->constantL()));
  
#line 15085 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9957 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15104 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9972 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (unsigned long)(opnd_array(2)->constantL()));
  
#line 15123 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9987 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sbfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 15139 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convUI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 10000 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ubfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 15156 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10013 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15172 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10030 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cset(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::NE);
  
#line 15189 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convP2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10048 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cset(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::NE);
  
#line 15206 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10062 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15222 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10075 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15238 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10088 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzsw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15254 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10101 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzs(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15270 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10114 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfws(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15286 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10127 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15302 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10140 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzdw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15318 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10153 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15334 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10166 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfwd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15350 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10179 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15366 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10198 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrw(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15382 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10216 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15398 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10234 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldr(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15414 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10252 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15430 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10270 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strs(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15446 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10288 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15462 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10306 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15478 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10324 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ str(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15494 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10342 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15510 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10360 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 15526 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10378 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15542 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10396 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 15558 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void clearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {

#line 2473 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register cnt_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */);
    Register base_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* base */);
    // base is word aligned
    // cnt is count of words

    Label loop;
    Label entry;

//  Algorithm:
//
//    scratch1 = cnt & 7;
//    cnt -= scratch1;
//    p += scratch1;
//    switch (scratch1) {
//      do {
//        cnt -= 8;
//          p[-8] = 0;
//        case 7:
//          p[-7] = 0;
//        case 6:
//          p[-6] = 0;
//          // ...
//        case 1:
//          p[-1] = 0;
//        case 0:
//          p += 8;
//      } while (cnt);
//    }

    const int unroll = 8; // Number of str(zr) instructions we'll unroll

    __ andr(rscratch1, cnt_reg, unroll - 1);  // tmp1 = cnt % unroll
    __ sub(cnt_reg, cnt_reg, rscratch1);      // cnt -= unroll
    // base_reg always points to the end of the region we're about to zero
    __ add(base_reg, base_reg, rscratch1, Assembler::LSL, exact_log2(wordSize));
    __ adr(rscratch2, entry);
    __ sub(rscratch2, rscratch2, rscratch1, Assembler::LSL, 2);
    __ br(rscratch2);
    __ bind(loop);
    __ sub(cnt_reg, cnt_reg, unroll);
    for (int i = -unroll; i < 0; i++)
      __ str(zr, Address(base_reg, i * wordSize));
    __ bind(entry);
    __ add(base_reg, base_reg, unroll * wordSize);
    __ cbnz(cnt_reg, loop);
  
#line 15619 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2680 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 15638 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2687 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 15661 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2687 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 15684 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2698 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int32_t val = (u_int32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 15704 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2680 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 15723 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2687 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 15746 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2687 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 15769 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2698 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int32_t val = (u_int32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 15789 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2706 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 15808 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2713 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (u_int64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 15835 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2713 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (u_int64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 15862 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2728 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int64_t val = (u_int64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 15882 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2736 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 15901 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2743 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 15920 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2750 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmp(reg, zr);
  
#line 15938 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void testN_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2756 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmpw(reg, zr);
  
#line 15956 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10663 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15973 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10677 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0D);
  
#line 15990 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10691 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16007 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10705 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0D);
  
#line 16024 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10723 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16050 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10751 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16076 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF3_reg_immF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 10778 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, 0.0D);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16101 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD3_reg_immD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 10805 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, 0.0D);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16126 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10834 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 16145 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 10855 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* p */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* q */));
    __ csetw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::LT);
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 16164 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 10873 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 31);
  
#line 16181 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void minI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10896 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             Assembler::LT);
  
#line 16203 "../generated/adfiles/ad_aarch64.cpp"
  }
}

uint minI_rRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void maxI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10921 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             Assembler::GT);
  
#line 16230 "../generated/adfiles/ad_aarch64.cpp"
  }
}

uint maxI_rRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2762 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(1)->label();
    __ b(*L);
  
#line 16252 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2768 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16271 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2774 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16290 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11005 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 16314 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11024 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 16338 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11043 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 16362 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2768 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16381 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchLoopEndUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2774 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16400 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 2912 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register oop = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* object */);
    Register box = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* box */);
    Register disp_hdr = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    Register tmp = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* tmp2 */);
    Label cont;
    Label object_has_monitor;
    Label cas_failed;

    assert_different_registers(oop, box, tmp, disp_hdr);

    // Load markOop from object into displaced_header.
    __ ldr(disp_hdr, Address(oop, oopDesc::mark_offset_in_bytes()));

    // Always do locking in runtime.
    if (EmitSync & 0x01) {
      __ cmp(oop, zr);
      return;
    }
    
    if (UseBiasedLocking) {
      __ biased_locking_enter(disp_hdr, oop, box, tmp, true, cont);
    }

    // Handle existing monitor
    if (EmitSync & 0x02) {
      // we can use AArch64's bit test and branch here but
      // markoopDesc does not define a bit index just the bit value
      // so assert in case the bit pos changes
#     define __monitor_value_log2 1
      assert(markOopDesc::monitor_value == (1 << __monitor_value_log2), "incorrect bit position");
      __ tbnz(disp_hdr, __monitor_value_log2, object_has_monitor);
#     undef __monitor_value_log2
    }

    // Set displaced_header to be (markOop of object | UNLOCK_VALUE).
    __ orr(disp_hdr, disp_hdr, markOopDesc::unlocked_value);

    // Load Compare Value application register.

    // Initialize the box. (Must happen before we update the object mark!)
    __ str(disp_hdr, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // Compare object markOop with mark and if equal exchange scratch1
    // with object markOop.
    // Note that this is simply a CAS: it does not generate any
    // barriers.  These are separately generated by
    // membar_acquire_lock().
    {
      Label retry_load;
      __ bind(retry_load);
      __ ldxr(tmp, oop);
      __ cmp(tmp, disp_hdr);
      __ br(Assembler::NE, cas_failed);
      // use stlxr to ensure update is immediately visible
      __ stlxr(tmp, box, oop);
      __ cbzw(tmp, cont);
      __ b(retry_load);
    }

    // Formerly:
    // __ cmpxchgptr(/*oldv=*/disp_hdr,
    //               /*newv=*/box,
    //               /*addr=*/oop,
    //               /*tmp=*/tmp,
    //               cont,
    //               /*fail*/NULL);

    assert(oopDesc::mark_offset_in_bytes() == 0, "offset of _mark is not 0");

    // If the compare-and-exchange succeeded, then we found an unlocked
    // object, will have now locked it will continue at label cont

    __ bind(cas_failed);
    // We did not see an unlocked object so try the fast recursive case.

    // Check if the owner is self by comparing the value in the
    // markOop of object (disp_hdr) with the stack pointer.
    __ mov(rscratch1, sp);
    __ sub(disp_hdr, disp_hdr, rscratch1);
    __ mov(tmp, (address) (~(os::vm_page_size()-1) | markOopDesc::lock_mask_in_place));
    // If condition is true we are cont and hence we can store 0 as the
    // displaced header in the box, which indicates that it is a recursive lock.
    __ ands(tmp/*==0?*/, disp_hdr, tmp);
    __ str(tmp/*==0, perhaps*/, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ b(cont);

      __ bind(object_has_monitor);
      // The object's monitor m is unlocked iff m->owner == NULL,
      // otherwise m->owner may contain a thread or a stack address.
      //
      // Try to CAS m->owner from NULL to current thread.
      __ add(tmp, disp_hdr, (ObjectMonitor::owner_offset_in_bytes()-markOopDesc::monitor_value));
      __ mov(disp_hdr, zr);

      {
	Label retry_load, fail;
	__ bind(retry_load);
	__ ldxr(rscratch1, tmp);
	__ cmp(disp_hdr, rscratch1);
	__ br(Assembler::NE, fail);
        // use stlxr to ensure update is immediately visible
	__ stlxr(rscratch1, rthread, tmp);
	__ cbnzw(rscratch1, retry_load);
	__ bind(fail);
      }

      // Label next;
      // __ cmpxchgptr(/*oldv=*/disp_hdr,
      //               /*newv=*/rthread,
      //               /*addr=*/tmp,
      //               /*tmp=*/rscratch1,
      //               /*succeed*/next,
      //               /*fail*/NULL);
      // __ bind(next);

      // store a non-null value into the box.
      __ str(box, Address(box, BasicLock::displaced_header_offset_in_bytes()));

      // PPC port checks the following invariants
      // #ifdef ASSERT
      // bne(flag, cont);
      // We have acquired the monitor, check some invariants.
      // addw(/*monitor=*/tmp, tmp, -ObjectMonitor::owner_offset_in_bytes());
      // Invariant 1: _recursions should be 0.
      // assert(ObjectMonitor::recursions_size_in_bytes() == 8, "unexpected size");
      // assert_mem8_is_zero(ObjectMonitor::recursions_offset_in_bytes(), tmp,
      //                        "monitor->_recursions should be 0", -1);
      // Invariant 2: OwnerIsThread shouldn't be 0.
      // assert(ObjectMonitor::OwnerIsThread_size_in_bytes() == 4, "unexpected size");
      //assert_mem4_isnot_zero(ObjectMonitor::OwnerIsThread_offset_in_bytes(), tmp,
      //                           "monitor->OwnerIsThread shouldn't be 0", -1);
      // #endif
    }

    __ bind(cont);
    // flag == EQ indicates success
    // flag == NE indicates failure

  
#line 16559 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 3060 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register oop = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* object */);
    Register box = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* box */);
    Register disp_hdr = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    Register tmp = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* tmp2 */);
    Label cont;
    Label object_has_monitor;
    Label cas_failed;

    assert_different_registers(oop, box, tmp, disp_hdr);

    // Always do locking in runtime.
    if (EmitSync & 0x01) {
      __ cmp(oop, zr); // Oop can't be 0 here => always false.
      return;
    }

    if (UseBiasedLocking) {
      __ biased_locking_exit(oop, tmp, cont);
    }

    // Find the lock address and load the displaced header from the stack.
    __ ldr(disp_hdr, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // If the displaced header is 0, we have a recursive unlock.
    __ cmp(disp_hdr, zr);
    __ br(Assembler::EQ, cont);


    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ ldr(tmp, Address(oop, oopDesc::mark_offset_in_bytes()));
      __ tbnz(disp_hdr, exact_log2(markOopDesc::monitor_value), object_has_monitor);
    }

    // Check if it is still a light weight lock, this is is true if we
    // see the stack address of the basicLock in the markOop of the
    // object.

      {
	Label retry_load;
	__ bind(retry_load);
	__ ldxr(tmp, oop);
	__ cmp(box, tmp);
	__ br(Assembler::NE, cas_failed);
        // use stlxr to ensure update is immediately visible
	__ stlxr(tmp, disp_hdr, oop);
	__ cbzw(tmp, cont);
	__ b(retry_load);
      }

    // __ cmpxchgptr(/*compare_value=*/box,
    //               /*exchange_value=*/disp_hdr,
    //               /*where=*/oop,
    //               /*result=*/tmp,
    //               cont,
    //               /*cas_failed*/NULL);
    assert(oopDesc::mark_offset_in_bytes() == 0, "offset of _mark is not 0");

    __ bind(cas_failed);

    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ b(cont);

      __ bind(object_has_monitor);
      __ add(tmp, tmp, -markOopDesc::monitor_value); // monitor
      __ ldr(rscratch1, Address(tmp, ObjectMonitor::owner_offset_in_bytes()));
      __ ldr(disp_hdr, Address(tmp, ObjectMonitor::recursions_offset_in_bytes()));
      __ eor(rscratch1, rscratch1, rthread); // Will be 0 if we are the owner.
      __ orr(rscratch1, rscratch1, disp_hdr); // Will be 0 if there are 0 recursions
      __ cmp(rscratch1, zr);
      __ br(Assembler::NE, cont);

      __ ldr(rscratch1, Address(tmp, ObjectMonitor::EntryList_offset_in_bytes()));
      __ ldr(disp_hdr, Address(tmp, ObjectMonitor::cxq_offset_in_bytes()));
      __ orr(rscratch1, rscratch1, disp_hdr); // Will be 0 if both are 0.
      __ cmp(rscratch1, zr);
      __ br(Assembler::NE, cont);
      // need a release store here
      __ lea(tmp, Address(tmp, ObjectMonitor::owner_offset_in_bytes()));
      __ stlr(rscratch1, tmp);
    }

    __ bind(cont);
    // flag == EQ indicates success
    // flag == NE indicates failure
  
#line 16663 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void safePointNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11141 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ read_polling_page(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* poll */), relocInfo::poll_type);
  
#line 16679 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2798 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    address mark = __ pc();
    address addr = (address)opnd_array(1)->method();
    if (!_method) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      __ bl(Address(addr, relocInfo::runtime_call_type));
    } else if (_optimized_virtual) {
      __ bl(Address(addr, relocInfo::opt_virtual_call_type));
    } else {
      __ bl(Address(addr, relocInfo::static_call_type));
    }

    if (_method) {
      // Emit stub for static call
      emit_java_to_interp(cbuf, mark);
    }
  
#line 16710 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2857 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 16722 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectHandleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// reg_mh_save
  {

#line 2818 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // TODO fixme
    // this is supposed to preserve and restore SP around the call
    // need to check it works
    __ mov(rfp, sp);

    address mark = __ pc();
    address addr = (address)opnd_array(1)->method();
    if (!_method) {
      // TODO check this
      // think we are calling generated Java here not x86
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      __ bl(Address(addr, relocInfo::runtime_call_type));
    } else if (_optimized_virtual) {
      __ bl(Address(addr, relocInfo::opt_virtual_call_type));
    } else {
      __ bl(Address(addr, relocInfo::static_call_type));
    }

    if (_method) {
      // Emit stub for static call
      emit_java_to_interp(cbuf, mark);
    }

    // now restore sp
    __ mov(sp, rfp);
  
#line 16763 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2857 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 16775 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2848 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address entry = (address)opnd_array(1)->method();
    RelocationHolder rh = virtual_call_Relocation::spec(__ pc());
    // we use movoop here as per emit_java_to_interp and c1's ic_call
    __ movoop(rscratch2, (jobject)Universe::non_oop_word(), /*immediate*/true);
    __ bl(Address(entry, rh));
  
#line 16795 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2857 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 16807 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2865 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      __ lea(rscratch1, RuntimeAddress(entry));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
    }
  
#line 16839 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2865 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      __ lea(rscratch1, RuntimeAddress(entry));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
    }
  
#line 16871 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2865 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      __ lea(rscratch1, RuntimeAddress(entry));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
    }
  
#line 16903 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2896 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    __ br(target_reg);
  
#line 16921 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void TailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2902 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    // exception oop should be in r0
    // ret addr has been popped into lr
    // callee expects it in r3
    __ mov(r3, lr);
    __ br(target_reg);
  
#line 16943 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2886 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ b(RuntimeAddress(OptoRuntime::rethrow_stub()));
  
#line 16972 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2891 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ ret(lr);
  
#line 16988 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11341 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO
    // implement proper trap call here
    __ brk(999);
  
#line 17006 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 2781 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(opnd_array(0)->reg(ra_,this)/* result */);

     Label miss;
     MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x1 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 17035 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void partialSubtypeCheckVsZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 2781 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(R5_enc);

     Label miss;
     MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x0 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 17065 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_compareNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    MacroAssembler _masm(&cbuf);

#line 11395 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc));
  
#line 17086 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_indexofNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 11411 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 17113 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_indexof_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 11430 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 17141 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 11448 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
		      opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc));
  
#line 17161 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void array_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  {
    MacroAssembler _masm(&cbuf);

#line 11463 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ char_arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                          opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc));
  
#line 17179 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLastJavaPC_no_retaddrNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLastJavaPC_with_retaddrNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchntaNode::memory_operand() const { return _opnds[1]; }
const TypePtr *membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_releaseNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_releaseNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_storestoreNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_storestoreNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_lockNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resNode::memory_operand() const { return _opnds[1]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // RegFlags
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    false,  // AbsI
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // CProj
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastII
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // CosD
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    true ,  // EncodeP
    false,  // ExpD
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // Goto
    true ,  // Halt
    true ,  // If
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // LogD
    false,  // Log10D
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachProj
    true ,  // MaxI
    true ,  // MemBarAcquire
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // Opaque1
    false,  // Opaque2
    true ,  // OrI
    true ,  // OrL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // Phi
    false,  // PopCountI
    false,  // PopCountL
    false,  // PowD
    true ,  // PrefetchAllocation
    true ,  // PrefetchRead
    true ,  // PrefetchWrite
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    false,  // RoundDouble
    false,  // RoundFloat
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SCMemProj
    false,  // SinD
    true ,  // SqrtD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StrComp
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // TanD
    true ,  // ThreadLocal
    false,  // Unlock
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    false,  // AddVB
    false,  // AddVS
    false,  // AddVI
    false,  // AddVL
    false,  // AddVF
    false,  // AddVD
    false,  // SubVB
    false,  // SubVS
    false,  // SubVI
    false,  // SubVL
    false,  // SubVF
    false,  // SubVD
    false,  // MulVS
    false,  // MulVI
    false,  // MulVF
    false,  // MulVD
    false,  // DivVF
    false,  // DivVD
    false,  // LShiftCntV
    false,  // RShiftCntV
    false,  // LShiftVB
    false,  // LShiftVS
    false,  // LShiftVI
    false,  // LShiftVL
    false,  // RShiftVB
    false,  // RShiftVS
    false,  // RShiftVI
    false,  // RShiftVL
    false,  // URShiftVB
    false,  // URShiftVS
    false,  // URShiftVI
    false,  // URShiftVL
    false,  // AndV
    false,  // OrV
    false,  // XorV
    false,  // LoadVector
    false,  // StoreVector
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    false,  // ReplicateB
    false,  // ReplicateS
    false,  // ReplicateI
    false,  // ReplicateL
    false,  // ReplicateF
    false,  // ReplicateD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false   // ExtractD
};


bool Matcher::stack_direction() const { return false; }

int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              round_to((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::in_preserve_stack_slots() { return 4; }

uint Compile::out_preserve_stack_slots() { return SharedRuntime::out_preserve_stack_slots(); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes/BytesPerInt; }

void Matcher::calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length, bool is_outgoing) {

#line 3270 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // No difference between ingoing/outgoing just pass false
    SharedRuntime::java_calling_convention(sig_bt, regs, length, false);
  
#line 17599 "../generated/adfiles/ad_aarch64.cpp"

}

void Matcher::c_calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length) {

#line 3276 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // This is obviously always outgoing
    (void) SharedRuntime::c_calling_convention(sig_bt, regs, NULL, length);
  
#line 17610 "../generated/adfiles/ad_aarch64.cpp"

}

OptoRegPair Matcher::return_value(int ideal_reg, bool is_outgoing) {

#line 3283 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };
  
    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                       // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 17646 "../generated/adfiles/ad_aarch64.cpp"

}

OptoRegPair Matcher::c_return_value(int ideal_reg, bool is_outgoing) {

#line 3283 "/builddir/build/BUILD/java-1.7.0-openjdk-1.7.0.85-2.6.1.2.el7.aarch64/openjdk/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };
  
    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                       // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 17682 "../generated/adfiles/ad_aarch64.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(R12_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_method_oop_reg() { return OptoReg::Name(R12_num); }

int Matcher::interpreter_method_oop_reg_encode() { return _regEncode[interpreter_method_oop_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(R29_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(R31_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
